<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html dir="ltr" xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>
	<title>{$title}&nbsp;{$config.suffix}</title>
	<meta http-equiv="Content-Type" content="text/html;charset={$config.charset}" />
	<meta name="generator" content="eSyndiCat Web Directory Software {$smarty.const.ESYN_VERSION}" />
	<base href="{$smarty.const.ESYN_URL}" />
	<link rel="shortcut icon" href="{$smarty.const.ESYN_URL}favicon.ico" />

	{include_file css="style" base="templates/TMPL/css/"}
	{if isset($css)}
		{include_file css=$css}
	{/if}

	{if isset($category) && $category.id >= 0 && isset($listings)}
		<link rel="alternate" type="application/rss+xml" title="{$category.title|escape:"html"}" href="{$smarty.const.ESYN_URL}feed.php?from=category&amp;id={$category.id}" />
	{/if}
	
	{if isset($view) && $view neq 'random' && isset($listings)}
		<link rel="alternate" type="application/rss+xml" title="{$category.title|escape:"html"}" href="{$smarty.const.ESYN_URL}feed.php?from={$view}" />
	{/if}

	<meta name="description" content="{if isset($description) && !empty($description)}{$description|escape:"html"}{/if}" />
	<meta name="keywords" content="{if isset($keywords) && !empty($keywords)}{$keywords|escape:"html"}{/if}" />

	{assign var="lang_file" value="tmp/cache/intelli.lang."|cat:$config.lang}
	{include_file js="js/jquery/jquery, js/utils/sessvars, js/intelli/intelli, tmp/cache/intelli.config, $lang_file"}
	{if isset($js)}
		{include_file js=$js}
	{/if}
	
	{if $manageMode}
		{include_file js="js/jquery/plugins/jquery.interface, js/jquery/plugins/jquery.dimensions"}
		<style type="text/css">
		{literal}
			div.groupWrapper
			{
				background-color:lightgreen;
				border:1px dotted whitesmoke;
			}
			.dropActive
			{
				padding:5px;
			}
			.dropHover
			{
				background: lightgreen;
				padding:0;
			}

		{/literal}
		</style>
	{/if}
	{esynHooker name="headSection"}
	<!--[if lt IE 7]>
	<script defer type="text/javascript" src="{$smarty.const.ESYN_URL}js/pngfix.js"></script>
	<![endif]-->

	<script type="text/javascript">
	{if isset($phpVariables)}{$phpVariables}{/if}
	intelli.lang = intelli.lang['{$config.lang}'];
	</script>

</head>

<body>

<!-- main page start -->
<div class="page" style="{if isset($smarty.cookies.cookiePageWidth)} width: {$smarty.cookies.cookiePageWidth};{/if} {if isset($smarty.cookies.cookieLetterSize)}font-size: {$smarty.cookies.cookieLetterSize};{/if}">

	<!-- inventory line start -->
	<div class="inventory">

		{if $config.language_switch}
		<!-- language switch start -->
		<div class="lang-switch">
			<form name="language_form" action="">
			{$lang.language}:
			<select name="language" onchange="document.language_form.submit();">
				{foreach from=$languages key=code item=language name=select_lang}
					<option value="{$code}" {if $code eq $config.lang}selected="selected"{/if}>{$language}</option>
				{/foreach}
			</select>
			</form>
		</div>
		<!-- language switch end -->
		{/if}

		<!-- inventory menu start -->
		<ul class="inv">
		{foreach from=$menus.inventory item=menu}
			{if $menu.name eq $smarty.const.ESYN_REALM}
				<li class="active">{$menu.title}</li>
			{else}
				<li><a href="{$menu.url}" {if $menu.nofollow eq '1'}rel="nofollow"{/if}>{$menu.title}</a></li>
			{/if}
		{/foreach}
		{if $config.accounts}
			<li class="login">
			{if isset($esynAccountInfo)}
				<a href="{$smarty.const.ESYN_URL}logout.php?action=logout">{$lang.logout}&nbsp;[{$esynAccountInfo.username}]</a>
			{else}
				{if $smarty.const.ESYN_REALM eq 'account_login'}
					{$lang.login}
				{else}
					<a href="{$smarty.const.ESYN_URL}login.php">{$lang.login}</a>
				{/if}
			{/if}
			</li>
		{/if}
		{if isset($listings) && isset($view)}
			<div class="xml-button">
			{if isset($category.id)}
				<a href="{$smarty.const.ESYN_URL}feed.php?from=category&amp;id={$category.id}">{print_img fl="xml.gif" full=true alt=$lang.xml_syndication}</a>
			{/if}
			{if in_array($view, array('popular','new','top'))}
				<a href="{$smarty.const.ESYN_URL}feed.php?from={$view}">{print_img fl="xml.gif" full=true alt=$lang.xml_syndication}</a>
			{/if}
			</div>
		{/if}
		</ul>
		<!-- inventory menu end -->

	</div>
	<!-- invenotory line end -->

	<div class="header">

	<table cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td>
			<!-- logo start -->
			<div class="logo">
				<a href="{$smarty.const.ESYN_URL}">
					{if $config.site_logo neq ''}
						{print_img ups=true fl=$config.site_logo full="true" title=$config.site alt=$config.site}
					{else}
						{print_img fl="logo.png" full=true title=$config.site alt=$config.site}
					{/if}
				</a>
			</div>
			<!-- logo end -->
		</td>
		<td>
			<div class="slogan">{$lang.slogan}</div>
		</td>
		<td align="right">
			<!-- search form start -->
			<div class="search-form">
				<form action="{$smarty.const.ESYN_URL}search.php" method="get" id="searchForm">
					<table cellpadding="0" cellspacing="0">
						<tr>
							<td style="padding-right: 5px;">
								<input type="text" class="what" name="what" size="28" id="search_input" autocomplete="off" />
								<div id="quickSearch" class="quickSearch"></div>
							</td>
							<td style="text-align: right;"><input type="submit" name="search_top" id="searchTop" value="{$lang.search}" class="button" /></td>
						</tr>
					</table>
				</form>
			</div>
			<!-- search form end -->
		</td>
	</tr>
	</table>

	</div>

	<!-- menu start -->
	<div class="top-menu">
		<ul class="menu">
		{foreach from=$menus.main item=menu}
			{if $menu.name eq $smarty.const.ESYN_REALM}
				<li class="active"><div>{$menu.title}</div></li>
			{else}
				<li><a href="{$menu.url}" {if $menu.nofollow eq '1'}rel="nofollow"{/if}>{$menu.title}</a></li>
			{/if}
		{/foreach}	
		</ul>
	</div>
	<!-- menu end -->

<div class="content">

<table cellpadding="0" cellspacing="0" width="100%" class="main">
<tr>
{if isset($leftBlocks) && !empty($leftBlocks)}
	<td valign="top" class="left-column">
		<div id="leftBlocks" class="groupWrapper">
			{include file="parse-blocks.tpl" pos=$leftBlocks|default:null}
		</div>
	</td>
{/if}
<td class="center-column" valign="top">

	{if isset($breadcrumb)}
		{$breadcrumb}
	{/if}

	{esynHooker name="afterBreadcrumb"}

	{esynHooker name="beforeMainContent"}

	<div id="topBlocks" class="groupWrapper">
		{include file="parse-blocks.tpl" pos=$topBlocks|default:null}
	</div>
