{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}accounts`;
CREATE TABLE `{install:prefix}accounts` (
  `id` int(8) NOT NULL auto_increment,
  `username` varchar(30) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `email` varchar(50) NOT NULL default '',
  `nemail` varchar(50) NOT NULL default '',
  `sec_key` varchar(32) NOT NULL default '',
  `status` enum('approval', 'active', 'banned', 'unconfirmed') NOT NULL default 'active',
  `date_reg` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `status` (`status`)
) {install:mysql_version};

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}action_show`;
CREATE TABLE `{install:prefix}action_show` (
	`id` INT NOT NULL AUTO_INCREMENT,
	`page` VARCHAR( 100 ) NOT NULL ,
	`action_name` VARCHAR(255) NOT NULL default '',
	PRIMARY KEY (`id`)
) {install:mysql_version};

INSERT INTO `{install:prefix}action_show` (`id`, `page`, `action_name`) VALUES
(1, 'view_listing', 'action_favorite'),
(2, 'view_listing', 'report_listing'),
(3, 'view_listing', 'visit_website');
{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}actions`;
CREATE TABLE `{install:prefix}actions` (
	`id` INT NOT NULL AUTO_INCREMENT,
	`name` VARCHAR( 255 ) NOT NULL ,
	`url` varchar(255) NOT NULL default '',
	`plugin` varchar(50) NOT NULL default '',
	`order` FLOAT NOT NULL,
	PRIMARY KEY (`id`)
) {install:mysql_version};

INSERT INTO `{install:prefix}actions` (`id`, `name`, `url`, `order`) VALUES
(1, 'action_favorite', '', 1),
(2, 'report_listing', '', 2),
(3, 'visit_website', '', 3);
{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}admins`;
CREATE TABLE `{install:prefix}admins` (
  `id` tinyint(3) unsigned NOT NULL auto_increment,
  `username` varchar(50) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `fullname` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `submit_notif` enum('0','1') NOT NULL default '0',
  `super` enum('0','1') NOT NULL default '1',
  `status` enum('inactive','active') NOT NULL default 'active',
  `confirmation` varchar(32) NOT NULL default '',
  `date_reg` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_visited` datetime NOT NULL default '0000-00-00 00:00:00',
  `state` text NOT NULL,
  PRIMARY KEY  (`id`)
) {install:mysql_version};

INSERT INTO `{install:prefix}admins` (`id`, `username`, `password`, `fullname`, `email`, `submit_notif`, `super`, `status`, `confirmation`, `date_reg`, `last_visited`) VALUES
(1, '{install:admin_username}', '{install:admin_password}', 'Administrator', '{install:email}', '1', '1', 'active', '', NOW(), NOW());
{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}admin_blocks`;
CREATE TABLE `{install:prefix}admin_blocks` (
  `name` varchar(100) NOT NULL DEFAULT '',
  `plugin` varchar(50) NOT NULL DEFAULT '',
  `title` text NOT NULL,
  `order` float NOT NULL DEFAULT '0'
) {install:mysql_version};

INSERT INTO `{install:prefix}admin_blocks` (`name`, `plugin`, `title`, `order`) VALUES('common', '', 'Common', 1);
INSERT INTO `{install:prefix}admin_blocks` (`name`, `plugin`, `title`, `order`) VALUES('categories', '', 'Categories', 2);
INSERT INTO `{install:prefix}admin_blocks` (`name`, `plugin`, `title`, `order`) VALUES('listings', '', 'Listings', 3);
INSERT INTO `{install:prefix}admin_blocks` (`name`, `plugin`, `title`, `order`) VALUES('plugins', '', 'Plugins', 4);

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}admin_pages`;
CREATE TABLE `{install:prefix}admin_pages` (
  `id` int(11) NOT NULL auto_increment,
  `block_name` varchar(100) NOT NULL default '',
  `title` varchar(50) NOT NULL default '',
  `file` varchar(255) NOT NULL default '',
  `attr` varchar(100) NOT NULL default '',
  `params` varchar(255) NOT NULL default '',
  `aco` varchar(30) NOT NULL default '',
  `menus` set('main','header') default NULL,
  `plugin` varchar(50) NOT NULL default '',
  `order` float NOT NULL default '0',
  `header_order` float NOT NULL default '0',
  PRIMARY KEY  (`id`)
) {install:mysql_version};

INSERT INTO `{install:prefix}admin_pages` (`id`, `block_name`, `title`, `file`, `attr`, `params`, `aco`, `menus`, `plugin`, `order`, `header_order`) VALUES
(NULL, 'common', 'Admin Panel', 'index', '', '', 'index', 'main', '', 1, 0),
(NULL, 'common', 'Configuration', 'configuration', '', '', 'configuration', 'main', '', 2, 0),
(NULL, 'common', 'Manage Database', 'database', '', '', 'database', 'main', '', 3, 0),
(NULL, 'common', 'Language Manager', 'language', '', '', 'language', 'main', '', 4, 0),
(NULL, 'common', 'Manage Admins', 'admins', '', '', 'admins', 'main', '', 5, 0),
(NULL, 'common', 'Manage Accounts', 'accounts', '', '', 'accounts', 'main', '', 6, 0),
(NULL, 'common', 'Manage Templates', 'templates', '', '', 'templates', 'main', '', 7, '0'),
(NULL, 'common', 'Manage Blocks', 'blocks', '', '', 'blocks', 'main', '', 8, 0),
(NULL, 'common', 'Visual Manage', 'visual', 'target="_blank"', '', 'visual', 'main', '', 9, 0),
(NULL, 'categories', 'Manage Categories', 'categories', '', '', 'categories', 'main', '', 1, 0),
(NULL, 'categories', 'Create Category', 'suggest-category', '', '', 'create_category', 'main,header', '', 2, 4),
(NULL, 'categories', 'Browse Categories', 'browse', '', '', 'browse', 'main,header', '', 3, 5),
(NULL, 'categories', 'Category Icons', 'category-icons', '', '', 'category_icons', 'main', '', 4, 0),
(NULL, 'listings', 'Create Listing', 'suggest-listing', '', '', 'create_listing', 'main,header', '', 1, 1),
(NULL, 'listings', 'Manage Listings', 'listings', '', '', 'listings', 'main,header', '', 2, 2),
(NULL, 'listings', 'Manage Comments', '', '', '', 'comments', 'main', 'comments', 3, 9),
(NULL, '', 'divider', '', '', '', '', 'header', '', 3, 3),
(NULL, '', 'Update Version', 'update', '', '', '', NULL, '', 0, 0),
(NULL, '', 'Sitemap', 'sitemap', '', '', 'sitemap', 'header', '', 0, 7),
(NULL, '', 'PHP Info', 'index&amp;info', '', '', 'phpinfo', 'header', '', 0, 8),
(NULL, '', 'divider', '', '', '', '', 'header', '', '0', '5'),
(NULL, '', 'Order Change', 'order-change', '', '', 'order_change', '', '', 0, 0);


{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}admin_permissions`;
CREATE TABLE `{install:prefix}admin_permissions` (
  `id` int(11) NOT NULL auto_increment,
  `admin_id` int(11) NOT NULL default '0',
  `aco` varchar(30) NOT NULL default '',
  `allow` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) {install:mysql_version};

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}block_show`;
CREATE TABLE `{install:prefix}block_show` (
  `id` int(11) NOT NULL auto_increment,
  `page` varchar(100) NOT NULL default '0',
  `block_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `page` (`page`,`block_id`)
) {install:mysql_version};

INSERT INTO `{install:prefix}block_show` (`id`, `page`, `block_id`) VALUES
(NULL, 'index', 3),
(NULL, 'view_listing', 5),
(NULL, 'view_listing', 7);

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}blocks`;
CREATE TABLE `{install:prefix}blocks` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(100) NOT NULL default '',
  `contents` text NOT NULL,
  `order` smallint(5) unsigned NOT NULL default '0',
  `lang` varchar(2) NOT NULL default '',
  `position` varchar(50) NOT NULL default 'left',
  `type` enum('plain','smarty','php','html') NOT NULL default 'plain',
  `plugin` varchar(50) NOT NULL default '',
  `status` enum('active','inactive') NOT NULL default 'active',
  `show_header` tinyint(1) NOT NULL default '0',
  `collapsible` tinyint(1) NOT NULL default '0',
  `collapsed` tinyint(1) NOT NULL default '0',
  `sticky` tinyint(1) NOT NULL default '0',
  `multi_language` tinyint(1) NOT NULL,
  `rss` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `status` (`status`)
) {install:mysql_version};

INSERT INTO `{install:prefix}blocks` (`id`, `title`, `contents`, `order`, `lang`, `position`, `type`, `plugin`, `status`, `show_header`, `sticky`, `multi_language`, `collapsible`, `rss`) VALUES
(1, 'Featured', '{if isset($featured_listings)}\r\n	{foreach from=$featured_listings item=featured_listing}\r\n		<div class="featured-listing">\r\n			<a href="{print_listing_url listing=$featured_listing}" class="countable listings title" id="lnk_{$featured_listing.id}_fea" {if $config.new_window}target="_blank"{/if}>{$featured_listing.title}</a>\r\n		</div>\r\n	{/foreach}\r\n{/if}', 2, 'en', 'left', 'smarty', '', 'active', 1, 1, 1, 1, 0),
(2, 'Partner', '{if isset($partner_listings)}\r\n	{foreach from=$partner_listings item=partner_listing}\r\n		<div class="partner-listing">\r\n			<a href="{print_listing_url listing=$partner_listing}" class="countable listings title" id="lnk_{$partner_listing.id}_par" {if $config.new_window}target="_blank"{/if}>{$partner_listing.title}</a>\r\n		</div>\r\n	{/foreach}\r\n{/if}', 1, 'en', 'top', 'smarty', '', 'active', 1, 1, 1, 1, 0),
(3, 'Statistics', '<table cellpadding="2" cellspacing="2">\r\n	{if isset($num_listings)}\r\n	<tr>\r\n		<td>{$lang.total_num_listings}</td>\r\n		<td>{$num_listings|string_format:"%d"}</td>\r\n	</tr>\r\n	{/if}\r\n	{if isset($num_categories)}\r\n		<tr>\r\n			<td>{$lang.total_num_categories}</td>\r\n			<td>{$num_categories|string_format:"%d"}</td>\r\n		</tr>\r\n	{/if}\r\n	{esynHooker name="statisticsBlock"}\r\n</table>', 4, 'en', 'right', 'smarty', '', 'active', 1, 0, 1, 0, 0),
(4, 'Accounts area', '{if $config.accounts}\r\n	<!-- accounts box start -->\r\n	{if $esynAccountInfo}\r\n		{$lang.welcome}, <strong>{$esynAccountInfo.username}</strong>!\r\n		<ul class="account-menu">\r\n			{foreach from=$menus.account item=menu}\r\n				{if $menu.name eq $smarty.const.ESYN_REALM}\r\n					<li class="active">\r\n						<div>{$menu.title}</div>\r\n					</li>\r\n				{else}\r\n					<li>\r\n						<a href="{$menu.url}"{if isset($menu.no_follow)}{$menu.no_follow}{/if}>{$menu.title}</a>\r\n					</li>\r\n				{/if}\r\n			{/foreach}\r\n\r\n			<li>\r\n				<a href="logout.php?action=logout">{$lang.logout}</a>\r\n			</li>\r\n		</ul>\r\n	{else}\r\n		<form action="{$smarty.const.ESYN_URL}login.php" method="post">\r\n			<table class="no" cellpadding="2" cellspacing="0">\r\n			<tr>\r\n				<td>{$lang.username}:<br />\r\n					<input type="text" tabindex="1" class="text" name="username" size="18" value="" />\r\n				</td>\r\n			</tr>\r\n			<tr>\r\n				<td>{$lang.password}:<br />\r\n					<input type="password" tabindex="2" class="text" name="password" size="18" value="" />\r\n				</td>\r\n			</tr>\r\n			<tr>\r\n				<td colspan="2" style="font-size: 10px;">\r\n					<input type="submit" class="button" tabindex="6" name="login" value="{$lang.login}" />\r\n					<a href="{$smarty.const.ESYN_URL}forgot.php">{$lang.forgot}</a>\r\n					<a href="{$smarty.const.ESYN_URL}register.php" rel="nofollow">{$lang.register}</a>\r\n				</td>\r\n			</tr>\r\n			</table>\r\n		</form>\r\n	{/if}\r\n	<!-- accounts box end -->\r\n{/if}', 1, 'en', 'right', 'smarty', '', 'active', 1, 1, 1, 1, 0),
(5, 'Actions', '{if isset($esyndicat_actions) && !empty($esyndicat_actions)}{foreach from=$esyndicat_actions item=action}\r\n	{assign var="action_key" value="esyndicat_action_"|cat:$action.name}\r\n\r\n	{if $action.name eq ''action_favorite''}\r\n		{if $esynAccountInfo}\r\n			{if $esynAccountInfo.id neq $listing.account_id}\r\n				{assign var="fav_array" value='',''|explode:$listing.fav_accounts_set}\r\n				{if !empty($fav_array) && in_array($esynAccountInfo.id, $fav_array)}\r\n					<a href="{if $action.url eq ''''}#{else}{$action.url}{/if}" class="esynactions_remove-favorite_{$listing.id}_{$esynAccountInfo.id}">{$lang.remove_from_favorites}</a><br />\r\n				{else}\r\n					<a href="{if $action.url eq ''''}#{else}{$action.url}{/if}" class="esynactions_add-favorite_{$listing.id}_{$esynAccountInfo.id}">{$lang.add_to_favorites}</a><br />\r\n				{/if}\r\n			{/if}					\r\n		{/if}\r\n	{else}\r\n		<a href="{if $action.url eq ''''}#{else}{$action.url}{/if}" class="esynactions_{$action.name|replace:"_":"-"}_{$listing.id}_{$listing.url}">{$lang.$action_key}</a><br />\r\n	{/if}\r\n{/foreach}{/if}', 4, 'en', 'right', 'smarty', '', 'active', 1, 1, 1, 0, 0),
(6, 'Latest Comments', '{if isset($latest_comments)}\n	{foreach from=$latest_comments item=comment name=latest_comments}\n		<div class="posted">\n			{print_img full=true fl="user.png" alt=$lang.comment_author}<strong>{$comment.author|escape:"html"}</strong> /  {print_img full=true fl="calendar.png" alt=$lang.calendar} {$comment.date|date_format:$config.date_format}\n		</div>\n		{if $config.html_comments}\n			<div class="comment">{$comment.body|truncate:100}<br /></div>\n		{else}\n			<div class="comment">{$comment.body|escape:"html"|truncate:100}<br /></div>\n		{/if}\n		<div style="float:right;"><a href="{print_listing_url listing=$comment.listing details=true}">{$lang.view_listing}</a></div>\n		<div style="clear:both;"></div>\n		{if !$smarty.foreach.latest_comments.last}<hr />{/if}\n	{/foreach}\n{/if}', 5, 'en', 'right', 'smarty', 'comments', 'active', 1, 1, 1, 0, 0),
(7, 'Comments', '{include file=$smarty.const.ESYN_PLUGINS|cat:"comments/templates/comments.tpl"}', 5, 'en', 'bottom', 'smarty', 'comments', 'active', 1, 0, 1, 0, 0);

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}categories`;
CREATE TABLE `{install:prefix}categories` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `account_id` int(8) NOT NULL default '0',
  `parent_id` int(8) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `page_title` varchar(255) NOT NULL default '',
  `icon` varchar(255) NOT NULL default '',
  `description` text,
  `status` enum('approval','active') NOT NULL default 'approval',
  `meta_description` tinytext,
  `meta_keywords` tinytext,
  `path` varchar(250) NOT NULL default '',
  `order` smallint(10) NOT NULL default '0',
  `locked` enum('0','1') NOT NULL default '0',
  `hidden` enum('0','1') NOT NULL default '0',
  `unique_tpl` enum('0','1') NOT NULL default '0',
  `level` smallint(6) NOT NULL default '1',
  `num_cols` tinyint(4) NOT NULL default '0',
  `num_neighbours` tinyint(4) NOT NULL default '0',
  `num_listings` int(8) NOT NULL default '0',
  `num_all_listings` int(8) NOT NULL default '0',
  `clicks` INT NOT NULL default '0',
  `no_follow` tinyint(1) NOT NULL default '0',
  `confirmation` enum('0','1') NOT NULL default '0',
  `confirmation_text` text,
  PRIMARY KEY  (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `status` (`status`),
  KEY `path` (`path`),
  KEY `order` (`order`)
) {install:mysql_version} PACK_KEYS=0;


INSERT INTO `{install:prefix}categories` (`id`, `account_id`, `parent_id`, `title`, `description`, `status`, `meta_description`, `meta_keywords`, `path`, `order`, `locked`, `unique_tpl`, `level`, `num_cols`, `num_neighbours`, `num_listings`, `num_all_listings`, `no_follow`) VALUES
(0, 0, -1, 'ROOT', '', 'active', '', '', '', 0, '0', '0', 0, 0, 0, 3, 3, 0);

INSERT INTO `{install:prefix}categories` (`id`, `parent_id`, `title`, `description`, `status`, `path`, `level`, `num_listings`, `num_all_listings`) VALUES
(2, 0, 'Sports', 'Sports Directory', 'active', 'sports', 0, 0, 0),
(3, 0, 'Shopping', 'Shopping Directory', 'active', 'shopping', 0, 0, 0),
(4, 0, 'Society', 'Society Directory', 'active', 'society', 0, 0, 0),
(5, 0, 'Misc', 'Miscellaneous and Everything Else Directory', 'active', 'misc', 0, 0, 0),
(6, 0, 'Science', 'Science Directory', 'active', 'science', 0, 0, 0),
(7, 0, 'Reference', 'Reference Directory', 'active', 'reference', 0, 0, 0),
(8, 0, 'Regional', 'Regional Directory', 'active', 'regional', 0, 0, 0),
(9, 0, 'News', 'News Directory', 'active', 'news', 0, 0, 0),
(10, 0, 'Home', 'Home Directory', 'active', 'home', 0, 0, 0),
(11, 0, 'Kids and Teens', 'Kids and Teen Directory', 'active', 'kids-and-teens', 0, 0, 0),
(12, 0, 'Games', 'Games Directory', 'active', 'games', 0, 0, 0),
(13, 0, 'Health', 'Health Directory', 'active', 'health', 0, 0, 0),
(14, 0, 'Computers', 'Computers Directory', 'active', 'computers', 0, 2, 2),
(15, 0, 'Arts', 'Arts Directory', 'active', 'arts', 0, 0, 0),
(16, 0, 'Business', 'Business Directory', 'active', 'business', 0, 0, 0);

UPDATE `{install:prefix}categories` SET `id` = '0' WHERE `parent_id` = '-1';

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}category_clicks`;
CREATE TABLE `{install:prefix}category_clicks` (
  `id` int(11) NOT NULL auto_increment,
  `category_id` int(11) NOT NULL default '0',
  `ip` varchar(15) NOT NULL default '',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `category_id` (`category_id`)
) {install:mysql_version};

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}comments`;
CREATE TABLE `{install:prefix}comments` (
	`id` int(8) NOT NULL auto_increment,
	`listing_id` int(8) NOT NULL default '0',
	`account_id` int(8) NOT NULL default '0',
	`author` varchar(100) NOT NULL default '',
	`url` varchar(100) NOT NULL default '',
	`body` text NOT NULL,
	`email` varchar(100) NOT NULL default '',
	`ip_address` varchar(15) NOT NULL default '',
	`rating` varchar(50) NOT NULL default '',
	`date` datetime NOT NULL default '0000-00-00 00:00:00',
	`status` enum('inactive', 'active') NOT NULL default 'inactive',
	`sess_id` varchar(32) NOT NULL default '',
	PRIMARY KEY  (`id`),
	KEY `listing_id` (`listing_id`)
) {install:mysql_version};
{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}config`;
CREATE TABLE `{install:prefix}config` (
  `id` int(4) NOT NULL auto_increment,
  `group_name` varchar(50) NOT NULL DEFAULT '',
  `name` varchar(100) NOT NULL default '',
  `value` text NOT NULL,
  `multiple_values` text NOT NULL,
  `type` enum('text','textarea','checkbox','radio','select','divider','hidden','password','image') NOT NULL default 'text',
  `description` text NOT NULL,
  `plugin` varchar(50) NOT NULL DEFAULT '',
  `editor` enum('0','1') NOT NULL default '0',
  `order` float NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`),
  KEY `type` (`type`)
) {install:mysql_version};

INSERT INTO `{install:prefix}config` (`group_name`, `name`, `value`, `multiple_values`, `type`, `description`, `plugin`, `editor`, `order`) VALUES
('', 'htaccessfile_0', '# Uncomment next line if you get 404 error on accounts page\r\n# Options -MultiViews\r\n<IfModule mod_rewrite.c>\r\n# enable mod_rewrite\r\nRewriteEngine on\r\n\r\n', '', 'hidden', 'htaccess top section', '', '0', 0),
('', 'htaccessfile_1', '# SECTION 1\r\n# correct urls for yahoo bot\r\nRewriteCond %{REQUEST_URI} !\\..+$\r\nRewriteCond %{REQUEST_URI} !/$\r\nRewriteRule (.*) %{REQUEST_URI}/ [R=301,L]\r\n\r\n# mod_rewrite rules for plugins\r\nRewriteRule ^mod/(.*)/$ controller.php?plugin=$1 [QSA,L]\r\nRewriteRule ^mod/(.*)/(.*)/$ controller.php?plugin=$1&file=$2 [QSA,L]\r\nRewriteRule ^mod/(.*)/(.*).html$ controller.php?plugin=$1&file=$2 [QSA,L]\r\n\r\n# mod_rewrite rules for view account page\r\nRewriteRule ^accounts/$ accounts.php [QSA,L]\r\nRewriteRule ^accounts/(.*)/$ accounts.php?alpha=$1 [QSA,L]\r\nRewriteRule ^accounts/(.*).html$ view-account.php?account=$1 [QSA,L]\r\n\r\nRewriteRule ^sitemap.xml$ tmp/sitemap/google/sitemap.xml [QSA,L]\r\n\r\nRewriteRule ^sitemap([0-9]+).xml$ tmp/sitemap/google/sitemap$1.xml [QSA,L]\r\nRewriteRule ^sitemap_index.xml$ tmp/sitemap/google/sitemap_index.xml [QSA,L]\r\nRewriteRule ^urllist.txt$ tmp/sitemap/yahoo/urllist.txt [QSA,L]', '', 'hidden', 'htaccess section 1', '', '0', 0),
('', 'htaccessfile_2', '# SECTION 2\r\n# mod_rewrite rules for ROOT category\r\nRewriteRule ^index([0-9]+).html$ index.php?category=0&page=$1 [QSA,L]\r\n\r\n', '', 'hidden', 'htaccess section 2', '', '0', 0),
('', 'htaccessfile_3', '# SECTION 3\r\n# mod_rewrite rules for categories pages with HTML path option disable\r\nRewriteRule ^(.*)/$ index.php?category=$1 [QSA,L]\r\nRewriteRule ^(.*)/index([0-9]+).html$ index.php?category=$1&page=$2 [QSA,L]\r\n\r\n', '', 'hidden', 'htaccess section 3', '', '0', 0),
('', 'htaccessfile_4', '# SECTION 4\r\n# mod_rewrite rule for suggest listing page\r\nRewriteRule report-listing.php$ report-listing.php [QSA,L]\r\n\r\n', '', 'hidden', 'htaccess section 4', '', '0', 0),
('', 'htaccessfile_5', '# SECTION 5\r\nRewriteRule ^([a-z]+)-listings.html$ listings.php?view=$1 [QSA,L]\r\nRewriteRule ^([a-z]+)-listings([0-9]+).html$ listings.php?view=$1&page=$2 [QSA,L]\r\n\r\n', '', 'hidden', 'htaccess section 5', '', '0', 0),
('', 'htaccessfile_6', '# SECTION 6\r\n# mod_rewrite rules for view listing page\r\nRewriteRule ^([^/]+)-l([0-9]+).html$ view-listing.php?cat=&title=$1&id=$2 [QSA,L]\r\nRewriteRule ^(.*)/([^/]+)-l([0-9]+).html$ view-listing.php?cat=$1&title=$2&id=$3 [QSA,L]\r\n\r\n', '', 'hidden', 'htaccess section 6', '', '0', 0),
('', 'htaccessfile_7', '# SECTION 7\r\n# mod_rewrite rules for additional pages\r\nRewriteRule ^p/(.*).html$ page.php?name=$1 [QSA,L]\r\n\r\n', '', 'hidden', 'htaccess section 7', '', '0', 0),
('', 'htaccessfile_8', '# SECTION 8\r\n# mod_rewrite rules for error pages\r\nRewriteRule ^([0-9]+).htm$ error.php?error=$1 [QSA,L]\r\n\r\n', '', 'hidden', 'htaccess section 8', '', '0', 0),
('', 'htaccessfile_9', '# SECTION 9\r\n# mod_rewrite rules for suggest category page\r\nRewriteRule ^suggest-category-([0-9]+).html$ suggest-category.php?id=$1 [QSA,L]\r\n\r\n', '', 'hidden', 'htaccess section 9', '', '0', 0),
('', 'htaccessfile_10', '# SECTION 10\r\nRewriteRule ^LICENSE.htm$ LICENSE.htm [QSA,L]\r\n\r\n', '', 'hidden', 'htaccess section 10', '', '0', 0),
('', 'htaccessfile_11', '# SECTION 11\r\n# mod_rewrite rules for categories pages\r\nRewriteRule ^(.*)_([0-9]+).html$ index.php?category=$1&page=$2 [QSA,L]\r\nRewriteRule ^(.*).html?(.*)$ index.php?category=$1&$2 [QSA,L]\r\nRewriteRule ^(.*).html$ index.php?category=$1 [QSA,L]\r\n</IfModule>\r\n\r\n', '', 'hidden', 'htaccess section 11', '', '0', 0),
('', 'htaccessfile_12', '# SECTION 12\r\nErrorDocument 500 500.htm\r\nErrorDocument 404 404.htm\r\nErrorDocument 403 403.htm\r\nErrorDocument 401 401.htm', '', 'hidden', 'htaccess section 12', '', '0', 0),
('accounts', '', 'General', '1', 'divider', '', '', '0', 1),
('accounts', 'accounts', '1', '''1'',''0''', 'radio', 'Accounts', '', '0', 2),
('accounts', 'accounts_autoapproval', '0', '''1'',''0''', 'radio', 'Accounts Auto Approval', '', '0', 3),
('listings', 'accounts_registered', '1', '''1'',''0''', 'radio', 'Allow submissions for guests', '', '0', 4),
('captcha', '', 'General', '1', 'divider', '', '', '0', 1),
('captcha', 'captcha', '1', '''1'',''0''', 'radio', 'Captcha', '', '0', 2),
('captcha', 'captcha_name', 'kcaptcha', 'kcaptcha', 'hidden', 'Name of CAPTCHA', '', '0', 3),
('captcha', 'captcha_preview', '', '', 'text', 'Captcha preview', '', '0', 3.1),
('captcha', 'captcha_case_sensitive', '1', '1,0', 'radio', 'Case sensitive', '', '0', 120.1),
('captcha', 'captcha_num_chars', '5', '', 'text', 'Number of characters', '', '0', 121.1),
('categories', '', 'General', '1', 'divider', '', '', '0', 0),
('categories', 'suggest_category', '1', '''1'',''0''', 'radio', 'Allow category submission', '', '0', 1),
('categories', 'use_html_path', '0', '''1'',''0''', 'radio', 'Use .html extension in category URL', '', '0', 2),
('categories', 'related', '1', '''1'',''0''', 'radio', 'Related categories display', '', '0', 3),
('categories', 'neighbour', '1', '''1'',''0''', 'radio', 'Neighbour categories display', '', '0', 4),
('categories', 'show_children_listings', '0', '''1'',''0''', 'radio', 'Show subcategories listings in the parents', '', '0', 4.5),
('categories', 'categories_order', 'title', '''title'',''order''', 'select', 'Categories sorting', '', '0', 5),
('categories', 'num_categories_cols', '3', '', 'text', 'Number of columns', '', '0', 6),
('categories', 'num_listings_display', '1', '''1'',''0''', 'radio', 'Listings count indicator', '', '0', 7),
('categories', 'subcats_display', '3', '', 'text', 'Number of subcategories', '', '0', 8),
('categories', 'num_cats_for_search', '5', '', 'text', 'Number of categories on the search page', '', '0', 8),
('categories', 'categories_tree_type', 'tree', '''tree'',''dropdown'',''simple dropdown''', 'select', 'Category selection method', '', '0', 5.1),
('categories', 'categories_display_type', 'horizontal', '''vertical'',''horizontal''', 'select', 'Categories display type', '', '0', 4.9),
('categories', 'categories_icon_width', '32', '', 'text', 'Category icon width', '', '0', 8.1),
('categories', 'categories_icon_height', '32', '', 'text', 'Categories icon height', '', '0', 8.2),
('cronjob', '', 'Check-UP CRON', '1', 'divider', '', '', '0', 52),
('cronjob', 'cron_recip', '0', '''1'',''0''', 'radio', 'Cron for checking reciprocal listings', '', '0', 53),
('cronjob', 'cron_broken', '0', '''1'',''0''', 'radio', 'Gets listing status (checking for broken listings)', '', '0', 54),
('cronjob', 'cron_pagerank', '0', '''1'',''0''', 'radio', 'Cron for listings pagerank update', '', '0', 55),
('cronjob', 'cron_num_listings', '10', '', 'text', 'Number of listings to check in one run', '', '0', 56),
('cronjob', 'cron_check_interval', '1', '', 'text', 'Check interval (in days)', '', '0', 57),
('cronjob', '', 'CRON email reports', '1', 'divider', '', '', '0', 58),
('cronjob', 'cron_report_job', '0', '''1'',''0''', 'radio', 'CRON should send email each CronJob', '', '0', 59),
('cronjob', 'cron_report_job_extra', '0', '''1'',''0''', 'radio', 'Include list of listing URLs (each CronJob)', '', '0', 60),
('cronjob', 'cron_report_cycle', '0', '''1'',''0''', 'radio', 'CRON should send email after all listings will be checked', '', '0', 61),
('cronjob', 'cron_report_cycle_extra', '0', '''1'',''0''', 'radio', 'Include list of listing URLs (each CronCycle)', '', '0', 62),
('cronjob', '', 'Backup CRON', '1', 'divider', '', '', '0', 67),
('cronjob', 'cron_backup', '0', '''1'',''0''', 'radio', 'Backup cron functionality', '', '0', 68),
('cronjob', 'cron_backup_archive', '0', '''1'',''0''', 'radio', 'Archive Data (Zlib PHP requires)', '', '0', 69),
('cronjob', 'cron_backup_interval', '30', '', 'text', 'Make backup each [..] day(s)', '', '0', 70),
('cronjob', 'cron_backup_last_time', '', '', 'hidden', '', '', '0', 71),
('cronjob', 'cron', '1', '', 'hidden', '', '', '0', NULL),
('general', '', 'Path & URLs', '1', 'divider', '', '', '0', 1),
('general', 'version', '{config_version}', '', 'hidden', '', '', '0', 2),
('general', 'site', 'eSyndiCat Directory', '1', 'text', 'Site title', '', '0', 3),
('general', 'site_logo', '', '', 'image', 'Site Logo', '', '0', 3.1),
('general', 'site_main_content', '', '', 'textarea', 'Index page content', '', '1', 3.13),
('general', 'site_description', '', '', 'textarea', 'Index META description', '', '0', 3.2),
('general', 'site_keywords', '', '', 'text', 'Index META keywords', '', '0', 3.3),
('general', 'backup', 'backup/', '1', 'text', 'Directory for database backups', '', '0', 5),
('general', '', 'Emails', '1', 'divider', '', '', '0', 7),
('general', 'site_email', '{install:email}', '1', 'text', 'Email', '', '0', 8),
('general', 'bugs_email', '{install:email}', '1', 'text', 'Bugs email', '', '0', 9),
('general', 'tmpl', 'cleancss', '', 'hidden', 'Your skin template', '', '0', 12),
('general', 'admin_tmpl', 'default', '1', 'hidden', 'Your admin skin template', '', '0', 12.1),
('general', '', 'Regional', '1', 'divider', '', '', '0', 13),
('general', 'lang', '{install:lang}', '1', 'select', 'Script language', '', '0', 14),
('general', 'charset', 'UTF-8', '1', 'text', 'Default charset for pages', '', '0', 15),
('general', 'date_format', '%b %e, %Y', '', 'text', 'Date format', '', '0', 15),
('general', '', 'General', '1', 'divider', '', '', '0', 16),
('general', 'suffix', ':: Powered by eSyndiCat', '1', 'text', 'Suffix for page titles', '', '0', 3.05),
('general', 'title_breadcrumb', '0', '''1'',''0''', 'radio', 'Full path to category in title', '', '0', 18),
('general', 'language_switch', '0', '''1'',''0''', 'radio', 'Language switching', '', '0', 19),
('general', 'mod_rewrite', '1', '''1'',''0''', 'radio', 'Apache mod_rewrite module', '', '0', 20),
('general', 'display_frontend', '1', '''1'',''0''', 'radio', 'Display FrontEnd', '', '0', 23),
('general', 'underconstruction', 'We are sorry. Our site is under construction.', '', 'textarea', 'Under construction message', '', '0', 24),
('general', 'esyndicat_news_url', 'http://blog.intelliants.com/?view=rss', '', 'hidden', '', '', '0', 0),
('general', 'esyndicat_new_plugins_url', 'http://tools.esyndicat.com/new_plugins.php', '', 'hidden', '', '', '0', 0),
('general', 'esyndicat_block_positions', 'left,right,top,center,bottom,user1,user2,verybottom,verytop,topbanner', '', 'hidden', 'eSyndiCat Block Positions', '', '0', 0),
('general', 'ckeditor_color', '#F00', '', 'hidden', 'CKEditor color', '', '0', 0),
('general', 'esyndicat_menu_type', 'inventory,main,bottom,account', '', 'hidden', 'menu type', '', '0', 0),
('general', 'display_twitter', '1', '', 'hidden', 'eSyndiCat Twitter Block', '', '0', '0'),
('general', 'config_keys', 'recaptcha_publickey,recaptcha_privatekey,sendmail_path,smtp_secure_connection,smtp_server,smtp_user,smtp_password', '', 'hidden', '', '', '0', 0),
('general', 'default_categories_icon', 'templates/common/img/category_icons/category_icon.gif', '', 'hidden', 'Default categories icon path', '', '0', 0),
('listings', '', 'General', '1', 'divider', '', '', '0', 1),
('listings', 'allow_listings_submission', '1', '''1'',''0''', 'radio', 'Allow listing submission', '', '0', 2),
('listings', 'auto_approval', '0', '''1'',''0''', 'radio', 'Auto approval on submission', '', '0', 3),
('listings', 'new_window', '0', '''1'',''0''', 'radio', 'Open listings in a new window', '', '0', 4),
('listings', 'forward_to_listing_details', '1', '''1'',''0''', 'radio', 'Forward to listing details', '', '0', 5),
('listings', 'pagerank', '1', '''1'',''0''', 'radio', 'Google PageRank display', '', '0', 6),
('listings', 'thumbshot', '1', '''1'',''0''', 'radio', 'Display thumbshots', '', '0', 7),
('listings', 'num_index_listings', '10', '', 'text', 'Number of listings per page', '', '0', 8),
('listings', 'num_get_listings', '10', '', 'text', 'Number of listings(Top, New, Popular)', '', '0', 8.5),
('listings', 'num_featured_display', '3', '', 'text', 'Number of listings in Featured Box', '', '0', 9),
('listings', 'num_partner_display', '3', '', 'text', 'Number of listings in Partners Box', '', '0', 10),
('listings', '', 'Sorting', '1', 'divider', '', '', '0', 11),
('listings', 'visitor_sorting', '1', '''1'',''0''', 'radio', 'Allow listing ordering for visitors', '', '0', 12),
('listings', 'listings_sorting', 'alphabetic', '''alphabetic'',''date'',''clicks'',''rank''', 'select', 'Listings order by', '', '0', 13),
('listings', 'listings_sorting_type', 'ascending', '''ascending'',''descending''', 'select', 'Listings order type', '', '0', 14),
('listings', '', 'Description Field', '', 'divider', '', '', '0', 15),
('listings', 'description_num_chars', '300', '', 'text', 'Description snippet length', '', '0', 16),
('listings', 'description_min_max_length', '50,500', '', 'text', 'Description length limit', '', '0', 17),
('listings', '', 'Expiration Date', '1', 'divider', '', '', '0', 18),
('listings', 'expiration_period', '', '', 'text', 'Listing expiration period (days)', '', '0', 19),
('listings', 'expiration_action', '', '', 'text', 'Listing expiration action', '', '0', 20),
('listings', 'broken_listings_report', '1', '''1'',''0''', 'radio', 'Broken listings report', '', '0', 7.1),
('listing_checking', '', 'Broken Checking', '', 'divider', '', '', '0', 30.6),
('listing_checking', 'listing_check', '0', '''1'',''0''', 'radio', 'Checking for broken listings', '', '0', 31),
('listing_checking', 'broken_visitors', '1', '''1'',''0''', 'radio', 'Disabled in admin panel', '', '0', 31.5),
('listing_checking', 'http_headers', '301,302,200', '', 'text', 'Correct HTTP headers', '', '0', 31.55),
('listing_checking', '', 'Reciprocal Checking', '', 'divider', '', '', '0', 31.6),
('listing_checking', 'reciprocal_check', '0', '''1'',''0''', 'radio', 'Reciprocal listing checking', '', '0', 32),
('listing_checking', 'reciprocal_required_only_for_free', '0', '''1'',''0''', 'radio', 'Reciprocal required for free listings', '', '0', 32.1),
('listing_checking', 'reciprocal_domain', '1', '''1'',''0''', 'radio', 'Domain sensitive', '', '0', 32.1),
('listing_checking', 'reciprocal_text', '{install:url}', '', 'text', 'Reciprocal checking for the following URL', '', '0', 56),
('listing_checking', 'recip_featured', '0', '''1'',''0''', 'radio', 'Make featured', '', '0', 56.5),
('listing_checking', 'reciprocal_visitors', '1', '''1'',''0''', 'radio', 'Checked in admin panel', '', '0', 99.95),
('listing_checking', '', 'Duplicate Checking', '', 'divider', '', '', '0', 100),
('listing_checking', 'duplicate_checking', '0', '''1'',''0''', 'radio', 'Duplicate listing checking', '', '0', 101),
('listing_checking', 'duplicate_type', 'domain', '''exact'',''domain'',''contain''', 'select', 'Duplicate checking type', '', '0', 102),
('listing_checking', 'duplicate_visitors', '1', '''1'',''0''', 'radio', 'Disabled in admin panel', '', '0', 103),
('listing_checking', 'reciprocal_label', 'To validate the reciprocal link please include the following HTML code in the page at the URL specified above, before submitting this form:', '', 'textarea', 'Reciprocal text on the suggest listing page', '', '0', 99.96),
('listing_checking', 'reciprocal_code', '', '', 'textarea', 'Reciprocal code', '', '0', 99.97),
('mail', '', 'Mail type', '1', 'divider', '', '', '0', 1),
('mail', 'mail_function', 'php mail', '''php mail'',''sendmail'',''smtp''', 'select', 'Mail method', '', '0', 2),
('mail', 'mimetype', 'html', '''html'',''plaintext''', 'select', 'Mime-Type', '', '0', 3),
('mail', '', 'Sendmail Configuration', '', 'divider', '', '', '0', 4),
('mail', 'sendmail_path', '/usr/bin/sendmail', '', 'text', 'Path to sendmail ', '', '0', 5),
('mail', '', 'SMTP Configuration', '', 'divider', '', '', '0', 6),
('mail', 'smtp_secure_connection', '', ''''',''SSL'',''TSL''', 'select', 'Use secure connection', '', '0', 7),
('mail', 'smtp_server', '', '', 'text', 'SMTP Server', '', '0', 8),
('mail', 'smtp_port', '25', '', 'text', 'SMTP Port', '', '0', 8.1),
('mail', 'smtp_user', '', '', 'text', 'SMTP Server Username', '', '0', 9),
('mail', 'smtp_password', '', '', 'password', 'SMTP Server Password', '', '0', 10),
('email_templates', '', 'Listing Submitted', '', 'divider', '', '', '0', 0.2),
('email_templates', 'listing_submit', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 0.3),
('email_templates', 'listing_submit_subject', 'Listing was submitted to {own_site}', '', 'text', 'Subject', '', '0', 0.4),
('email_templates', 'listing_submit_body_html', '<h3>\r\n	Dear Sir/Madam,</h3>\r\n<p>\r\n	We are glad to inform you that a link to {your_site_url} has been submitted to <em><a href="{own_dir_url}">{own_site}</a></em> ({own_dir_url}). Your submission will be reviewed within 24 hours.</p>\r\n<p>\r\n	After approval and activation, your URL will be listed at:</p>\r\n<p>\r\n	<a href="{dir_listing}"><i>{dir_listing}</i></a></p>\r\n<p>\r\n	Now, please add a link to <em><a href="{own_dir_url}">{own_site}</a></em> to any of your site&#39;s pages.</p>\r\n<p>\r\n	Please use the code below:</p>\r\n<pre>\r\n<a href="{own_dir_url}">{own_site}</a></pre>\r\n<p>\r\n	OR use the following information</p>\r\n<pre>\r\nTITLE: <em>{own_site}</em>\r\nURL: <em>{own_dir_url}</em>\r\nDESCRIPTION: <em>your site description</em>\r\n</pre>\r\n<p>\r\n	All the listings in our directory are direct, so they will improve your listing popularity.</p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 0.5),
('email_templates', 'listing_submit_body_plaintext', 'Dear Sir/Madam,\r\n \r\nWe are glad to inform you that a link to {your_site_url}\r\nhas been submitted to {own_site} ({own_dir_url}).\r\nYour submission will be reviewed within 24 hours.\r\n  \r\nAfter approval and activation, your URL will be listed at: \r\n{dir_listing}\r\n  \r\nNow, please add a link to {own_dir_url} to any of your site''s pages.\r\n\r\nPlease use the code below:\r\n------------------------------------\r\n<a href="{own_dir_url}">{own_site}</a>\r\n------------------------------------\r\n\r\nOR use the following information\r\n------------------------------------\r\nTITLE: {own_site}\r\nURL: {own_dir_url}\r\nDESCRIPTION: your site description\r\n\r\nAll the listings in our directory are direct, so they will improve your listing popularity.\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 0.51),
('email_templates', '', 'Listing Approved', '', 'divider', '', '', '0', 0.6),
('email_templates', 'listing_approve', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 0.65),
('email_templates', 'listing_approve_subject', 'Listing was approved in {own_site}', '', 'text', 'Subject', '', '0', 0.68),
('email_templates', 'listing_approve_body_html', '<h3>\r\n	Dear Sir/Madam,</h3>\r\n<p>\r\n	Congratulations! Your listing {your_site_url} has been approved for <em><a href="{own_dir_url}">{own_site}</a></em>. You can view it at:</p>\r\n<p>\r\n	<em><a href="{dir_listing}">{dir_listing}</a></em></p>\r\n<p>\r\n	If you have not placed reciprocal listing to <em><a href="{own_dir_url}">{own_site}</a></em> yet, please add a listing to {own_dir_url} to any of your site&#39;s pages.</p>\r\n<p>\r\n	Please use the code below:</p>\r\n<pre>\r\n<a href="{own_dir_url}">{own_site}</a></pre>\r\n<p>\r\n	OR use the following information</p>\r\n<pre>\r\nTITLE: <em>{own_site}</em>\r\nURL: <em>{own_dir_url}</em>\r\nDESCRIPTION: <em>your site description</em>\r\n</pre>\r\n<p>\r\n	All the listings in our directory are direct, so they will improve your listing popularity.</p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 0.7),
('email_templates', 'listing_approve_body_plaintext', 'Dear Sir/Madam,\r\n  \r\nCongratulations! Your listing {your_site_url} has been approved for {own_site}.\r\nYou can view it at {dir_listing}.\r\n  \r\nIf you have not placed reciprocal listing to {own_site} yet,\r\nplease add a listing to {own_dir_url} to any of your site''s pages.\r\n\r\nPlease use the code below:\r\n------------------------------------\r\n<a href="{own_dir_url}">{own_site}</a>\r\n------------------------------------\r\n\r\nOR use the following information\r\n------------------------------------\r\nTITLE: {own_site}\r\nURL: {own_dir_url}\r\nDESCRIPTION: site description\r\n------------------------------------\r\n\r\nAll the listings in our directory are direct, so they will improve your listing popularity.\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 0.7),
('email_templates', '', 'Listing Disapproved', '', 'divider', '', '', '0', 0.71),
('email_templates', 'listing_disapprove', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 0.72),
('email_templates', 'listing_disapprove_subject', 'Listing was disapproved in {own_site}', '', 'text', 'Subject', '', '0', 0.73),
('email_templates', 'listing_disapprove_body_html', '<h3>\r\n	Dear Sir/Madam,</h3>\r\n<p>\r\n	Your listing {your_site_url} has been disapproved in<em> <a href="{own_dir_url}">{own_site}</a></em>.</p>\r\n<p>\r\n	If you have questions, please feel free to ask us.</p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 0.74),
('email_templates', 'listing_disapprove_body_plaintext', 'Dear Sir/Madam,\r\n\r\nYour listing {your_site_url} has been disapproved in {own_site} Listings Directory.\r\n\r\nIf you have questions, please feel free to ask us.\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 0.741),
('email_templates', '', 'Listing Moved', '', 'divider', '', '', '0', 56.8),
('email_templates', 'listing_move', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 56.9),
('email_templates', 'listing_move_subject', 'Listing was moved in {own_site}', '', 'text', 'Subject', '', '0', 56.95),
('email_templates', 'listing_move_body_html', '<h3>\r\n	Dear Sir/Madam,</h3>\r\n<p>\r\n	We are glad to inform you, that your listing to site {your_site_url} was moved into another category.</p>\r\n<p>\r\n	This is the new location of your listing:</p>\r\n<p>\r\n	<em><a href="{dir_listing}">{dir_listing}</a></em></p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 57),
('email_templates', 'listing_move_body_plaintext', 'Dear Sir/Madam,\r\n\r\nWe are glad to inform you, that your listing to site {your_site_url} was moved into another category. \r\nThis is the new location of your listing:\r\n\r\n{dir_listing}\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 57.1),
('email_templates', '', 'Listing Modified', '', 'divider', '', '', '0', 57.5),
('email_templates', 'listing_modify', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 57.6),
('email_templates', 'listing_modify_subject', 'Listing was modified in {own_site}', '', 'text', 'Subject', '', '0', 57.7),
('email_templates', 'listing_modify_body_html', '<h3>\r\n	Dear Sir/Madam,</h3>\r\n<p>\r\n	We are glad to inform you, that your listing to site {your_site_url} was modified.</p>\r\n<p>\r\n	These are the new attributes of your listing:</p>\r\n<p>\r\n	Title: <em>{your_site_title}</em><br />\r\n	URL: <em>{your_site_url}</em><br />\r\n	Description: <em>{your_site_desc}</em><br />\r\n	Email: <em>{your_site_email}</em><br />\r\n	Rank: <em>{your_site_rank}</em><br />\r\n	Status: <em>{your_site_status}</em></p>\r\n<p>\r\n	You can view your listing here:</p>\r\n<p>\r\n	<em><a href="{dir_listing}">{dir_listing}</a></em></p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '1', 'textarea', 'HTML Body', '', '1', 57.8),
('email_templates', 'listing_modify_body_plaintext', 'Dear Sir/Madam,\r\n\r\nWe are glad to inform you, that your listing to site {your_site_url} was modified.\r\nThese are the new attributes of your listing:\r\n\r\nTitle: {your_site_title}\r\nURL: {your_site_url}\r\nDescription: {your_site_desc}\r\nEmail: {your_site_email}\r\nRank: {your_site_rank}\r\nStatus: {your_site_status}\r\n\r\nYou can view your listing here:\r\n{dir_listing}\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '1', 'textarea', 'Email Body', '', '0', 57.81),
('email_templates', '', 'Listing Banned', '', 'divider', '', '', '0', 58),
('email_templates', 'listing_reject', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 58.5),
('email_templates', 'listing_reject_subject', 'Listing was banned in {own_site}', '', 'text', 'Subject', '', '0', 58.6),
('email_templates', 'listing_reject_body_html', '<h3>\r\n	Dear Sir/Madam,</h3>\r\n<p>\r\n	Your listing to {your_site_url} has been banned in <em><a href="{own_dir_url}">{own_site}</a></em>.</p>\r\n<p>\r\n	If you have questions, please feel free to ask us.</p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '1', 'textarea', 'HTML Body', '', '1', 59),
('email_templates', 'listing_reject_body_plaintext', 'Dear Sir/Madam,\r\n\r\nListing to {your_site_url} in our directory has been banned.\r\n\r\nIf you have questions, please feel free to ask us.\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '1', 'textarea', 'Email Body', '', '0', 59.1),
('email_templates', '', 'Listing Deleted', '', 'divider', '', '', '0', 59.9),
('email_templates', 'listing_delete', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 60),
('email_templates', 'listing_delete_subject', 'Listing was deleted from {own_site}', '', 'text', 'Subject', '', '0', 61),
('email_templates', 'listing_delete_body_html', '<h3>\r\n	Dear Sir/Madam,</h3>\r\n<p>\r\n	Your listing {your_site_url} has been deleted from</p>\r\n<p>\r\n	<em><a href="{dir_listing}">{dir_listing}</a></em></p>\r\n<p>\r\n	category, probably because you did not place reciprocal listing(s) to <em><a href="{own_dir_url}">{own_site}</a></em>. To see your listing again, please add a listing to our site and inform us.</p>\r\n<p>\r\n	<em>{reason}</em></p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '1', 'textarea', 'HTML Body', '', '1', 62),
('email_templates', 'listing_delete_body_plaintext', 'Dear Sir/Madam,\r\n\r\nYour listing {your_site_url} has been deleted from {dir_listing} category,\r\nprobably because you did not place reciprocal listing(s) to {own_site}. \r\nTo see your listing again, please add a listing to our site and inform us.\r\n\r\n{reason}\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '1', 'textarea', 'Email Body', '', '0', 62.1),
('email_templates', '', 'Listing Added', '', 'divider', '', '', '0', 62.5),
('email_templates', 'listing_admin_add', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 63),
('email_templates', 'listing_admin_add_subject', 'Listing was added to {own_site}', '', 'text', 'Subject', '', '0', 64),
('email_templates', 'listing_admin_add_body_html', '<h3>\r\n	Dear Sir/Madam,</h3>\r\n<p>\r\n	We are glad to inform you that a listing to {your_site_url} has been added to <em><a href="{own_dir_url}">{own_site}</a></em> ({own_dir_url}).</p>\r\n<p>\r\n	These are the attributes of your listing:<br />\r\n	Title: <em>{your_site_title}</em><br />\r\n	URL: <em>{your_site_url}</em><br />\r\n	Description:<em> {your_site_desc}</em><br />\r\n	Email: <em>{your_site_email}</em><br />\r\n	Rank:<em> {your_site_rank}</em></p>\r\n<p>\r\n	You can view your listing here:</p>\r\n<p>\r\n	<em><a href="{dir_listing}">{dir_listing}</a></em></p>\r\n<p>\r\n	Now, please add a listing to {own_site} to any of your site&#39;s pages.</p>\r\n<p>\r\n	Please use the code below:<br />\r\n	------------------------------------<br />\r\n	<a href="{own_dir_url}">{own_site}</a><br />\r\n	------------------------------------</p>\r\n<p>\r\n	OR use the following information<br />\r\n	------------------------------------<br />\r\n	TITLE: <em>{own_site}</em><br />\r\n	URL: <em>{own_dir_url}</em><br />\r\n	DESCRIPTION: <em>your site description</em></p>\r\n<p>\r\n	All the listings in our directory are direct, so they will improve your listing popularity.</p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'Email that is sent when admin adds listing', '', '1', 65),
('email_templates', 'listing_admin_add_body_plaintext', 'Dear Sir/Madam,\r\n \r\nWe are glad to inform you that a listing to {your_site_url} has been added to {own_site} Listings Directory ({own_dir_url}).\r\n  \r\nThese are the attributes of your listing:\r\nTitle: {your_site_title}\r\nURL: {your_site_url}\r\nDescription: {your_site_desc}\r\nEmail: {your_site_email}\r\nRank: {your_site_rank}\r\nStatus: {your_site_status}\r\n\r\nYou can view your listing here {dir_listing}\r\n\r\nNow, please add a listing to {own_site} to any of your site''s pages.\r\n\r\nPlease use the code below:\r\n------------------------------------\r\n<a href="{own_dir_url}">{own_site}</a>\r\n------------------------------------\r\n\r\nOR use the following information\r\n------------------------------------\r\nTITLE: {own_site}\r\nURL: {own_dir_url}\r\nDESCRIPTION: your site description\r\n\r\nAll the listings in our directory are direct, so they will improve your listing popularity.\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 65.1),
('email_templates', '', 'Account Registration', '', 'divider', '', '', '0', 66.5),
('email_templates', 'register_account', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 66.6),
('email_templates', 'register_account_subject', 'Thanks for registration at {own_site}', '', 'text', 'Subject: ', '', '0', 67),
('email_templates', 'register_account_body_html', '<h3>\r\n	Dear Sir/Madam,</h3>\r\n<p>\r\n	Thanks for your registration at <em><a href="{own_dir_url}">{own_site}</a></em>. Here is information you should use in order to login:</p>\r\n<p>\r\n	Your username: <strong>{account_username}</strong><br />\r\n	Your password: <strong>{account_pwd}</strong><br />\r\n	Your activation key: {key}</p>\r\n<p>\r\n	To activate your account go to<em> <a href="{own_dir_url}register.php?user={account_username_url}&amp;key={key}&amp;action=confirm">{own_dir_url}register.php?user={account_username_url}&amp;key={key}&amp;action=confirm</a></em></p>\r\n<p>\r\n	You may change your password later by editing your personal attributes in your account area.</p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 68),
('email_templates', 'register_account_body_plaintext', 'Dear Sir/Madam,\r\n\r\nThanks for your registration at {own_site}. Here is information you should use in order to login:\r\n\r\nYour username: {account_username}\r\nYour password: {account_pwd}\r\n\r\nYour activation key: {key}\r\n\r\nTo activate your account go to {own_dir_url}register.php?user={account_username_url}&key={key}&action=confirm\r\n\r\nYou may change your password later by editing your personal attributes in your account area.\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 68),
('email_templates', '', 'Account Registration Admin Notification', '', 'divider', '', '', '0', 68.01),
('email_templates', 'account_register', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 68.02),
('email_templates', 'account_register_subject', 'Account was registered to {own_site}', '', 'text', 'Subject: ', '', '0', 68.03),
('email_templates', 'account_register_body_html', '<h3>\r\n	Dear {admin_name},</h3>\r\n<p>\r\n	Account was registered to <em><a href="{own_dir_url}">{own_site}</a></em>. Please check it.</p>\r\n<p>\r\n	These are the attributes of the account:<br />\r\n	Username:<em> {account_username}</em><br />\r\n	Email:<em> {account_email}</em></p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 68.04),
('email_templates', 'account_register_body_plaintext', 'Dear {admin_name},\r\n\r\nAccount was registered to {own_site} Directory. Please check it.\r\n\r\nThese are the\r\nattributes of the account:\r\nUsername: {account_username}\r\nEmail: {account_email}\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 68.05),
('email_templates', '', 'Account Confirmed Admin Notification', '', 'divider', '', '', '0', 68.06),
('email_templates', 'account_confirmed', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 68.07),
('email_templates', 'account_confirmed_subject', 'Account was confirmed in {own_site}', '', 'text', 'Subject: ', '', '0', 68.08),
('email_templates', 'account_confirmed_body_html', '<h3>\r\n	Dear {admin_name},</h3>\r\n<p>\r\n	Account was confirmed in <em><a href="{own_dir_url}">{own_site}</a></em>. Please check it.</p>\r\n<p>\r\n	These are the attributes of the account:<br />\r\n	Username:<em> {account_username}</em><br />\r\n	Email:<em> {account_email}</em><br />\r\n	Status:<em> {account_status}</em></p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 68.09),
('email_templates', 'account_confirmed_body_plaintext', 'Dear {admin_name},\r\n\r\nAccount was confirmed in {own_site} Directory. Please check it.\r\n\r\nThese are the\r\nattributes of the account:\r\nUsername: {account_username}\r\nEmail: {account_email}\r\nStatus: {account_status}\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 68.09),
('email_templates', '', 'Admin Account Registration', '', 'divider', '', '', '0', 68.1),
('email_templates', 'register_account_admin', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 69),
('email_templates', 'register_account_admin_subject', 'Thanks for registration at {own_site}', '', 'text', 'Subject: ', '', '0', 69.1),
('email_templates', 'register_account_admin_body_plaintext', 'Dear Sir/Madam,\r\n\r\nYour website {your_site_url} has been added to {own_site}.\r\n\r\nThis is the information we have added:\r\n\r\nTitle: {your_site_title}\r\nDescription: {your_site_desc}\r\nURL: {your_site_url}\r\nEmail: {your_site_email}\r\n\r\nYou can find your listing at {dir_listing}\r\n\r\nIf you would like to update your listing information or provide more complete contact information, etc, you can login using the following information\r\n\r\nYour username: {account_username}\r\nYour password: {account_pwd}\r\n\r\nLogin page: {own_dir_url}/login.php\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 69.2),
('email_templates', 'register_account_admin_body_html', '<h3>\r\n	Dear Sir/Madam,</h3>\r\n<p>\r\n	Your website {your_site_url} has been added to {own_site}</p>\r\n<p>\r\n	This is the information we have added:</p>\r\n<p>\r\n	Title: {your_site_title}<br />\r\n	Description: {your_site_desc}<br />\r\n	URL: {your_site_url}<br />\r\n	Email: {your_site_email}</p>\r\n<p>\r\n	You can find your listing at {dir_listing}</p>\r\n<p>\r\n	If you would like to update your listing information or provide more complete contact information, etc, you can login using the following information:</p>\r\n<p>\r\n	Your username: {account_username}<br />\r\n	Your password: {account_pwd}</p>\r\n<p>\r\n	Login page: {own_dir_url}login.php</p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 69.2),
('email_templates', '', 'Submission Notification Email for Admin', '', 'divider', '', '', '0', 80),
('email_templates', 'admin_notif_subject', 'Listing was submitted to {own_site}', '', 'text', 'Email subject', '', '0', 81),
('email_templates', 'admin_notif_body_html', '<h3>\r\n	Dear {admin_name},</h3>\r\n<p>\r\n	Listing was submitted to <em><a href="{own_dir_url}">{own_site}</a></em>. Please check it.</p>\r\n<p>\r\n	These are the attributes of a listing:<br />\r\n	Title:<em> {your_site_title}</em><br />\r\n	URL: <em>{your_site_url}</em><br />\r\n	Description: <em>{your_site_desc}</em><br />\r\n	Email:<em> {your_site_email}</em></p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 82),
('email_templates', 'admin_notif_body_plaintext', 'Dear {admin_name},\r\n\r\nListing was submitted to {own_site} Directory. Please check it.\r\n\r\nThese are the attributes of a listing:\r\nTitle: {your_site_title}\r\nURL: {your_site_url}\r\nDescription: {your_site_desc}\r\nEmail: {your_site_email}\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 82.1),
('email_templates', '', 'Submission Category Notification Email for Admin', '', 'divider', '', '', '0', 82.21),
('email_templates', 'suggest_category_subject', 'Category was submitted to {own_site}', '', 'text', 'Email subject', '', '0', 82.22),
('email_templates', 'suggest_category_body_html', '<h3>\r\n	Dear {admin_name},</h3>\r\n<p>\r\n	Category was submitted to <em><a href="{own_dir_url}">{own_site}</a></em>. Please check it.</p>\r\n<p>\r\n	These are the attributes of a category:<br />\r\n	Title:<em> {cat_title}</em><br />\r\n	Category path: <em>{cat_path}</em></p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 82.23),
('email_templates', 'suggest_category_body_plaintext', 'Dear {admin_name},\r\n\r\nCategory was submitted to {own_site} Directory. Please check it.\r\n\r\nThese are the attributes of a category:\r\nTitle: {cat_title}\r\nCategory path: {cat_path}\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 82.24),
('email_templates', '', 'Account Removed', '', 'divider', '', '', '0', 85.14),
('email_templates', 'account_deleted', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 85.15),
('email_templates', 'account_deleted_subject', 'Account deleted in {own_site}', '', 'text', 'Email subject', '', '0', 85.2),
('email_templates', 'account_deleted_body_html', '<h3>\r\n	Dear {username},</h3>\r\n<p>\r\n	Your account was removed from</p>\r\n<p>\r\n	<em><a href="{own_dir_url}">{own_site}</a></em></p>\r\n<p>\r\n	Let us know if you have any questions.</p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 85.3),
('email_templates', 'account_deleted_body_plaintext', 'Dear {username},\r\n\r\nYour account was removed from {own_site}. \r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 85.4),
('email_templates', '', 'Password Change Request', '', 'divider', '', '', '0', 86.5),
('email_templates', 'password_change_subject', 'Password change request at {own_site}', '', 'text', 'Email subject', '', '0', 87),
('email_templates', 'password_change_body_html', '<h3>\r\n	Dear {username},</h3>\r\n<p>\r\n	You requested a password change in <em><a href="{own_dir_url}">{own_site}</a></em>. Now you should use the following credentials to log in as account:</p>\r\n<p>\r\n	username:<strong> {username}</strong><br />\r\n	password: <strong>{password}</strong></p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 88),
('email_templates', 'password_change_body_plaintext', 'Dear {username},\r\n\r\nYou requested a password change in {own_site}. Now you should use the following credentials to log in as account:\r\n\r\nUsername: {username}\r\nPassword: {password}\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 88.1),
('email_templates', '', 'Account Approved', '', 'divider', '', '', '0', 88.2),
('email_templates', 'account_approved', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 88.21),
('email_templates', 'account_approved_subject', 'Account was approved at {own_site}', '', 'text', 'Email subject', '', '0', 88.3),
('email_templates', 'account_approved_body_html', '<h3>\r\n	Dear {username},</h3>\r\n<p>\r\n	Your account was approved in <em><a href="{own_dir_url}">{own_site}</a></em>. Now you can log in to the directory.</p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 88.4),
('email_templates', 'account_approved_body_plaintext', 'Dear {username},\r\n\r\nYour account was approved in {own_site}. Now you can log in to the directory.\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 88.5),
('email_templates', '', 'Account Dispproved', '', 'divider', '', '', '0', 88.6),
('email_templates', 'account_disapproved', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 88.65),
('email_templates', 'account_disapproved_subject', 'Account was disapproved at {own_site}', '', 'text', 'Email subject', '', '0', 88.7),
('email_templates', 'account_disapproved_body_html', '<h3>\r\n	Dear {username},</h3>\r\n<p>\r\n	Your account was disapproved in <em><a href="{own_dir_url}">{own_site}</a></em>.</p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 88.8),
('email_templates', 'account_disapproved_body_plaintext', 'Dear {username},\r\n\r\nYour account was disapproved in {own_site}.\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 88.9),
('email_templates', '', 'Report broken link', '', 'divider', '', '', '0', 95.1),
('email_templates', 'broken_listing_report_subject', 'Broken Listing Reported at {own_site}', '', 'text', 'Subject: ', '', '0', 95.2),
('email_templates', 'broken_listing_report_body_html', '<h3>\r\n	Dear {admin_name},</h3>\r\n<p>\r\n	The following listing is reported as being broken:</p>\r\n<p>\r\n	Listing ID: {id}<br />\r\n	Listing URL: {url}<br />\r\n	Listing Title: {title}</p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 95.3),
('email_templates', 'broken_listing_report_body_plaintext', 'Dear {admin_name},\r\n\r\nThe following listing is reported as being broken:\r\n\r\nListing ID: {id}\r\nListing URL: {url}\r\nListing Title: {title}\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 95.31),
('email_templates', '', 'Account Confirm Email', '', 'divider', '', '', '0', 70),
('email_templates', 'account_confirm_email', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 70.1),
('email_templates', 'account_confirm_email_subject', 'Confirm email in {own_site}', '', 'text', 'Subject: ', '', '0', 70.2),
('email_templates', 'account_confirm_email_body_plaintext', 'Dear {username},\r\n\r\nWe have received new password request for your account ({username}) in {own_site}.\r\n\r\nIf this request was initiated by you, please click on following link to confirm your email:\r\n{own_dir_url}confirm.php?action=restore_password&account={account_id}&r={sec_key}\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 70.3),
('email_templates', 'account_confirm_email_body_html', '<h3>\r\n	Dear {username},</h3>\r\n<p>\r\n	We have received new password request for your account ({username}) in <em><a href="{own_dir_url}">{own_site}</a></em>.<br />\r\n	<br />\r\n	If this request was initiated by you, please click on following link to confirm your email:<br />\r\n	<em><a href="{own_dir_url}confirm.php?action=restore_password&amp;account={account_id}&amp;r={sec_key}">{own_dir_url}confirm.php?action=restore_password&amp;account={account_id}&amp;r={sec_key}</a></em></p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 70.4),
('email_templates', '', 'Account Confirm Change Email', '', 'divider', '', '', '0', 70.5),
('email_templates', 'account_change_email', '1', '''1'',''0''', 'radio', 'Email sending', '', '0', 70.6),
('email_templates', 'account_change_email_subject', 'Confirm change email in {own_site}', '', 'text', 'Subject: ', '', '0', 70.7),
('email_templates', 'account_change_email_body_plaintext', 'Dear {username},\r\n\r\nWe have received change email request for your account ({username}) in {own_site}.\r\n\r\nIf this request was initiated by you, please click on following link to confirm your email:\r\n{own_dir_url}confirm.php?action=change_email&account={account_id}&r={sec_key}\r\n\r\n______________________________\r\nThank you,\r\n{own_site} Administration Team\r\n{own_dir_url}\r\n{own_email}', '', 'textarea', 'Email Body', '', '0', 70.8),
('email_templates', 'account_change_email_body_html', '<h3>\r\n	Dear {username},</h3>\r\n<p>\r\n	We have received change email request for your account ({username}) in <em><a href="{own_dir_url}">{own_site}</a></em>.<br />\r\n	<br />\r\n	If this request was initiated by you, please click on following link to confirm your email:<br />\r\n	<em><a href="{own_dir_url}confirm.php?action=change_email&amp;account={account_id}&amp;r={sec_key}">{own_dir_url}confirm.php?action=change_email&amp;account={account_id}&amp;r={sec_key}</a></em></p>\r\n<p>\r\n	______________________________<br />\r\n	Thank you,<br />\r\n	{own_site} Administration Team<br />\r\n	{own_dir_url}<br />\r\n	{own_email}</p>\r\n', '', 'textarea', 'HTML Body', '', '1', 70.9),
('comments', 'div_comments', 'Comments Configuration', '', 'divider', 'Comments Configuration', 'comments', '0', 122.1),
('comments', 'allow_listing_comments_submission', '1', '1,0', 'radio', 'Allow listing comments submission', 'comments', '0', 123.1),
('comments', 'listing_comments_accounts', '1', '1,0', 'radio', 'Allows to comment for guests', 'comments', '0', 124.1),
('comments', 'html_comments', '0', '1,0', 'radio', 'Allows WYSIWYG', 'comments', '0', 125.1),
('comments', 'comments_approval', '0', '1,0', 'radio', 'Comments auto approval', 'comments', '0', 126.1),
('comments', 'comment_min_chars', '10', '', 'text', 'Min number of chars for listing comment', 'comments', '0', 127.1),
('comments', 'comment_max_chars', '300', '', 'text', 'Max number of chars for listing comment', 'comments', '0', 128.1),
('comments', 'num_latest_comments', '5', '', 'text', 'Number of latest comments in block', 'comments', '0', 129.1),
('comments', 'div_rating', 'Rating Configuration', '', 'divider', 'Rating Configuration', 'comments', '0', 130.1),
('comments', 'listing_rating', '1', '1,0', 'radio', 'Listings Rating', 'comments', '0', 131.1),
('comments', 'listing_rating_max', '10', '', 'text', 'Maximum listings rating', 'comments', '0', 132.1),
('comments', 'listing_rating_block_max', '10', '', 'text', 'Maximum listings in block rating', 'comments', '0', 133.1),
('comments', 'rate_period', '1', '', 'text', 'Rate period for IP (in days)', 'comments', '0', 134.1);

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}config_groups`;
CREATE TABLE IF NOT EXISTS `{install:prefix}config_groups` (
  `id` smallint(6) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `plugin` varchar(50) NOT NULL default '',
  `title` varchar(150) NOT NULL default '',
  `order` float NOT NULL default '0',
  PRIMARY KEY  (`id`)
) {install:mysql_version};

INSERT INTO `{install:prefix}config_groups` VALUES
(NULL, 'general', '', 'General Configuration', 1),
(NULL, 'categories', '', 'Categories Configuration', 2),
(NULL, 'listings', '', 'Listings Configuration', 3),
(NULL, 'accounts', '', 'Accounts Configuration', 4),
(NULL, 'listing_checking', '', 'Listing Checking', 7),
(NULL, 'mail', '', 'Mail Configuration', 8),
(NULL, 'email_templates', '', 'Email Templates', 9),
(NULL, 'cronjob', '', 'Cronjob Configuration', 10),
(NULL, 'captcha', '', 'Captcha Configuration', 12),
(NULL, 'miscellaneous', '', 'Miscellaneous', '13'),
(NULL, 'comments', 'comments', 'Comments', 14);

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}cron`;
CREATE TABLE `{install:prefix}cron` (
  `id` smallint(5) unsigned NOT NULL auto_increment,
  `name` varchar(20) NOT NULL default '',
  `nextrun` int(10) unsigned NOT NULL default '0',
  `data` varchar(250) NOT NULL default '',
  `active` tinyint(1) NOT NULL default '1',
  `extras` varchar(30) default NULL,
  PRIMARY KEY  (`id`)
) {install:mysql_version};

INSERT INTO `{install:prefix}cron` (`id`, `name`, `nextrun`, `data`, `active`, `extras`) VALUES
(NULL, 'check_listings', 0, '0 */3 * * * includes/cron/check.php', 1, NULL),
(NULL, 'check_expired', 0, '10 0 * * * includes/cron/check_expired.php', 1, NULL),
(NULL, 'backup', 0, '5 0 * * * includes/cron/backup.php', 1, NULL);
{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}crossed`;
CREATE TABLE `{install:prefix}crossed` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `category_id` int(8) unsigned NOT NULL default '0',
  `category_title` VARCHAR( 255 ) NOT NULL,
  `crossed_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `category_id` (`category_id`,`crossed_id`)
) {install:mysql_version};
{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}field_categories`;
CREATE TABLE `{install:prefix}field_categories` (
  `id` int(11) NOT NULL auto_increment,
  `field_id` INT( 11 ) NOT NULL DEFAULT '0',
  `category_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) {install:mysql_version};

INSERT INTO `{install:prefix}field_categories` (`id`,`field_id`, `category_id`) VALUES 
(NULL, '1', '0'),
(NULL, '2', '0'),
(NULL, '3', '0'),
(NULL, '4', '0'),
(NULL, '5', '0');

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}flat_structure`;
CREATE TABLE `{install:prefix}flat_structure` (
  `parent_id` int(8) NOT NULL default '0',
  `category_id` int(8) NOT NULL default '0',
  KEY `parent_id` (`parent_id`),
  KEY `category_id` (`category_id`)
) {install:mysql_version};


INSERT INTO `{install:prefix}flat_structure` (`parent_id`, `category_id`) VALUES
(2, 2),
(0, 2),
(3, 3),
(0, 3),
(4, 4),
(0, 4),
(5, 5),
(0, 5),
(6, 6),
(0, 6),
(7, 7),
(0, 7),
(8, 8),
(0, 8),
(9, 9),
(0, 9),
(10, 10),
(0, 10),
(11, 11),
(0, 11),
(12, 12),
(0, 12),
(13, 13),
(0, 13),
(14, 14),
(0, 14),
(15, 15),
(0, 15),
(16, 16),
(0, 16);

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}hooks`;
CREATE TABLE `{install:prefix}hooks` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `plugin` varchar(50) NOT NULL default '',
  `name` varchar(250) NOT NULL default '',
  `type` enum('php','html','smarty','plain') NOT NULL default 'php',
  `code` text,
  `file` text,
  `status` enum('active','inactive') NOT NULL default 'active',
  `order` smallint(5) unsigned NOT NULL default '5',
  PRIMARY KEY  (`id`),
  KEY `status` (`status`)
) {install:mysql_version};

INSERT INTO `{install:prefix}hooks` (`plugin`, `name`, `type`, `code`, `file`, `status`, `order`) VALUES
('comments', 'viewListingAfterMainFieldsDisplay', 'smarty', '<tr>\n	<td><strong>{$lang.comments}:</strong></td>\n	<td>{$total_comments}</td>\n</tr>', '', 'active', 1),
('comments', 'statisticsBlock', 'smarty', '{if isset($num_total_comments)}\n	<tr>\n		<td>{$lang.comments}:</td>\n		<td>{$num_total_comments}</td>\n	</tr>\n{/if}', '', 'active', 2),
('comments', 'bootstrap', 'php', 'global $eSyndiCat, $esynSmarty, $esynConfig;\n				\n$eSyndiCat->setTable("comments");\n$num_total_comments = $eSyndiCat->one("COUNT(*)", "`status` = ''active''");\n$eSyndiCat->resetTable();				\n$esynSmarty->assign(''num_total_comments'', $num_total_comments);\n	\n$sql = "SELECT * FROM `{$eSyndiCat->mPrefix}comments`";\n$sql .= "WHERE `status`=''active''";\n$sql .= "ORDER BY `date` DESC ";\n$sql .= "LIMIT ".$esynConfig->getConfig(''num_latest_comments'');\n$latest_comments = $eSyndiCat->getAll($sql);\n\n$eSyndiCat->factory(''Listing'');\nglobal $esynListing;\nif (!empty($latest_comments))\n{\n	foreach ($latest_comments as $key => $comment)\n	{\n		$latest_comments[$key][''listing''] = $esynListing->getListingById($comment[''listing_id'']);\n	}\n}\n$esynSmarty->assign(''latest_comments'', $latest_comments);', '', 'active', 4),
('comments', 'viewListing', 'php', 'global $eSyndiCat, $esynSmarty, $esynConfig, $esynI18N, $listing;\n\n$eSyndiCat->setTable("comments");\n$comments = $eSyndiCat->all("*", "`listing_id` = :id AND `status` = ''active''", array(''id'' => $listing[''id'']));\n$eSyndiCat->resetTable();\n\nrequire_once(ESYN_HOME . ''plugins'' . ESYN_DS . ''comments'' . ESYN_DS . ''includes'' . ESYN_DS . ''classes'' . ESYN_DS . ''esynRating.php'');\n\n$esynRating = new esynRating();\n\n$rating = $esynRating->getRating($listing[''id'']);\n\n$rating[''voted''] = false;\n\nif($esynRating->isVoted($_SERVER[''REMOTE_ADDR''], $listing[''id'']))\n{\n	$rating[''voted''] = true;\n\n	$rating[''html''] = number_format($rating[''rating''], 2);\n	$rating[''html''] .= ''&nbsp;/&nbsp;'';\n	$rating[''html''] .= $esynConfig->getConfig(''listing_rating_block_max'');\n	$rating[''html''] .= ''&nbsp;('';\n	$rating[''html''] .= $rating[''num_votes''];\n	$rating[''html''] .= ''&nbsp;'';\n	$rating[''html''] .= $rating[''num_votes''] > 1 ? $esynI18N[''votes_cast''] : $esynI18N[''vote_cast''];\n	$rating[''html''] .= '')&nbsp;'';\n	$rating[''html''] .= ''<span style="color: green;">'';\n	$rating[''html''] .= $esynI18N[''thanks_for_voting''];\n	$rating[''html''] .= ''</span>'';\n}\n\n$esynSmarty->assign(''comments'', $comments);\n$esynSmarty->assign(''rating'', $rating);\n$esynSmarty->assign(''total_comments'', count($comments));', '', 'active', 5);

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}language`;
CREATE TABLE `{install:prefix}language` (
  `id` int(8) NOT NULL auto_increment,
  `key` varchar(100) NOT NULL default '',
  `value` text NOT NULL,
  `lang` varchar(50) NOT NULL default '',
  `category` enum('admin','frontend','common','page','tooltip') NOT NULL default 'frontend',
  `code` varchar(2) NOT NULL default '',
  `plugin` VARCHAR( 50 ),
  PRIMARY KEY  (`id`),
  KEY `category` (`category`,`code`)
) {install:mysql_version};

INSERT INTO `{install:prefix}language` (`id`, `key`, `value`, `lang`, `category`, `code`) VALUES
(NULL, 'login_to', 'Login To eSyndiCat Admin Panel', 'English', 'admin', 'en'),
(NULL, 'login_to_text', 'Enter the login name into "Login" and password into the "Password" fields.\r\nThen click "Login".', 'English', 'admin', 'en'),
(NULL, 'login', 'Login', 'English', 'common', 'en'),
(NULL, 'install_not_deleted', 'WARNING!!! INSTALL DIRECTORY HASN''T BEEN REMOVED', 'English', 'admin', 'en'),
(NULL, 'interface_language', 'Interface Language', 'English', 'common', 'en'),
(NULL, 'password', 'Password', 'English', 'common', 'en'),
(NULL, 'forgot_password', 'Forgot your password?', 'English', 'common', 'en'),
(NULL, 'login_btn', 'Login', 'English', 'common', 'en'),
(NULL, 'invalid_username', 'Invalid username.', 'English', 'common', 'en'),
(NULL, 'invalid_password', 'Invalid password.', 'English', 'common', 'en'),
(NULL, 'admin_panel', 'Admin Panel', 'English', 'admin', 'en'),
(NULL, 'configuration', 'Configuration', 'English', 'admin', 'en'),
(NULL, 'manage_admins', 'Manage Admins', 'English', 'admin', 'en'),
(NULL, 'manage_database', 'Manage Database', 'English', 'admin', 'en'),
(NULL, 'manage_accounts', 'Manage Accounts', 'English', 'admin', 'en'),
(NULL, 'manage_pages', 'Manage Pages', 'English', 'admin', 'en'),
(NULL, 'manage_fields', 'Manage Listing Fields', 'English', 'admin', 'en'),
(NULL, 'manage_fields_recommendation', 'It is not recommended to you to add or change fields often.', 'English', 'admin', 'en'),
(NULL, 'manage_language', 'Language Manager', 'English', 'admin', 'en'),
(NULL, 'changes_saved', 'Changes saved.', 'English', 'common', 'en'),
(NULL, 'items_deleted', 'Deleted.', 'English', 'common', 'en'),
(NULL, 'category_locked', 'Category Locked', 'English', 'admin', 'en'),
(NULL, 'import', 'Import', 'English', 'admin', 'en'),
(NULL, 'export', 'Export', 'English', 'admin', 'en'),
(NULL, 'save_changes', 'Save Changes', 'English', 'common', 'en'),
(NULL, 'home', 'Home', 'English', 'common', 'en'),
(NULL, 'management', 'Management', 'English', 'admin', 'en'),
(NULL, 'help', 'Help', 'English', 'common', 'en'),
(NULL, 'phrase_manager', 'Phrase Manager', 'English', 'admin', 'en'),
(NULL, 'site_home', 'Site Home', 'English', 'admin', 'en'),
(NULL, 'directory_home', 'Directory Home', 'English', 'admin', 'en'),
(NULL, 'error_name', 'Name is incorrect.', 'English', 'common', 'en'),
(NULL, 'edit', 'Edit', 'English', 'common', 'en'),
(NULL, 'delete', 'Delete', 'English', 'common', 'en'),
(NULL, 'error_description', 'Description is incorrect.', 'English', 'admin', 'en'),
(NULL, 'help_content', 'Any help regarding eSyndiCat Software could be found here:<br /><br />\r\n1. <a href="http://www.esyndicat.com/forum/">eSyndiCat Support Forums</a><br /><br />\r\n2. <a href="http://www.esyndicat.com/desk/">eSyndiCat Help Desk</a><br /><br />\r\n3. <a href="http://www.esyndicat.com/desk/index.php?/Knowledgebase/List">Knowledge base</a><br /><br />\r\n\r\nPlease do not hesitate to contact us in case you have any questions.', 'English', 'admin', 'en'),
(NULL, 'field_url', 'Listing URL', 'English', 'common', 'en'),
(NULL, 'field_title', 'Title', 'English', 'common', 'en'),
(NULL, 'field_description', 'Description', 'English', 'common', 'en'),
(NULL, 'field_email', 'Email', 'English', 'common', 'en'),
(NULL, 'field_reciprocal', 'Reciprocal URL', 'English', 'common', 'en'),
(NULL, 'days', 'Days', 'English', 'admin', 'en'),
(NULL, 'order', 'Order', 'English', 'common', 'en'),
(NULL, 'save_order', 'Save Order', 'English', 'admin', 'en'),
(NULL, 'cost', 'Cost', 'English', 'admin', 'en'),
(NULL, 'description', 'Description', 'English', 'common', 'en'),
(NULL, 'title', 'Title', 'English', 'common', 'en'),
(NULL, 'add', 'Add', 'English', 'common', 'en'),
(NULL, 'view_all', 'View All', 'English', 'common', 'en'),
(NULL, 'search', 'Search', 'English', 'common', 'en'),
(NULL, 'server_info', 'Server Info', 'English', 'admin', 'en'),
(NULL, 'logout', 'Logout', 'English', 'common', 'en'),
(NULL, 'edit_admin', 'Edit Admin', 'English', 'admin', 'en'),
(NULL, 'admin_added', 'New admin successfully created.', 'English', 'admin', 'en'),
(NULL, 'date', 'Date', 'English', 'common', 'en'),
(NULL, 'status', 'Status', 'English', 'common', 'en'),
(NULL, 'select_action', 'Select Action', 'English', 'admin', 'en'),
(NULL, 'approve', 'Approve', 'English', 'admin', 'en'),
(NULL, 'disapprove', 'Disapprove', 'English', 'admin', 'en'),
(NULL, 'go', 'Go', 'English', 'common', 'en'),
(NULL, '_select_', '-- select --', 'English', 'common', 'en'),
(NULL, 'reply', 'Reply', 'English', 'common', 'en'),
(NULL, 'subject_incorrect', 'Subject is incorrect.', 'English', 'admin', 'en'),
(NULL, 'email_not_sent', 'Warning: Couldn''t deliver mail message.', 'English', 'admin', 'en'),
(NULL, 'email_sent', 'Email sent.', 'English', 'common', 'en'),
(NULL, 'body', 'Body', 'English', 'common', 'en'),
(NULL, 'from', 'From', 'English', 'common', 'en'),
(NULL, 'body_incorrect', 'Body is incorrect.', 'English', 'common', 'en'),
(NULL, 'to', 'To', 'English', 'common', 'en'),
(NULL, 'subject', 'Subject', 'English', 'common', 'en'),
(NULL, 'author', 'Author', 'English', 'common', 'en'),
(NULL, 'email', 'Email', 'English', 'common', 'en'),
(NULL, 'approval', 'Approval', 'English', 'admin', 'en'),
(NULL, 'active', 'Active', 'English', 'admin', 'en'),
(NULL, 'categories', 'Categories', 'English', 'common', 'en'),
(NULL, 'listings', 'Listings', 'English', 'common', 'en'),
(NULL, 'banned', 'Banned', 'English', 'admin', 'en'),
(NULL, 'broken', 'Broken', 'English', 'admin', 'en'),
(NULL, 'nonrecip', 'Non reciprocal', 'English', 'admin', 'en'),
(NULL, 'featured', 'Featured', 'English', 'common', 'en'),
(NULL, 'partner', 'Partner', 'English', 'common', 'en'),
(NULL, 'remove_featured', 'Remove featured', 'English', 'admin', 'en'),
(NULL, 'remove_partner', 'Remove partner', 'English', 'admin', 'en'),
(NULL, 'total', 'Total', 'English', 'common', 'en'),
(NULL, 'reciprocal', 'Reciprocal', 'English', 'common', 'en'),
(NULL, 'comments', 'Comments', 'English', 'common', 'en'),
(NULL, 'accounts', 'Accounts', 'English', 'common', 'en'),
(NULL, 'manage_categories', 'Manage Categories', 'English', 'admin', 'en'),
(NULL, 'path', 'Path', 'English', 'admin', 'en'),
(NULL, 'move', 'Move', 'English', 'common', 'en'),
(NULL, 'no_categories', 'No categories. <a href="controller.php?file=suggest-category&amp;id=[category_id]" style="font-weight: bold;">Click here</a> to create category.', 'English', 'admin', 'en'),
(NULL, 'password_incorrect', 'Password is incorrect.', 'English', 'common', 'en'),
(NULL, 'username_incorrect', 'Username is incorrect.', 'English', 'admin', 'en'),
(NULL, 'username_exists', 'Username already exists.', 'English', 'admin', 'en'),
(NULL, 'passwords_not_match', 'Passwords do not match.', 'English', 'common', 'en'),
(NULL, 'account_added', 'Account added.', 'English', 'common', 'en'),
(NULL, 'account', 'Account', 'English', 'common', 'en'),
(NULL, 'browse_categories', 'Browse Categories', 'English', 'common', 'en'),
(NULL, 'set_order', 'Set Order', 'English', 'admin', 'en'),
(NULL, 'create', 'Create', 'English', 'common', 'en'),
(NULL, 'copy_categories', 'Copy Subcategories', 'English', 'admin', 'en'),
(NULL, 'manage_related', 'Manage Related', 'English', 'admin', 'en'),
(NULL, 'manage_crossed', 'Manage Crossed', 'English', 'admin', 'en'),
(NULL, 'browse', 'Browse', 'English', 'common', 'en'),
(NULL, 'category', 'Category', 'English', 'common', 'en'),
(NULL, 'listing', 'Listing', 'English', 'common', 'en'),
(NULL, 'manage', 'Manage', 'English', 'admin', 'en'),
(NULL, 'expand_all', 'Expand All', 'English', 'common', 'en'),
(NULL, 'collapse_all', 'Collapse All', 'English', 'common', 'en'),
(NULL, 'common', 'Common', 'English', 'admin', 'en'),
(NULL, 'sql_management', 'SQL Management', 'English', 'admin', 'en'),
(NULL, 'check_consistency', 'Check Consistency', 'English', 'admin', 'en'),
(NULL, 'optimize_tables', 'optimize tables', 'English', 'admin', 'en'),
(NULL, 'done', 'Done', 'English', 'common', 'en'),
(NULL, 'all_categories', 'All Categories', 'English', 'common', 'en'),
(NULL, 'all_listings', 'All Listings', 'English', 'common', 'en'),
(NULL, 'all_accounts', 'All Accounts', 'English', 'admin', 'en'),
(NULL, 'help_contents', 'Help Contents', 'English', 'admin', 'en'),
(NULL, 'release_notes', 'Release Notes', 'English', 'admin', 'en'),
(NULL, 'system_info', 'System Info', 'English', 'admin', 'en'),
(NULL, 'about_esyndicat', 'About eSyndiCat', 'English', 'admin', 'en'),
(NULL, 'title_incorrect', 'Title incorrect.', 'English', 'common', 'en'),
(NULL, 'category_unlocked', 'Category unlocked', 'English', 'admin', 'en'),
(NULL, 'unique_category_template', 'Use unique template', 'English', 'admin', 'en'),
(NULL, 'category_unique', 'Category will use unique template now.', 'English', 'admin', 'en'),
(NULL, 'category_ununique', 'Category will not use unique template anymore.', 'English', 'admin', 'en'),
(NULL, 'moved', 'Moved.', 'English', 'admin', 'en'),
(NULL, 'related_added', 'Related category added.', 'English', 'admin', 'en'),
(NULL, 'already_related', 'Related category already exists.', 'English', 'admin', 'en'),
(NULL, 'crossed_added', 'Crosslink added.', 'English', 'admin', 'en'),
(NULL, 'already_crossed', 'Crossed link already exists.', 'English', 'admin', 'en'),
(NULL, 'already_copied', 'Listing already exists in this category.', 'English', 'admin', 'en'),
(NULL, 'copied', ' copied.', 'English', 'admin', 'en'),
(NULL, 'rating_reset', 'Listing rating reset.', 'English', 'admin', 'en'),
(NULL, 'featured_added', 'Listing added to featured.', 'English', 'admin', 'en'),
(NULL, 'already_featured', 'Listing already featured.', 'English', 'admin', 'en'),
(NULL, 'crossed_removed', 'Crosslink removed from this category.', 'English', 'admin', 'en'),
(NULL, 'featured_removed', 'Listing removed from featured.', 'English', 'admin', 'en'),
(NULL, 'partner_removed', 'Listing removed from partners.', 'English', 'admin', 'en'),
(NULL, 'partner_added', 'Listing added to partners.', 'English', 'admin', 'en'),
(NULL, 'already_partner', 'Listing already added to partners.', 'English', 'admin', 'en'),
(NULL, 'subcategories_copied', 'All subcategories have been copied.', 'English', 'admin', 'en'),
(NULL, 'lock', 'Lock', 'English', 'admin', 'en'),
(NULL, 'unlock', 'Unlock', 'English', 'admin', 'en'),
(NULL, 'add_related', 'Add Related', 'English', 'admin', 'en'),
(NULL, 'add_crossed', 'Add Crossed', 'English', 'admin', 'en'),
(NULL, 'no_related', 'No related categories. <a href="javascript:void(0)" onclick="$(''#treeContainer'').fadeIn();$(''#action'').val(''relate'');$(''#labelcat0'').disable();resetTree();return false;" style="font-weight: bold;">Click here</a> to add related category to <strong>{category_title}</strong>.', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_uninstall_selected_plugins', 'Are you sure you want to uninstall selected plugins?', 'English', 'admin', 'en'),
(NULL, 'category_path_exists', 'Category with similar path value already exists', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_uninstall_selected_plugin', 'Are you sure you want uninstall this plugin?', 'English', 'admin', 'en'),
(NULL, 'category_title_exists', 'Category with similar title value already exists', 'English', 'admin', 'en'),
(NULL, 'category_added', 'Category added.', 'English', 'admin', 'en'),
(NULL, 'meta_description', 'Meta-description', 'English', 'common', 'en'),
(NULL, 'meta_keywords', 'Meta-keywords', 'English', 'common', 'en'),
(NULL, 'parent', 'Parent', 'English', 'admin', 'en'),
(NULL, 'yes', 'Yes', 'English', 'common', 'en'),
(NULL, 'no', 'No', 'English', 'common', 'en'),
(NULL, 'columns_num', 'Number Of Columns', 'English', 'admin', 'en'),
(NULL, 'neighbours_num', 'Number Of Neighbours', 'English', 'admin', 'en'),
(NULL, 'all_comments', 'All Comments', 'English', 'admin', 'en'),
(NULL, 'comment', 'Comment', 'English', 'common', 'en'),
(NULL, 'incorrect_dates', 'Incorrect dates.', 'English', 'admin', 'en'),
(NULL, 'partner_since', 'Partner Since', 'English', 'common', 'en'),
(NULL, 'clicks', 'Clicks', 'English', 'common', 'en'),
(NULL, 'rating', 'Rating', 'English', 'common', 'en'),
(NULL, 'featured_since', 'Featured Since', 'English', 'common', 'en'),
(NULL, 'ban', 'Ban', 'English', 'common', 'en'),
(NULL, 'deleted', 'Deleted.', 'English', 'common', 'en'),
(NULL, 'settings', 'Settings', 'English', 'admin', 'en'),
(NULL, 'upgrade_completed', 'Upgrade completed.', 'English', 'admin', 'en'),
(NULL, 'state', 'State', 'English', 'admin', 'en'),
(NULL, 'filter_by', 'Filter By', 'English', 'admin', 'en'),
(NULL, 'send', 'Send', 'English', 'common', 'en'),
(NULL, 'recipients', 'Recipients', 'English', 'admin', 'en'),
(NULL, '_all_', '-- all --', 'English', 'admin', 'en'),
(NULL, 'root_cant_deleted', 'Root category can not be deleted.', 'English', 'admin', 'en'),
(NULL, 'cant_open_sql', 'Could not open file with sql instructions: {filename}.', 'English', 'admin', 'en'),
(NULL, 'no_pages', 'No pages created. Please <a href="manage-pages.php?action=add">click here</a> to create a page.', 'English', 'admin', 'en'),
(NULL, 'disable', 'Disable', 'English', 'common', 'en'),
(NULL, 'enable', 'Enable', 'English', 'admin', 'en'),
(NULL, 'myfield', 'myfield', 'English', 'common', 'en'),
(NULL, 'pagerank', 'PageRank', 'English', 'common', 'en'),
(NULL, 'some', 'some', 'English', 'common', 'en'),
(NULL, '_status_', '- Status -', 'English', 'admin', 'en'),
(NULL, '_state_', '- State -', 'English', 'admin', 'en'),
(NULL, '_action_', '- Action -', 'English', 'admin', 'en'),
(NULL, 'crosslisting_confirm', 'Are sure you want to make it crosslink?', 'English', 'admin', 'en'),
(NULL, 'unknown_upload', 'Unknown error during file upload.', 'English', 'common', 'en'),
(NULL, 'incorrect_filetype', 'Incorrect file type.', 'English', 'common', 'en'),
(NULL, 'upload_correct_permission', 'Couldn''t copy uploaded image to the destination. Please make sure that the script has write permission.', 'English', 'common', 'en'),
(NULL, 'view', 'View', 'English', 'common', 'en'),
(NULL, 'additional_fields', 'Additional Fields', 'English', 'common', 'en'),
(NULL, 'reciprocal_valid', 'Reciprocal Valid', 'English', 'admin', 'en'),
(NULL, 'rank', 'Rank', 'English', 'common', 'en'),
(NULL, 'email_notif', 'Send email notification', 'English', 'admin', 'en'),
(NULL, 'admin', 'Admin', 'English', 'admin', 'en'),
(NULL, 'logout_content', 'Logged out. <a href="../" style="font-weight: bold;">Click here</a> to go to directory home.<br />\r\n<a href="login.php" style="font-weight: bold;">Click here</a> to go to directory admin panel again.<br />', 'English', 'admin', 'en'),
(NULL, 'incorrect_permissions', 'Please set correct permissions.', 'English', 'admin', 'en'),
(NULL, 'incorrect_password_confirm', 'Please make sure you entered valid confirmation.', 'English', 'admin', 'en'),
(NULL, 'incorrect_email', 'Please input correct email.', 'English', 'common', 'en'),
(NULL, 'incorrect_password', 'Please input correct password.', 'English', 'admin', 'en'),
(NULL, 'incorrect_fullname', 'Please input correct full name.', 'English', 'admin', 'en'),
(NULL, 'added', 'Added.', 'English', 'admin', 'en'),
(NULL, 'admins', 'Admins', 'English', 'admin', 'en'),
(NULL, 'username', 'Username', 'English', 'common', 'en'),
(NULL, 'fullname', 'Full Name', 'English', 'common', 'en'),
(NULL, 'submission_notif', 'Submission Notification', 'English', 'admin', 'en'),
(NULL, 'password_confirm', 'Password Confirmation', 'English', 'common', 'en'),
(NULL, 'enabled', 'Enabled', 'English', 'common', 'en'),
(NULL, 'disabled', 'Disabled', 'English', 'common', 'en'),
(NULL, 'admin_permissions', 'Admin Permissions', 'English', 'admin', 'en'),
(NULL, 'super_admin', 'Super Admin', 'English', 'admin', 'en'),
(NULL, 'created', 'Created.', 'English', 'admin', 'en'),
(NULL, 'related_confirm', 'Are sure you want to remove this related category?', 'English', 'admin', 'en'),
(NULL, 'nothing_checked', 'Please check any items to delete.', 'English', 'admin', 'en'),
(NULL, 'no_comments', 'No Comments.', 'English', 'common', 'en'),
(NULL, 'no_crossed', 'No crossed categories. <a href="javascript:void(0);" onClick="$(''#treeContainer'').fadeIn();$(''#action'').val(''cross'');$(''#labelcat0'').disable();return false;" style="font-weight: bold;">Click here</a> to add crossed category to <strong>{category_title}</strong>.', 'English', 'admin', 'en'),
(NULL, 'no_crossed_root', 'No crossed categories can be created for ROOT category.', 'English', 'admin', 'en'),
(NULL, 'no_related_root', 'No related categories can be created for ROOT category.', 'English', 'admin', 'en'),
(NULL, 'copy_subcats', 'Are sure you want to copy all subcategories to another category?', 'English', 'admin', 'en'),
(NULL, 'copy_listing_confirm', 'Are sure you want to copy this listing to another category?', 'English', 'admin', 'en'),
(NULL, 'move_listing_confirm', 'Are sure you want to move in this category?', 'English', 'admin', 'en'),
(NULL, 'no_accounts', 'No accounts. <a href="manage-accounts.php?action=add">Click here</a> to add account.', 'English', 'admin', 'en'),
(NULL, 'incorrect_name_url', 'Incorrect name. Please fill in the URL field.', 'English', 'admin', 'en'),
(NULL, 'page_exists', 'Page with this URL already exists. Please change URL.', 'English', 'admin', 'en'),
(NULL, 'page', 'Page', 'English', 'common', 'en'),
(NULL, 'pages', 'Pages', 'English', 'common', 'en'),
(NULL, 'page_url', 'Page UNIQUE key', 'English', 'admin', 'en'),
(NULL, 'show_menus', 'Show in Menus', 'English', 'admin', 'en'),
(NULL, 'top_menu', 'Main Menu', 'English', 'admin', 'en'),
(NULL, 'bottom_menu', 'Bottom Menu', 'English', 'admin', 'en'),
(NULL, 'account_menu', 'Account Menu', 'English', 'admin', 'en'),
(NULL, 'external_url', 'External URL', 'English', 'admin', 'en'),
(NULL, 'no_follow_url', 'No Follow URL', 'English', 'admin', 'en'),
(NULL, 'page_external_url', 'Page External URL', 'English', 'admin', 'en'),
(NULL, 'enter_external_url', 'Enter External URL', 'English', 'admin', 'en'),
(NULL, 'page_content', 'Page Content', 'English', 'admin', 'en'),
(NULL, 'page_content_sample', 'Your page content should be here...', 'English', 'common', 'en'),
(NULL, 'url', 'URL', 'English', 'common', 'en'),
(NULL, 'menus', 'Menus', 'English', 'admin', 'en'),
(NULL, 'cant_write_sql', 'Cannot write to file {filename}.', 'English', 'admin', 'en'),
(NULL, 'table_dumped', 'Table {table} successfully dumped into file {filename}.', 'English', 'admin', 'en'),
(NULL, 'directory_not_writable', '{dirname} directory is not writable. You can not save to server.', 'English', 'admin', 'en'),
(NULL, 'mysql_options', 'MySQL Options', 'English', 'admin', 'en'),
(NULL, 'options', 'Options', 'English', 'admin', 'en'),
(NULL, 'select_all', 'Select All ', 'English', 'admin', 'en'),
(NULL, 'select_none', 'Select None', 'English', 'admin', 'en'),
(NULL, 'structure', 'Structure', 'English', 'admin', 'en'),
(NULL, 'add_drop_table', 'Add DROP TABLE', 'English', 'admin', 'en'),
(NULL, 'data', 'Data', 'English', 'admin', 'en'),
(NULL, 'complete_inserts', 'Complete Inserts', 'English', 'admin', 'en'),
(NULL, 'use_real_prefix', 'Use real tables prefix', 'English', 'admin', 'en'),
(NULL, 'save_as_file', 'Save as file', 'English', 'admin', 'en'),
(NULL, 'save_to_server', 'Save to server', 'English', 'admin', 'en'),
(NULL, 'save_to_pc', 'Save to PC', 'English', 'admin', 'en'),
(NULL, 'export_not_checked', 'You have not choosen what to export.', 'English', 'admin', 'en'),
(NULL, 'no_upgrades', 'No patches or upgrades available.', 'English', 'admin', 'en'),
(NULL, 'location_sql_file', 'Location of MySQL upgrade file', 'English', 'admin', 'en'),
(NULL, 'choose_import_file', 'Please choose a file to import.', 'English', 'admin', 'en'),
(NULL, 'run_sql_queries', 'Run MySQL query/queries', 'English', 'admin', 'en'),
(NULL, 'tables_fields', 'Tables/Fields', 'English', 'admin', 'en'),
(NULL, 'show_query_again', 'Show this query again', 'English', 'admin', 'en'),
(NULL, 'clear', 'Clear', 'English', 'admin', 'en'),
(NULL, 'clear_confirm', 'Are you sure you want to clear your form?', 'English', 'admin', 'en'),
(NULL, 'add_field', 'Add Field', 'English', 'admin', 'en'),
(NULL, 'edit_field', 'Edit Field', 'English', 'admin', 'en'),
(NULL, 'field_added', 'Field added.', 'English', 'admin', 'en'),
(NULL, 'field_exists', 'Field already exists.', 'English', 'admin', 'en'),
(NULL, 'field_length_incorrect', 'Field length invalid. Only digits allowed.', 'English', 'admin', 'en'),
(NULL, 'field_name_incorrect', 'Field name should consist of letters and numbers only. Length 2-20.', 'English', 'admin', 'en'),
(NULL, 'field_default_incorrect', 'You must choose default from values above.', 'English', 'admin', 'en'),
(NULL, 'name', 'Name', 'English', 'admin', 'en'),
(NULL, 'show_on_pages', 'Show On Pages', 'English', 'admin', 'en'),
(NULL, 'suggest_listing', 'Suggest Listing', 'English', 'common', 'en'),
(NULL, 'listing_details', 'Listing Details', 'English', 'common', 'en'),
(NULL, 'required_field', 'Required Field', 'English', 'admin', 'en'),
(NULL, 'visible_for_admin', 'Visible for admin only', 'English', 'admin', 'en'),
(NULL, 'field_type', 'Field type', 'English', 'admin', 'en'),
(NULL, 'field_length', 'Field length', 'English', 'admin', 'en'),
(NULL, 'field_default', 'Field default value', 'English', 'admin', 'en'),
(NULL, 'file_prefix', 'File Prefix', 'English', 'admin', 'en'),
(NULL, 'image_height', 'Image Height', 'English', 'admin', 'en'),
(NULL, 'image_width', 'Image Width', 'English', 'common', 'en'),
(NULL, 'item_value', 'Item Value', 'English', 'admin', 'en'),
(NULL, 'add_item_value', 'Add Item Value', 'English', 'admin', 'en'),
(NULL, 'remove', 'Remove', 'English', 'common', 'en'),
(NULL, 'of', 'of', 'English', 'common', 'en'),
(NULL, 'first_page', 'First Page', 'English', 'common', 'en'),
(NULL, 'previous_page', 'Previous Page', 'English', 'common', 'en'),
(NULL, 'next_page', 'Next Page', 'English', 'common', 'en'),
(NULL, 'last_page', 'Last Page', 'English', 'common', 'en'),
(NULL, 'no_broken', 'No broken listings.', 'English', 'admin', 'en'),
(NULL, 'no_norecip', 'No non-reciprocal listings.', 'English', 'admin', 'en'),
(NULL, 'no_featured', 'No featured listings.', 'English', 'admin', 'en'),
(NULL, 'no_partner', 'No partner listings.', 'English', 'admin', 'en'),
(NULL, 'no_listings', 'No listings yet created. <a href="suggest-listing.php?id=0" style="font-weight: bold;">Click here</a> to add new one.', 'English', 'common', 'en'),
(NULL, 'mark_as', 'Mark As', 'English', 'admin', 'en'),
(NULL, 'check', 'Check', 'English', 'admin', 'en'),
(NULL, 'config_groups', 'Configuration Groups', 'English', 'admin', 'en'),
(NULL, 'search_by_keywords', 'Search by Keywords', 'English', 'admin', 'en'),
(NULL, 'any_word', 'any word', 'English', 'common', 'en'),
(NULL, 'all_words', 'all words', 'English', 'common', 'en'),
(NULL, 'exact_match', 'exact match', 'English', 'common', 'en'),
(NULL, 'search_by_dates', 'Search by dates', 'English', 'admin', 'en'),
(NULL, 'header_incorrect', 'Listing header is unknown. Please check it manually.', 'English', 'admin', 'en'),
(NULL, 'recip_incorrect', 'Please check it manually. Reciprocal link seems to be invalid.', 'English', 'admin', 'en'),
(NULL, 'from_incorrect', 'Please specify the "From" address.', 'English', 'admin', 'en'),
(NULL, 'email_message_sent', 'Your message being sent right now.', 'English', 'admin', 'en'),
(NULL, 'incorrect_key', 'Phrase key is incorrect.', 'English', 'admin', 'en'),
(NULL, 'incorrect_value', 'Please enter the value of the key.', 'English', 'admin', 'en'),
(NULL, 'key_not_valid', 'Key is not valid only alphanumeric and underscore characters allowed.', 'English', 'admin', 'en'),
(NULL, 'key_exists', 'The phrase with similar key already exists', 'English', 'admin', 'en'),
(NULL, 'lang_incorrect', 'Please choose correct language.', 'English', 'admin', 'en'),
(NULL, 'incorrect_text_field', 'Text field is incorrect.', 'English', 'admin', 'en'),
(NULL, 'search_in_phrases', 'Search in Phrases', 'English', 'admin', 'en'),
(NULL, 'download_lang', 'Export Language', 'English', 'admin', 'en'),
(NULL, 'compare_languages', 'Compare Languages', 'English', 'admin', 'en'),
(NULL, 'new_language', 'New Language', 'English', 'admin', 'en'),
(NULL, 'copy_language', 'Copy Language', 'English', 'admin', 'en'),
(NULL, 'add_phrase', 'Add Phrase', 'English', 'admin', 'en'),
(NULL, 'language', 'Language', 'English', 'common', 'en'),
(NULL, 'default', 'Default', 'English', 'common', 'en'),
(NULL, 'edit_translate', 'Edit / Translate {language} phrases', 'English', 'admin', 'en'),
(NULL, 'set_default', 'Set Default', 'English', 'common', 'en'),
(NULL, 'download', 'Download', 'English', 'common', 'en'),
(NULL, 'download_upload', 'Export/Import', 'English', 'admin', 'en'),
(NULL, 'phrase_group', 'Phrase Group', 'English', 'admin', 'en'),
(NULL, 'all_groups', 'All Groups', 'English', 'admin', 'en'),
(NULL, 'display', 'Display', 'English', 'admin', 'en'),
(NULL, 'no_search_results', 'No results found matching your criteria.', 'English', 'admin', 'en'),
(NULL, 'about', 'About Us', 'English', 'frontend', 'en'),
(NULL, 'account_created', 'Account created! Thank you!', 'English', 'common', 'en'),
(NULL, 'advanced_search', 'Advanced Search', 'English', 'frontend', 'en'),
(NULL, 'advertise', 'Advertise Us', 'English', 'frontend', 'en'),
(NULL, 'approval_listings', 'Waiting Approval', 'English', 'common', 'en'),
(NULL, 'ascending', 'ascending', 'English', 'frontend', 'en'),
(NULL, 'author_email', 'Author Email', 'English', 'frontend', 'en'),
(NULL, 'category_title', 'Category title', 'English', 'frontend', 'en'),
(NULL, 'category_submitted', 'Category was submitted for consideration!', 'English', 'frontend', 'en'),
(NULL, 'change_password', 'Change Password', 'English', 'frontend', 'en'),
(NULL, 'characters_left', 'characters left', 'English', 'common', 'en'),
(NULL, 'click_here', 'Click here', 'English', 'frontend', 'en'),
(NULL, 'comment_added', 'Comment added.', 'English', 'common', 'en'),
(NULL, 'comment_author', 'Comment Author', 'English', 'frontend', 'en'),
(NULL, 'comment_rank', 'Listing Rank: ', 'English', 'frontend', 'en'),
(NULL, 'company_info', 'Company Info', 'English', 'frontend', 'en'),
(NULL, 'company_jobs', 'Company Jobs', 'English', 'frontend', 'en'),
(NULL, 'company_policy', 'Company Policy', 'English', 'frontend', 'en'),
(NULL, 'company_terms', 'Terms Of Service', 'English', 'frontend', 'en'),
(NULL, 'complete_submission', 'Complete submission', 'English', 'frontend', 'en'),
(NULL, 'confirmation_sent', 'Confirmation for password change request sent.', 'English', 'frontend', 'en'),
(NULL, 'current_password', 'Current Password', 'English', 'frontend', 'en'),
(NULL, 'description_empty', 'Description is empty!', 'English', 'frontend', 'en'),
(NULL, 'descending', 'descending', 'English', 'frontend', 'en'),
(NULL, 'edit_account', 'Edit Account', 'English', 'common', 'en'),
(NULL, 'edit_info', 'Edit Info', 'English', 'frontend', 'en'),
(NULL, 'edit_listing', 'Edit Listing', 'English', 'common', 'en'),
(NULL, 'account_email_exists', 'Account with this email already exists!', 'English', 'common', 'en'),
(NULL, 'account_listings', 'My listings', 'English', 'frontend', 'en'),
(NULL, 'account_login', 'Account Login', 'English', 'frontend', 'en'),
(NULL, 'account_no_listings', 'You have not submitted any listings. Please choose correct category and make sure it fits your listing best. Then click SUGGEST LISTING, input requested information and submit it. <br /> Usually it takes about 24 hours for a listing to be reviewed by administrator.', 'English', 'frontend', 'en'),
(NULL, 'accounts_area', 'Accounts Area', 'English', 'frontend', 'en'),
(NULL, 'error', 'Error', 'English', 'common', 'en'),
(NULL, 'featured_listings', 'Featured', 'English', 'common', 'en'),
(NULL, 'first', 'First', 'English', 'common', 'en'),
(NULL, 'free', 'Free', 'English', 'frontend', 'en'),
(NULL, 'friend_fullname', 'Your friend''s fullname', 'English', 'frontend', 'en'),
(NULL, 'friend_told', 'Message has just been sent to your friend.', 'English', 'frontend', 'en'),
(NULL, 'forgot', 'Forgot password?', 'English', 'frontend', 'en'),
(NULL, 'last', 'Last', 'English', 'common', 'en'),
(NULL, 'leave_comment', 'Leave Comment', 'English', 'frontend', 'en'),
(NULL, 'listing_added', 'Listing added', 'English', 'common', 'en'),
(NULL, 'listing_changed', 'Listing changed', 'English', 'frontend', 'en'),
(NULL, 'listing_rank', 'Listing Rank', 'English', 'common', 'en'),
(NULL, 'listing_status', 'Listing Status', 'English', 'common', 'en'),
(NULL, 'listing_submitted', 'Thank you! Your listing was submitted for consideration', 'English', 'frontend', 'en'),
(NULL, 'listings_found', 'Listings Found: ', 'English', 'frontend', 'en'),
(NULL, 'logged_out', 'You have been logged out.', 'English', 'frontend', 'en'),
(NULL, 'my_categories', 'My Categories', 'English', 'frontend', 'en'),
(NULL, 'my_listings', 'My listings', 'English', 'frontend', 'en'),
(NULL, 'new_listings', 'New listings', 'English', 'frontend', 'en'),
(NULL, 'new_password', 'New Password', 'English', 'frontend', 'en'),
(NULL, 'new_password2', 'New Password[confirm]', 'English', 'frontend', 'en'),
(NULL, 'new_password_sent', 'New password has just been sent to account email!', 'English', 'frontend', 'en'),
(NULL, 'neighbour_categories', 'Neighbour Categories', 'English', 'frontend', 'en'),
(NULL, 'next', 'Next', 'English', 'common', 'en'),
(NULL, 'no_results', 'No results', 'English', 'frontend', 'en'),
(NULL, 'not_found_listings', 'No listings found. Please try to broaden your search criterias!', 'English', 'frontend', 'en'),
(NULL, 'not_available', 'Not available', 'English', 'frontend', 'en'),
(NULL, 'no_approval_listings', 'No listings waiting for approval in your categories', 'English', 'frontend', 'en'),
(NULL, 'not_rated', 'This listing is not rated yet. Be the first who rates it!', 'English', 'frontend', 'en'),
(NULL, 'partner_listings', 'Partner listings', 'English', 'common', 'en'),
(NULL, 'policy', 'Privacy Policy', 'English', 'frontend', 'en'),
(NULL, 'previous', 'Previous', 'English', 'common', 'en'),
(NULL, 'reason', 'Reason', 'English', 'frontend', 'en'),
(NULL, 'related_categories', 'Related Categories', 'English', 'common', 'en'),
(NULL, 'restore_password', 'Restore password', 'English', 'common', 'en'),
(NULL, 'statistics', 'Statistics', 'English', 'common', 'en'),
(NULL, 'submit', 'Submit', 'English', 'common', 'en'),
(NULL, 'submission', 'Submission', 'English', 'frontend', 'en'),
(NULL, 'manage_listings', 'Manage Listings', 'English', 'admin', 'en'),
(NULL, 'suggest_category_top1', 'You are going to suggest category here:', 'English', 'frontend', 'en'),
(NULL, 'suggest_listing_top1', 'You are going to suggest your listing to the following category:', 'English', 'frontend', 'en'),
(NULL, 'suggest_listing_top2', 'Please make sure your listing fits this category.', 'English', 'frontend', 'en'),
(NULL, 'password_changed', 'Password has been successfully changed.', 'English', 'frontend', 'en'),
(NULL, 'passwords_dont_match', 'Passwords you entered do not match.', 'English', 'frontend', 'en'),
(NULL, 'password_empty', 'You have not entered a new password.', 'English', 'frontend', 'en'),
(NULL, 'popular_listings', 'Popular listings', 'English', 'frontend', 'en'),
(NULL, 'posted', 'posted on ', 'English', 'frontend', 'en'),
(NULL, 'rate_listing', 'Rate Listing', 'English', 'frontend', 'en'),
(NULL, 'report_broken_listing', 'Report Broken  Listing', 'English', 'frontend', 'en'),
(NULL, 'rating_num', 'Number of Ratings:', 'English', 'frontend', 'en'),
(NULL, 'reciprocal_empty', 'Reciprocal link is empty!', 'English', 'frontend', 'en'),
(NULL, 'register', 'Register', 'English', 'frontend', 'en'),
(NULL, 'register_account', 'Do not have an account?', 'English', 'frontend', 'en'),
(NULL, 'submission_confirmation', 'Please verify if submitted information is correct.', 'English', 'frontend', 'en'),
(NULL, 'upgrade_listing', 'Upgrade Listing', 'English', 'frontend', 'en'),
(NULL, 'url_empty', 'url is empty!', 'English', 'frontend', 'en'),
(NULL, 'username_empty', 'Make sure you entered valid username or your account is active.', 'English', 'frontend', 'en'),
(NULL, 'terms', 'Terms of Use', 'English', 'frontend', 'en'),
(NULL, 'title_empty', 'Title is empty!', 'English', 'frontend', 'en'),
(NULL, 'thanks', 'Thank you.', 'English', 'frontend', 'en'),
(NULL, 'thank_text', 'to get back to index page.', 'English', 'frontend', 'en'),
(NULL, 'thanks_for_vote', 'Thanks for vote.', 'English', 'frontend', 'en'),
(NULL, 'top_listings', 'Top listings', 'English', 'frontend', 'en'),
(NULL, 'total_num_categories', 'Number of categories:', 'English', 'frontend', 'en'),
(NULL, 'total_num_listings', 'Number of listings:', 'English', 'frontend', 'en'),
(NULL, 'transaction_failed', 'Transaction failed! Please contact us!', 'English', 'frontend', 'en'),
(NULL, 'transaction_failed2', 'Stop trying hack our site! Your ip is has been tracked!', 'English', 'frontend', 'en'),
(NULL, 'transaction_success_title', 'Transaction successful!', 'English', 'frontend', 'en'),
(NULL, 'transaction_success', 'Transaction successful! You will be sent an email within 24 hours!', 'English', 'frontend', 'en'),
(NULL, 'view_amazon', 'View Amazon Info', 'English', 'frontend', 'en'),
(NULL, 'view_listing', 'View Listing', 'English', 'frontend', 'en'),
(NULL, 'admin_deleted', 'Selected admin successfully deleted', 'English', 'admin', 'en'),
(NULL, 'view_my_listings', 'View My listings', 'English', 'frontend', 'en'),
(NULL, 'view_my_categories', 'Categories To Edit', 'English', 'frontend', 'en'),
(NULL, 'your_email', 'Your email', 'English', 'frontend', 'en'),
(NULL, 'your_listing_category', 'Your listing category', 'English', 'frontend', 'en'),
(NULL, 'your_listing_url', 'Your listing URL', 'English', 'frontend', 'en'),
(NULL, 'your_listing_title', 'Your listing title', 'English', 'frontend', 'en'),
(NULL, 'your_listing_description', 'Your listing description', 'English', 'frontend', 'en'),
(NULL, 'your_listing_reciprocal', 'Listing reciprocal URL', 'English', 'frontend', 'en'),
(NULL, 'your_message', 'Your message here', 'English', 'frontend', 'en'),
(NULL, 'your_password', 'Your password', 'English', 'frontend', 'en'),
(NULL, 'your_password_confirm', 'Confirm your password', 'English', 'frontend', 'en'),
(NULL, 'your_username', 'Your username', 'English', 'frontend', 'en'),
(NULL, 'your_username_here', 'Your username here:', 'English', 'frontend', 'en'),
(NULL, 'welcome', 'Welcome', 'English', 'frontend', 'en'),
(NULL, 'wrong_image_type', 'Only following image types are allowed (<i>{types}</i>) for `{name}` field', 'English', 'common', 'en'),
(NULL, 'sort_listings_by', 'Sort listings by: ', 'English', 'frontend', 'en'),
(NULL, 'alphabetic', 'Alphabetic', 'English', 'frontend', 'en'),
(NULL, 'error_already_voted', 'You''ve already voted. Please try later.', 'English', 'frontend', 'en'),
(NULL, 'error_banned', 'Listing was banned. Please do not try to add it again.', 'English', 'frontend', 'en'),
(NULL, 'error_broken_listing', 'Listing seems to be broken. Please check it manually.', 'English', 'common', 'en'),
(NULL, 'error_captcha', 'Your confirmation code is incorrect.', 'English', 'frontend', 'en'),
(NULL, 'error_category_empty', 'Please go into appropriate category and become account there.', 'English', 'frontend', 'en'),
(NULL, 'error_category_exists', 'Category was already suggested before.', 'English', 'frontend', 'en'),
(NULL, 'error_category_locked', 'This category is locked by administrator.', 'English', 'frontend', 'en'),
(NULL, 'error_contact_fullname', 'Please fill in full name.', 'English', 'frontend', 'en'),
(NULL, 'error_directory_readonly', 'Uploads directory is readonly. Please make it writable.', 'English', 'frontend', 'en'),
(NULL, 'error_email_incorrect', 'Make sure you entered valid email.', 'English', 'common', 'en'),
(NULL, 'error_listing_present', 'Your listing already exists in directory.', 'English', 'common', 'en'),
(NULL, 'error_file_upload', 'Unknown error during file upload.', 'English', 'frontend', 'en'),
(NULL, 'error_max_description', 'Your description length should be less than {num} symbols.', 'English', 'frontend', 'en'),
(NULL, 'error_min_description', 'Your description length should be more than {num} symbols.', 'English', 'frontend', 'en'),
(NULL, 'error_comment', 'Make sure you entered valid comment.', 'English', 'frontend', 'en'),
(NULL, 'error_comment_author', 'Make sure you entered valid comment author.', 'English', 'frontend', 'en'),
(NULL, 'error_comment_email', 'Make sure you entered valid author email.', 'English', 'frontend', 'en'),
(NULL, 'error_max_comment', 'Your comment length should be less than {maxLength} symbols.', 'English', 'frontend', 'en'),
(NULL, 'error_min_comment', 'Your comment length should be more than {minLength} symbols.', 'English', 'frontend', 'en'),
(NULL, 'error_no_account_email', 'No accounts registered with this email.', 'English', 'frontend', 'en'),
(NULL, 'error_root_category', 'You can not suggest in root category. Please choose an appropiate category and try again.', 'English', 'frontend', 'en'),
(NULL, 'error_suggest_logged', 'You should be logged in to suggest listings.', 'English', 'frontend', 'en'),
(NULL, 'error_password_empty', 'Please input correct password.', 'English', 'common', 'en'),
(NULL, 'error_password_match', 'Passwords do not match.', 'English', 'common', 'en'),
(NULL, 'error_reciprocal_listing', 'Please input correct reciprocal link.', 'English', 'frontend', 'en'),
(NULL, 'error_reciprocal_domain', 'Please make sure you use a backlink from your domain.', 'English', 'frontend', 'en'),
(NULL, 'error_username_empty', 'Please input correct username.', 'English', 'common', 'en'),
(NULL, 'error_username_exists', 'Username already taken. Please input different username.', 'English', 'common', 'en'),
(NULL, 'error_account_incorrect', 'Please fill in username.', 'English', 'frontend', 'en'),
(NULL, 'error_accountpsw_incorrect', 'Please fill in password.', 'English', 'frontend', 'en'),
(NULL, '200', 'URL located, content follows (200)', 'English', 'frontend', 'en'),
(NULL, '301', 'Object moved permanently (301)', 'English', 'frontend', 'en'),
(NULL, '302', 'Object moved (302)', 'English', 'frontend', 'en'),
(NULL, '304', 'Not modified (304)', 'English', 'frontend', 'en'),
(NULL, '400', 'Bad request (400)', 'English', 'frontend', 'en'),
(NULL, '401', 'Unauthorized(401)', 'English', 'frontend', 'en'),
(NULL, '403', 'Forbidden (403)', 'English', 'frontend', 'en'),
(NULL, '404', 'Requested URL not found (404)', 'English', 'frontend', 'en'),
(NULL, '500', 'Unknown server error (500)', 'English', 'frontend', 'en'),
(NULL, '503', 'Server capacity reached (503)', 'English', 'frontend', 'en'),
(NULL, '666', 'Error occurred while paid listing submission. Please try to sugget a listing again.', 'English', 'frontend', 'en'),
(NULL, '670', 'Accounts functionality disabled by administrator.', 'English', 'frontend', 'en'),
(NULL, '671', 'Permission denied. You don''t have enough permission to modify that listing.', 'English', 'common', 'en'),
(NULL, '672', 'Suggest category functionality disabled by administrator.', 'English', 'frontend', 'en'),
(NULL, '673', 'Your IP-address was banned by administrator', 'English', 'frontend', 'en'),
(NULL, 'cancel', 'Cancel', 'English', 'common', 'en'),
(NULL, 'click_here_to_edit', 'Click here to edit.', 'English', 'common', 'en'),
(NULL, 'reset', 'Reset', 'English', 'common', 'en'),
(NULL, 'key', 'Key', 'English', 'common', 'en'),
(NULL, 'value', 'Value', 'English', 'common', 'en'),
(NULL, 'import_from_server', 'Import the language file from your server', 'English', 'admin', 'en'),
(NULL, 'import_from_pc', 'Import the language file from PC', 'English', 'admin', 'en'),
(NULL, 'filename', 'Filename', 'English', 'common', 'en'),
(NULL, 'all_languages', 'All Languages', 'English', 'common', 'en'),
(NULL, 'search_in', 'Search in', 'English', 'common', 'en'),
(NULL, 'phrase_text', 'Phrase Text', 'English', 'admin', 'en'),
(NULL, 'phrase_var', 'Phrase Variable Name', 'English', 'admin', 'en'),
(NULL, 'phrase_text_var', 'Phrase Text and Phrase Variable Name', 'English', 'admin', 'en'),
(NULL, 'search_for_text', 'Search for Text', 'English', 'common', 'en'),
(NULL, 'save', 'Save', 'English', 'common', 'en'),
(NULL, 'no_backlink', 'No backlink', 'English', 'common', 'en'),
(NULL, 'type', 'Type', 'English', 'admin', 'en'),
(NULL, 'impressions', 'Impressions', 'English', 'admin', 'en'),
(NULL, 'position', 'Position', 'English', 'common', 'en'),
(NULL, 'include_subcats', 'Including subcategories', 'English', 'admin', 'en'),
(NULL, 'other', 'Other', 'English', 'common', 'en'),
(NULL, 'target', 'Target', 'English', 'admin', 'en'),
(NULL, 'content', 'Content', 'English', 'admin', 'en'),
(NULL, 'choose_file_upload', 'Choose a file to upload', 'English', 'admin', 'en'),
(NULL, 'content_incorrect', 'Content can not be empty.', 'English', 'admin', 'en'),
(NULL, 'copy', 'Copy', 'English', 'common', 'en'),
(NULL, 'field_is_empty', '"{field}" is empty.', 'English', 'common', 'en'),
(NULL, 'broken_report_sent', 'A report has been sent to the site administrator.', 'English', 'frontend', 'en'),
(NULL, 'report', 'Report', 'English', 'common', 'en'),
(NULL, 'close', 'Close', 'English', 'common', 'en'),
(NULL, 'report_as_broken', 'Report the link {lurl} as being broken.', 'English', 'frontend', 'en'),
(NULL, 'do_you_want_report_broken', 'Do you want to report broken listing?', 'English', 'frontend', 'en'),
(NULL, 'remote_host', 'Remote host(IP more preferred)', 'English', 'admin', 'en'),
(NULL, 'remote_db', 'Remote database', 'English', 'admin', 'en'),
(NULL, 'remote_user', 'Remote username', 'English', 'admin', 'en'),
(NULL, 'remote_pass', 'Remote password', 'English', 'admin', 'en'),
(NULL, 'remote_prefix', 'Remote table prefix', 'English', 'admin', 'en'),
(NULL, 'import_box', 'Importing', 'English', 'admin', 'en'),
(NULL, 'manage_cache', 'Manage Cache', 'English', 'admin', 'en'),
(NULL, 'ascii_required', 'Only alphanumeric ASCII characters are allowed', 'English', 'common', 'en'),
(NULL, '1', 'Not available', 'English', 'frontend', 'en'),
(NULL, 'expire', 'Expire', 'English', 'common', 'en'),
(NULL, 'vote', 'Vote', 'English', 'common', 'en'),
(NULL, 'error_invalid_path', 'Invalid category path', 'English', 'admin', 'en'),
(NULL, 'tree', 'Tree', 'English', 'admin', 'en'),
(NULL, 'category_cannot_be_moved', 'This category cannot be moved to its child category or to itself: {move_to}', 'English', 'admin', 'en'),
(NULL, 'oops', 'Oops!', 'English', 'common', 'en'),
(NULL, 'folder_incorrect_permissions', 'Sorry, you have not set necessary permissions. Please set writable permissions for the following directory {name}', 'English', 'common', 'en'),
(NULL, 'generated_path_exists', 'Generated path: <i>{name}</i> already exists please specify another path or change your title slightly', 'English', 'admin', 'en'),
(NULL, 'expire_date', 'Expire date', 'English', 'common', 'en'),
(NULL, 'random_listings', 'Random listings', 'English', 'frontend', 'en'),
(NULL, 'image_keepratio', 'Keep image ratio', 'English', 'admin', 'en'),
(NULL, 'total_votes', 'Total <b>{num}</b> votes', 'English', 'common', 'en'),
(NULL, 'category_cannot_be_copied', 'This category cannot be copied to its child category or to itself: {copy_to}', 'English', 'admin', 'en'),
(NULL, 'suggest_category', 'Suggest Category', 'English', 'common', 'en'),
(NULL, 'plugin_uninstalled', 'Selected plugin uninstalled successfully', 'English', 'admin', 'en'),
(NULL, 'uninstall', 'Uninstall', 'English', 'admin', 'en'),
(NULL, 'plugin_installed', 'Plugin successfully installed', 'English', 'admin', 'en'),
(NULL, 'import_and_install', 'Import & install', 'English', 'admin', 'en'),
(NULL, 'file_doesnt_exist', 'File doesn''t exist', 'English', 'admin', 'en'),
(NULL, 'import_plugin_from_server', 'Import plugin installer file from this server (specify an absolute path). You can also type an URL.', 'English', 'admin', 'en'),
(NULL, 'import_plugin_installer', 'Upload plugins installer XML file (in most cases install.xml)', 'English', 'admin', 'en'),
(NULL, 'active_plugins', 'Active plugins', 'English', 'admin', 'en'),
(NULL, 'plugins', 'Plugins', 'English', 'admin', 'en'),
(NULL, 'parent_category', 'Parent category', 'English', 'common', 'en'),
(NULL, 'manage_blocks', 'Manage Blocks', 'English', 'admin', 'en'),
(NULL, 'block', 'Block', 'English', 'admin', 'en'),
(NULL, 'no_blocks', 'There is no blocks', 'English', 'admin', 'en'),
(NULL, 'add_block', 'Add Block', 'English', 'admin', 'en'),
(NULL, 'edit_block', 'Edit Block', 'English', 'admin', 'en'),
(NULL, 'contents', 'Contents', 'English', 'admin', 'en'),
(NULL, 'block_created', 'Block created', 'English', 'admin', 'en'),
(NULL, 'broken_listings', 'Broken Listings', 'English', 'admin', 'en'),
(NULL, 'banned_listings', 'Banned listings', 'English', 'admin', 'en'),
(NULL, 'nonrecip_listings', 'Non-reciprocal Listings', 'English', 'admin', 'en'),
(NULL, 'reciprocal_listings', 'Reciprocal Listings', 'English', 'admin', 'en'),
(NULL, 'create_category', 'Create Category', 'English', 'admin', 'en'),
(NULL, 'create_listing', 'Create Listing', 'English', 'admin', 'en'),
(NULL, 'whoisonline', 'Who is online right now', 'English', 'admin', 'en'),
(NULL, 'create_admin', 'Create Admin', 'English', 'admin', 'en'),
(NULL, 'plugin', 'Plugin', 'English', 'admin', 'en'),
(NULL, 'manage_plugins', 'Manage Plugins', 'English', 'admin', 'en'),
(NULL, 'blocks', 'Blocks', 'English', 'admin', 'en'),
(NULL, 'admin_comment', 'Admin comment', 'English', 'admin', 'en'),
(NULL, 'searchable', 'Searchable', 'English', 'common', 'en'),
(NULL, 'file_types', 'Allowed file types (comma separated values (don''t include point), example: pdf, doc, odf, mov)', 'English', 'common', 'en'),
(NULL, 'fulltext_search', 'Fulltext search', 'English', 'admin', 'en'),
(NULL, 'section', 'Search section', 'English', 'common', 'en'),
(NULL, 'manage_sections', 'Manage Search sections', 'English', 'admin', 'en'),
(NULL, 'sections', 'Search sections', 'English', 'common', 'en'),
(NULL, 'section_added', 'Section added', 'English', 'admin', 'en'),
(NULL, 'section_exists', 'Section exists', 'English', 'admin', 'en'),
(NULL, 'contains', 'Contains', 'English', 'common', 'en'),
(NULL, 'where', 'Where', 'English', 'common', 'en'),
(NULL, 'search_match', 'Match', 'English', 'common', 'en'),
(NULL, 'relevance', 'Relevance', 'English', 'common', 'en'),
(NULL, 'perpage', 'Per page', 'English', 'common', 'en'),
(NULL, 'output_settings', 'Output settings', 'English', 'common', 'en'),
(NULL, 'no_sections', 'No sections created. Please <a href="manage-sections.php?action=add">click here</a> to create a section.', 'English', 'admin', 'en'),
(NULL, 'admins_deleted', 'Selected admins successfully deleted', 'English', 'admin', 'en'),
(NULL, 'access_denied', '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">\n<html><head>\n<title>403 Forbidden</title>\n</head><body>\n<h1>Forbidden</h1>\n<p>You don\'t have permission to access this page on this server.</p>\n<a href="javascript:history.go(-1)">&laquo; Back</a>\n</body></html>', 'English', 'admin', 'en'),
(NULL, 'deep_links', 'Deep links', 'English', 'common', 'en'),
(NULL, 'too_big_value', 'Too big value for "<i>{name}</i>"', 'English', 'admin', 'en'),
(NULL, 'search_listings', 'Search Listings', 'English', 'admin', 'en'),
(NULL, 'approval_accounts', 'Approval Accounts', 'English', 'admin', 'en'),
(NULL, 'active_accounts', 'Active accounts', 'English', 'admin', 'en'),
(NULL, 'search_account', 'Search Account', 'English', 'admin', 'en'),
(NULL, 'create_account', 'Create Account', 'English', 'admin', 'en'),
(NULL, 'filter_by_status', 'Filter by status', 'English', 'admin', 'en'),
(NULL, 'filter_by_state', 'Filter by state', 'English', 'admin', 'en'),
(NULL, 'active_listings', 'Active Listings', 'English', 'admin', 'en'),
(NULL, 'approval_categories', 'Approval Categories', 'English', 'admin', 'en'),
(NULL, 'active_categories', 'Active Categories', 'English', 'admin', 'en'),
(NULL, 'start_search', 'Start search', 'English', 'common', 'en'),
(NULL, 'confirmation', 'Confirmation', 'English', 'common', 'en'),
(NULL, 'na', 'n/a', 'English', 'common', 'en'),
(NULL, 'loading', 'Loading ...', 'English', 'common', 'en'),
(NULL, 'phrase_added', 'Phrase added', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete', 'Are you sure you want to delete', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_resend_confirmation', 'Are you sure you want to resend confirmation email?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_blocks', 'Are you sure you want to delete selected blocks?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_this_block', 'Are you sure you want to delete this block?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_this_category', 'Are you sure you want to delete this category? All its subcategories and listings will be deleted too!', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_categories', 'Are you sure you want to delete selected categories? All its subcategories and listings will be deleted too!', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_admins', 'Are you sure you want to delete selected administrators?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_comments', 'Are  you sure you want to delete selected comments?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_this_admin', 'Are you sure you want to delete this administrator?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_this_listing', 'Are you sure you want to delete this listing?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_this_listing_featured', 'Are you sure you don''t want to have this listing featured?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_remove_featured', 'Are you sure you don''t want to have this listings as featured?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_this_listing_partner', 'Are you sure you want to mark this listing as partner', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_remove_partner', 'Are you sure you don''t want to have this listing as partner', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_remove_crosslink', 'Are you sure you want to remove this cross link?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_this_account', 'Are you sure you want to delete this account?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_this_listing_field', 'Are you sure you want to delete this listing field? Note: Whole column including its data will be deleted!', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_this_page', 'Are you sure you want to delete this page?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_this_comment', 'Are you sure you want to delete this comment?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_category_relationship', 'Are you sure you want to remove category relationship?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_category_crossing', 'Are you sure you want to delete crossed category?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_remove_selected_from_featured', 'Are you sure you want to remove featured mark from selected listings?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_listings', 'Are you sure you want to delete selected listings? Note: There is no Undo!', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_accounts', 'Are you sure you want to delete selected accounts?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_this_page', 'Are you sure you want to delete this page?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_pages', 'Are you sure you want to delete selected pages?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_logout', 'Are you sure you want to logout?', 'English', 'admin', 'en'),
(NULL, 'edit_category', 'Edit Category', 'English', 'admin', 'en'),
(NULL, 'lock_status', 'Lock status', 'English', 'admin', 'en'),
(NULL, 'change', 'change', 'English', 'common', 'en'),
(NULL, 'listing_category', 'Listing category', 'English', 'common', 'en'),
(NULL, 'error_login', 'Either login or password is invalid', 'English', 'common', 'en'),
(NULL, 'user_default', 'User default', 'English', 'common', 'en'),
(NULL, 'active_listings_count', 'ACTIVE LISTINGS COUNT', 'English', 'admin', 'en'),
(NULL, 'recount', 'recount', 'English', 'admin', 'en'),
(NULL, 'categories_relation', 'CATEGORIES RELATION', 'English', 'admin', 'en'),
(NULL, 'repair', 'repair', 'English', 'admin', 'en'),
(NULL, 'listings_and_categories', 'LISTINGS AND CAT-IES', 'English', 'admin', 'en'),
(NULL, 'find_and_delete', 'delete orphan', 'English', 'admin', 'en'),
(NULL, 'orphan_listings_deleted', '{num} orphan listing(s) deleted!', 'English', 'admin', 'en'),
(NULL, 'no_orphan_listings', 'No orphan listings found', 'English', 'admin', 'en'),
(NULL, 'no_orphan_categories', 'No orphan categories found', 'English', 'admin', 'en'),
(NULL, 'orphan_categories_deleted', '{num} orphan categories deleted', 'English', 'admin', 'en'),
(NULL, 'admin_activity_expired', 'Admin activity expired', 'English', 'admin', 'en'),
(NULL, 'message', 'Message', 'English', 'admin', 'en'),
(NULL, 'source_file', 'source file', 'English', 'admin', 'en'),
(NULL, 'line', 'Line', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_phrases', 'Are you sure you want to delete selected phrases?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_log_messages', 'Are you sure you want to delete selected log messages?', 'English', 'admin', 'en'),
(NULL, 'language_already_exists', 'Language already exists', 'English', 'admin', 'en'),
(NULL, 'bad_iso', 'Bad country - ISO code.', 'English', 'admin', 'en'),
(NULL, 'copy_default_language_to', 'Copy default language [<b> [lang] </b>] to ', 'English', 'admin', 'en'),
(NULL, 'repair_tables', 'REPAIR TABLES', 'English', 'admin', 'en'),
(NULL, 'language_deleted', 'Selected language successfully deleted', 'English', 'admin', 'en'),
(NULL, 'crossed_deleted', 'Selected crossing successfully deleted', 'English', 'admin', 'en'),
(NULL, 'related_deleted', 'Selected relations successfully deleted', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_language', 'Are you sure you want to delete selected language? Note: All phrases will be deleted. There is no undo!', 'English', 'admin', 'en'),
(NULL, 'two_language_required_to_compare', 'At least two languages required to compare them', 'English', 'admin', 'en'),
(NULL, 'all_fields', 'All fields', 'English', 'admin', 'en'),
(NULL, 'compare', 'Compare', 'English', 'admin', 'en'),
(NULL, 'differences_found', '<b>{num}</b> differences found. Compared by <b>{category}</b>', 'English', 'admin', 'en'),
(NULL, 'add_new_values', 'Add new values', 'English', 'admin', 'en'),
(NULL, 'phrases_added', 'Phrases added', 'English', 'admin', 'en'),
(NULL, 'copy_with_listings', 'Do you want to copy categories with listings?', 'English', 'admin', 'en'),
(NULL, 'tried_disapprove_current_admin', 'You''ve tried to disapprove current admin which is couldn''t be done.', 'English', 'admin', 'en'),
(NULL, 'tried_delete_current_admin', 'You''ve tried to delete current admin which is couldn''t be done.', 'English', 'admin', 'en'),
(NULL, 'listings_added', 'Listings added', 'English', 'admin', 'en'),
(NULL, 'manage_acl', 'Manage ACL', 'English', 'admin', 'en'),
(NULL, 'acl_created', 'Acl created', 'English', 'admin', 'en'),
(NULL, 'visible_on_pages', 'Visible on pages', 'English', 'admin', 'en'),
(NULL, 'visual_manage', 'Visual Manage', 'English', 'admin', 'en'),
(NULL, 'exit', 'Exit', 'English', 'common', 'en'),
(NULL, 'youre_in_manage_mode', 'You''re in manage mode', 'English', 'frontend', 'en'),
(NULL, 'show_header', 'Show header', 'English', 'admin', 'en'),
(NULL, 'sticky', 'Sticky', 'English', 'admin', 'en'),
(NULL, '_check_status_', '- Check Status -', 'English', 'admin', 'en'),
(NULL, 'destination_valid', 'Destination Valid', 'English', 'admin', 'en'),
(NULL, 'destination_broken', 'Destination Broken', 'English', 'admin', 'en'),
(NULL, 'reciprocal_broken', 'Reciprocal Broken', 'English', 'admin', 'en'),
(NULL, 'regular', 'Regular', 'English', 'admin', 'en'),
(NULL, '_type_', '- Type -', 'English', 'admin', 'en'),
(NULL, 'all', 'All', 'English', 'admin', 'en'),
(NULL, 'code', 'Code', 'English', 'common', 'en'),
(NULL, 'enable_no_follow', 'Enable No-Follow', 'English', 'admin', 'en'),
(NULL, 'lock_category', 'Lock category', 'English', 'admin', 'en'),
(NULL, 'number_of_columns', 'Number of Columns', 'English', 'admin', 'en'),
(NULL, 'number_of_neighbours', 'Number of Neighbours', 'English', 'admin', 'en'),
(NULL, 'all_neighbours', 'All neighbours', 'English', 'admin', 'en'),
(NULL, 'number_of_neigh_tip', '<i>0</i> - do not display neighbour categories', 'English', 'admin', 'en'),
(NULL, 'number_of_cols_tip', 'value should be more than 0', 'English', 'admin', 'en'),
(NULL, 'custom', 'Custom', 'English', 'admin', 'en'),
(NULL, 'quick_links', 'Quick links', 'English', 'common', 'en'),
(NULL, 'add_as_crossed_to_other_categories', 'Add also to other categories as crossed', 'English', 'common', 'en'),
(NULL, 'suspend', 'Suspend', 'English', 'common', 'en'),
(NULL, 'no_listings_in_category', 'No listings in this category. <a href="suggest-listing.php?id={category_id}" style="font-weight: bold;">Click here</a> to add listing to <strong>{category_title}</strong>.', 'English', 'admin', 'en'),
(NULL, 'wrong_file_extension', 'Wrong file extension for {field} field. Please use one of the following extensions <i>{allowed}</i>', 'English', 'frontend', 'en'),
(NULL, 'global', 'Global', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_phrase', 'Are you sure you want to delete this phrase?', 'English', 'admin', 'en'),
(NULL, 'block_deleted', 'Selected block successfully deleted', 'English', 'admin', 'en'),
(NULL, 'blocks_deleted', 'Selected blocks successfully deleted', 'English', 'admin', 'en'),
(NULL, 'leave_empty_to_show_everywhere', 'Leave empty to show everywhere', 'English', 'admin', 'en'),
(NULL, 'nothing_found', 'Nothing found', 'English', 'admin', 'en'),
(NULL, 'compose', 'Compose', 'English', 'admin', 'en'),
(NULL, 'bind_to_categories', 'Bind to categories', 'English', 'admin', 'en'),
(NULL, 'start_date', 'Start date', 'English', 'admin', 'en'),
(NULL, 'end_date', 'End date', 'English', 'admin', 'en'),
(NULL, 'password_restore_description', 'If you see this page that means that you''ve received an email with\r\n\r\nthis URL.\r\n\r\nThis page is intended to set a new password for your administration\r\n\r\naccount.\r\n\r\n<div style="color:red;padding:10px;border:1px solid gray"><p>It is assumed that you know your username (login)</p><p>There is only one attempt!!!</p><p>Otherwise you''ll have to request restoration again (in login page)</p></div>', 'English', 'admin', 'en'),
(NULL, 'new_password', 'New password', 'English', 'admin', 'en'),
(NULL, 'locked', 'Locked', 'English', 'admin', 'en'),
(NULL, 'no_follow', 'No follow', 'English', 'admin', 'en'),
(NULL, 'categories_deleted', 'Categories deleted', 'English', 'admin', 'en'),
(NULL, 'category_deleted', 'Category deleted', 'English', 'admin', 'en'),
(NULL, 'listing_moved', 'Listing successfully moved', 'English', 'admin', 'en'),
(NULL, 'listings_moved', 'Listings successfully moved', 'English', 'admin', 'en'),
(NULL, 'listing_copied', 'Listing successfully copied', 'English', 'admin', 'en'),
(NULL, 'listings_copied', 'Listings successfully copied', 'English', 'admin', 'en'),
(NULL, 'listings_deleted', 'Selected listings successfully deleted', 'English', 'admin', 'en'),
(NULL, 'listing_deleted', 'Listing deleted successfully', 'English', 'admin', 'en'),
(NULL, 'go_back', 'Go back', 'English', 'common', 'en'),
(NULL, 'listing_remove_reason', 'You can type removing reason (included to email) <br /><i>no affect for cross links</i>', 'English', 'admin', 'en'),
(NULL, 'ok', 'Ok', 'English', 'common', 'en'),
(NULL, 'multi_language', 'Multilingual', 'English', 'admin', 'en'),
(NULL, 'editor_not_showed_listing_inactive', 'For security reasons html editor is showed only if status is  active and HTML is allowed from configuration.', 'English', 'admin', 'en'),
(NULL, 'crossed_to', 'Crossed to', 'English', 'common', 'en'),
(NULL, 'main_cat', 'main', 'English', 'admin', 'en'),
(NULL, 'move_listing', 'Move listing', 'English', 'frontend', 'en'),
(NULL, 'listing_returned', 'Listing was returned back!', 'English', 'common', 'en'),
(NULL, 'listing_move_confirmation', 'You are going to move listing to another category, please be sure you want do this. If listing has active status it will be disapproved.', 'English', 'frontend', 'en'),
(NULL, 'listing_fin_move_confirmation', 'Are you sure you want to move this listing?', 'English', 'frontend', 'en'),
(NULL, 'moved_from', 'Moved From', 'English', 'admin', 'en'),
(NULL, 'update_pagerank', 'Update pagerank', 'English','admin','en'),
(NULL, 'rate_this', 'Rate this {rate}', 'English', 'frontend', 'en'),
(NULL, 'are_you_sure_to_cancel_listing_moving', 'Are you sure you want cancel account listing moving?', 'English', 'admin', 'en'),
(NULL, 'add_page', 'Add Page', 'English', 'admin', 'en'),
(NULL, 'inventory_menu', 'Inventory Menu', 'English', 'admin', 'en'),
(NULL, 'edit_page', 'Edit Page', 'English', 'admin', 'en'),
(NULL, 'page_added', 'Page added', 'English', 'admin', 'en'),
(NULL, 'unique_key', 'UNIQUE key', 'English', 'admin', 'en'),
(NULL, 'modrewrite_url_thesame', 'Non MOD-REWRITE URL the same', 'English', 'admin', 'en'),
(NULL, 'modrewrite_url', 'Non MOD-REWRITE URL', 'English', 'admin', 'en'),
(NULL, 'apply', 'Apply', 'English','common','en'),
(NULL, 'favorites_added', 'The Listing has been added to favorites.', 'English', 'common', 'en'),
(NULL, 'view_my_favorites', 'View My favorites', 'English', 'common', 'en'),
(NULL, 'remove_from_favorites', 'Remove from favorites', 'English', 'common', 'en'),
(NULL, 'favorites_removed', 'The Listing has been removed from favorites.', 'English', 'common', 'en'),
(NULL, 'add_to_favorites', 'Add To Favorites', 'English', 'common', 'en'),
(NULL, 'my_favorite_listings', 'My favorite listings', 'English', 'common', 'en'),
(NULL, 'install', 'Install', 'English','admin','en'),
(NULL, 'slogan', 'Want to build a Directory<br />you can be proud of?', 'English','frontend', 'en'),
(NULL, 'comment_approval', 'Your comment is waiting for approval.', 'English', 'frontend', 'en'),
(NULL, 'edit_comment', 'Edit comment', 'English', 'admin', 'en'),
(NULL, 'add_listing_comment', 'Add Listing Comment', 'English', 'admin', 'en'),
(NULL, 'recip_recheck', 'Recheck reciprocal', 'English','admin','en'),
(NULL, 'error_url', 'You''ve entered invalid URL', 'English', 'common', 'en'),
(NULL, 'plugin_is_up_to_date', 'Plugin is up to date', 'English', 'admin', 'en'),
(NULL, 'error_occurred_while_plugin_updating', 'Unknown error occured while updating plugin', 'English', 'admin', 'en'),
(NULL, 'vote_cast', 'vote cast', 'English', 'frontend', 'en'),
(NULL, 'vote_casts', 'vote casts', 'English', 'frontend', 'en'),
(NULL, 'changelog', 'Changelog', 'English', 'admin', 'en'),
(NULL, 'upgrade_instructions', 'Upgrade instructions', 'English', 'admin', 'en'),
(NULL, 'new_version_of_plugin_available', 'New version of plugin is available do you wish to update it? <input type="button" value="{yes}" onclick="updatePlugin(''{urlToGetNewVersion}'', ''{plugin}'', ''{updateInstructions}'')" />&nbsp;&nbsp;<input type="button" value="{no}" onclick="$(''#notification'').hide()" />', 'English', 'admin', 'en'),
(NULL, 'unknown_plugin', 'This plugin is unknown', 'English', 'admin', 'en'),
(NULL, 'get_new_version', 'Get new version', 'English', 'admin', 'en'),
(NULL, 'version', 'Version', 'English', 'admin', 'en'),
(NULL, 'latest_version', 'Latest version', 'English', 'admin', 'en'),
(NULL, 'upgrade_tip', 'You can use this page also if you want to upgrade existing plugin. Just specify install.xml file and press "{import_and_install}" button.', 'English', 'admin', 'en'),
(NULL, 'existing_plugins', 'EXISTING PLUGINS', 'English', 'admin', 'en'),
(NULL, 'no_plugins', 'No plugins.', 'English', 'admin', 'en'),
(NULL, 'install_upgrade', 'Install or upgrade', 'English', 'admin', 'en'),
(NULL, 'search_criterias', 'Search Criterias', 'English', 'frontend', 'en'),
(NULL, 'listings_legend', 'listings waiting for administrator approval', 'English', 'frontend', 'en'),
(NULL, 'filter_by_type', 'Filter by type', 'English', 'admin', 'en'), 
(NULL, 'check_updates', 'Check for updates', 'English', 'admin', 'en'),
(NULL, 'multicross', 'Multicross', 'English', 'admin', 'en'),
(NULL, 'add_favorite', 'Do you want to add the listing to favorites?', 'English', 'frontend', 'en'),
(NULL, 'remove_favorite', 'Do you want to remove the listing from favorites?', 'English', 'frontend', 'en'),
(NULL, 'mcross_warning', 'You can not cross one more link', 'English', 'common', 'en'),
(NULL, 'cross_warning', 'You can not cross listing into main category', 'English', 'common', 'en'),
(NULL, 'page_title_index', 'Home', 'English', 'page', 'en'),
(NULL, 'page_title_search', 'Search', 'English', 'page', 'en'),
(NULL, 'page_title_new_listings', 'New Listings', 'English', 'page', 'en'),
(NULL, 'page_title_top_listings', 'Top Listings', 'English', 'page', 'en'),
(NULL, 'page_title_popular_listings', 'Popular Listings', 'English', 'page', 'en'),
(NULL, 'page_title_random_listings', 'Random Listings', 'English', 'page', 'en'),
(NULL, 'page_title_suggest_listing', 'Suggest Listing', 'English', 'page', 'en'),
(NULL, 'page_title_suggest_category', 'Suggest Category', 'English', 'page', 'en'),
(NULL, 'page_title_edit_account', 'Edit Account', 'English', 'page', 'en'),
(NULL, 'page_title_favorites_listings', 'Favorites', 'English', 'page', 'en'),
(NULL, 'page_title_account_listings', 'My Listings', 'English', 'page', 'en'),
(NULL, 'page_title_about', 'About Us', 'English', 'page', 'en'),
(NULL, 'page_title_terms', 'Terms of Use', 'English', 'page', 'en'),
(NULL, 'page_title_help', 'Help', 'English', 'page', 'en'),
(NULL, 'page_title_policy', 'Privacy Policy', 'English', 'page', 'en'),
(NULL, 'cannot_move_due_to_crosslink', 'Listing moving rejected because it''s cross link exists on the destination category', 'English', 'admin', 'en'),
(NULL, 'page_title_advertise', 'Advertise Us', 'English', 'page', 'en'),
(NULL, 'listings_submission_disabled', 'Listings submission is disabled by adminstrator.', 'English', 'frontend', 'en'),
(NULL, 'plugin_successfully_updated', 'Plugin successfully updated', 'English', 'admin', 'en'),
(NULL, 'plugin_upload_following_files', 'This plugin goes with the following files please upload them to the appropriate folders. <ul>{files}</ul>', 'English', 'admin', 'en'),
(NULL, 'plugin_remove_following_files', 'This plugin goes with the following files please delete them to completely remove the plugin. <ul>{files}</ul>', 'English', 'admin', 'en'),
(NULL, 'error_email', 'Make sure you entered valid email.', 'English', 'common', 'en'),
(NULL, 'update_plugin', 'Update plugin', 'English', 'admin', 'en'),
(NULL, 'thankyou_tail', '<p>Please read our letter with further instructions.</p>', 'English','common','en'),
(NULL, 'thankyou_head', '<p>Below is the information you submitted so far. You will be able to extend and edit this information via your member account.</p><p><span style=\"color: #F00; font-weight: bold;\">IMPORTANT!</span> Your account password has been sent to the following email address:</p>', 'English','common','en'),
(NULL, 'reg_confirmed', 'Account confirmed. Please sign in.', 'English','common','en'),
(NULL, 'reg_confirm_err', 'Error. You key not found.', 'English','common','en'),
(NULL, 'reg_confirmation', 'Registration Confirmation', 'English','common','en'),
(NULL, 'confirm', 'Confirm', 'English','common','en'),
(NULL, 'error_javascript', 'You have to enable JavaScript in your browser.', 'English', 'common', 'en'),
(NULL, 'redraw_captcha', 'Click on image to redraw.', 'English', 'frontend', 'en'),
(NULL, 'text_captcha', 'Please input letters you see on the image.', 'English', 'frontend', 'en'),
(NULL, 'favorites_listings', 'Favorite Listings', 'English', 'frontend', 'en'),
(NULL, 'image_deleted', 'Image deleted', 'English', 'admin', 'en'),
(NULL, 'notice_field_type_empty', 'You have to select the field type.', 'English', 'admin', 'en'),
(NULL, 'page_title', 'Page title', 'English', 'admin', 'en'),
(NULL, 'error_min_textarea', 'Your {field} length should be more than {num} symbols.', 'English', 'frontend', 'en'),
(NULL, 'error_max_textarea', 'Your {field} length should be less than {num} symbols.', 'English', 'frontend', 'en'),
(NULL, 'field_max_length', 'Max length', 'English', 'admin', 'en'),
(NULL, 'field_min_length', 'Min length', 'English', 'admin', 'en'),
(NULL, 'characters_count', 'Characters count', 'English', 'frontend', 'en'),
(NULL, 'no_file', 'There is no file', 'English', 'admin', 'en'),
(NULL, 'plugin_errors', 'Plugin errors', 'English', 'admin', 'en'),
(NULL, 'captcha', 'Captcha', 'English', 'frontend', 'en'),
(NULL, 'fields', 'Fields', 'English', 'frontend', 'en'),
(NULL, 'reg_confirmed_pending', 'Account confirmed. Your account is still pending approval by the administrator.', 'English', 'frontend', 'en'),
(NULL, 'rememberme', 'Remember Me', 'English', 'frontend', 'en'),
(NULL, 'tooltip', 'Tooltip', 'English', 'admin', 'en'),
(NULL, 'field_min_length', 'Min length', 'English', 'admin', 'en'),
(NULL, 'field_max_length', 'Max length', 'English', 'admin', 'en'),
(NULL, 'new_account', 'New account', 'English', 'admin', 'en'),
(NULL, 'cross', 'Cross', 'English', 'admin', 'en'),
(NULL, 'listings_crossed', 'Listings successfully crossed', 'English', 'admin', 'en'),
(NULL, 'listing_crossed', 'Listing successfully crossed', 'English', 'admin', 'en'),
(NULL, 'wyswyg_editor', 'WYSWYG editor', 'English', 'admin', 'en'),
(NULL, 'manage_transactions', 'Manage Transactions', 'English', 'admin', 'en'),
(NULL, 'edit_transaction', 'Edit transaction', 'English', 'admin', 'en'),
(NULL, 'create_transaction', 'Create transaction', 'English', 'admin', 'en'),
(NULL, 'inactive', 'Inactive', 'English', 'admin', 'en'),
(NULL, 'error_username_incorrect', 'Make sure you entered valid username.', 'English', 'frontend', 'en'),
(NULL, 'unconfirmed', 'Unconfirmed', 'English', 'common', 'en'),
(NULL, 'thumb_width', 'Thumbnail width', 'English', 'admin', 'en'),
(NULL, 'thumb_height', 'Thumbnail height', 'English', 'admin', 'en'),
(NULL, 'resize_mode', 'Resize mode', 'English', 'admin', 'en'),
(NULL, 'expiration_period', 'Expiration Period', 'English', 'admin', 'en'),
(NULL, 'expiration_period_incorrect', 'Expiration period incorrect. It should be numeric.', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_this_transaction', 'Are you sure to delete this transaction?', 'English', 'admin', 'en'),
(NULL, 'category_icons', 'Category Icons', 'English', 'admin', 'en'),
(NULL, 'icon', 'Icon', 'English', 'admin', 'en'),
(NULL, 'choose_icon', 'Choose icon', 'English', 'admin', 'en'),
(NULL, 'remove_icon', 'Remove Icon', 'English', 'admin', 'en'),
(NULL, 'admin_check_new_password', 'Please check your email for confirmation link.', 'English', 'admin', 'en'),
(NULL, 'admin_new_password_sent', 'The new password has been sent to your email. Please check your email.', 'English', 'admin', 'en'),
(NULL, 'tab_content_help', '<h2>Useful Links:</h2>\r\n<a href="http://www.esyndicat.com/docs/glossary.html" target="_blank">Glossary Of Terms</a><br />\r\n<a href="http://www.esyndicat.com/desk/" target="_blank">HelpDesk</a><br />\r\n<a href="http://www.esyndicat.com/docs/" target="_blank">Documentation</a><br /><br />\r\n\r\nIf you have any questions please ask in the support <a href="http://www.esyndicat.com/forum/" target="_blank">forums</a> or <a href="http://www.esyndicat.com/desk/" target="_blank">helpdesk</a>.', 'English', 'admin', 'en'),
(NULL, 'tab_title_help', 'Help', 'English', 'admin', 'en'),
(NULL, 'tab_content_search', '<form action="controller.php?file=listings" method="get">\r\n<table>\r\n<tr>\r\n	<td width="115">Search Listings:&nbsp;</td>\r\n	<td>\r\n		<input type="hidden" name="file" value="listings" />\r\n		<input type="text" class="common question" size="23" name="quick_search" id="quick_search_listing" />\r\n		<input type="submit" class="common" value="Search" />\r\n	</td>\r\n</tr>\r\n</table>\r\n</form>\r\n\r\n<form action="controller.php?file=categories" method="get">\r\n<table>\r\n<tr>\r\n	<td width="115">Search Categories:&nbsp;</td>\r\n	<td>\r\n		<input type="hidden" name="file" value="categories" />\r\n		<input type="text" class="common question" size="23" name="quick_search" id="quick_search_category" />\r\n		<input type="submit" class="common" value="Search" />\r\n	</td>\r\n</tr>\r\n</table>\r\n</form>\r\n\r\n<form action="controller.php?file=accounts" method="get">\r\n<table>\r\n<tr>\r\n	<td width="115">Search Accounts:&nbsp;</td>\r\n	<td>\r\n		<input type="hidden" name="file" value="accounts" />\r\n		<input type="text" class="common question" size="23" name="quick_search" id="quick_search_account" />\r\n		<input type="submit" class="common" value="Search" />\r\n	</td>\r\n</tr>\r\n</table>\r\n</form>', 'English', 'admin', 'en'),
(NULL, 'tab_title_search', 'Search', 'English', 'admin', 'en'),
(NULL, 'page_key_incorrect', 'Page key is incorrect.', 'English', 'admin', 'en'),
(NULL, 'page_menu_incorrect', 'Page menus is incorrect.', 'English', 'admin', 'en'),
(NULL, 'export_tables_incorrect', 'Please select tables for export.', 'English', 'admin', 'en'),
(NULL, 'incorrect_permissions', 'Please check permissions.', 'English', 'admin', 'en'),
(NULL, 'incorrect_username', 'Please input correct username.', 'English', 'admin', 'en'),
(NULL, 'update_msg', 'eSyndiCat Directory {version} is avaiable. <a href="controller.php?file=update">Please update now.</a>', 'English', 'admin', 'en'),
(NULL, 'update_version', 'Update Version', 'English', 'admin', 'en'),
(NULL, 'listing_fields', 'Listing Fields', 'English', 'admin', 'en'),
(NULL, 'search_sections', 'Search Sections', 'English', 'admin', 'en'),
(NULL, 'custom_url', 'Custom SEO URL', 'English', 'admin', 'en'),
(NULL, 'custom_url_exist', 'Page with such custom SEO URL already exist.', 'English', 'admin', 'en'),
(NULL, 'readme', 'Readme', 'English', 'admin', 'en'),
(NULL, 'reset_all', 'Reset all', 'English', 'admin', 'en'),
(NULL, 'reset_backup_alert', 'Please create a backup before resetting any table.', 'English', 'admin', 'en'),
(NULL, 'reset_success', 'Reset has been successful done.', 'English', 'admin', 'en'),
(NULL, 'reset_choose_table', 'Please choose any table.', 'English', 'admin', 'en'),
(NULL, 'esyndicat_news', 'eSyndiCat News', 'English', 'admin', 'en'),
(NULL, 'auto_generate_password', 'Auto generate password', 'English', 'frontend', 'en'),
(NULL, 'available_plugins', 'Available Plugins', 'English', 'admin', 'en'),
(NULL, 'installed_plugins', 'Installed Plugins', 'English', 'admin', 'en'),
(NULL, 'connection_information', 'Connection Information', 'English', 'admin', 'en'),
(NULL, 'hostname', 'Hostname', 'English', 'admin', 'en'),
(NULL, 'update', 'Update', 'English', 'admin', 'en'),
(NULL, 'update_notice', 'Before updating please backup your database and files.', 'English', 'admin', 'en'),
(NULL, 'no_updates', 'There is no any updates.', 'English', 'admin', 'en'),
(NULL, 'can_not_get_method', 'Can not get the coping method.', 'English', 'admin', 'en'),
(NULL, 'script_success_updated', 'Script has been updated successfully. Your current version is {version}.', 'English', 'admin', 'en'),
(NULL, 'url_package_empty', 'The package URL is empty.', 'English', 'admin', 'en'),
(NULL, 'get_package_content_error', 'Error occurs while getting package content.', 'English', 'admin', 'en'),
(NULL, 'unpack_error', 'Error occurs while unpacking package.', 'English', 'admin', 'en'),
(NULL, 'ftp_details_error', 'Connection details are wrong.', 'English', 'admin', 'en'),
(NULL, 'ftp_connect_error', 'Can not connect to server.', 'English', 'admin', 'en'),
(NULL, 'ftp_login_error', 'Can not login as {username}.', 'English', 'admin', 'en'),
(NULL, 'license_empty ', 'Your License Number is empty. Please input your license number and save configuration <a href="{url}admin/controller.php?file=configuration">here</a>', 'English', 'admin', 'en'),
(NULL, 'update_overwrite_note', 'Please note. The update script will overwrite your existing files. If you have any modification please create a backup of your files before updating.<br /><br />Do you want to continue?', 'English', 'admin', 'en'),
(NULL, 'warning', 'WARNING', 'English', 'admin', 'en'),
(NULL, 'license_not_valid', 'Your license number is not valid. Please check it in the configuration section.', 'English', 'admin', 'en'),
(NULL, 'domain_not_valid', 'Your domain name is not valid.', 'English', 'admin', 'en'),
(NULL, 'listings_chart', 'Listings Chart', 'English', 'admin', 'en'),
(NULL, 'plugin_description', 'Description', 'English', 'admin', 'en'),
(NULL, 'plugin_changelog', 'Changelog', 'English', 'admin', 'en'),
(NULL, 'plugin_faq', 'FAQ', 'English', 'admin', 'en'),
(NULL, 'plugin_installation', 'Installation', 'English', 'admin', 'en'),
(NULL, 'plugin_notes', 'Notes', 'English', 'admin', 'en'),
(NULL, 'plugin_screenshots', 'Screenshots', 'English', 'admin', 'en'),
(NULL, 'plugin_documentation', 'Plugin Documentation', 'English', 'admin', 'en'),
(NULL, 'do_not_display_neighbours', 'Do not display neighbours', 'English', 'admin', 'en'),
(NULL, 'choose_importer', 'Choose Importer', 'English', 'admin', 'en'),
(NULL, 'database_name', 'Database Name', 'English', 'admin', 'en'),
(NULL, 'database_username', 'Database Username', 'English', 'admin', 'en'),
(NULL, 'database_password', 'Database Password', 'English', 'admin', 'en'),
(NULL, 'find_database', 'Find Database', 'English', 'admin', 'en'),
(NULL, 'database_prefix', 'Database Prefix', 'English', 'admin', 'en'),
(NULL, 'select', 'Select', 'English', 'admin', 'en'),
(NULL, 'database_host', 'Database Host', 'English', 'admin', 'en'),
(NULL, 'database_connection_error', 'Could not connect to database.', 'English', 'admin', 'en'),
(NULL, 'database_selection_error', 'An error occured while selecting database.', 'English', 'admin', 'en'),
(NULL, 'manage_importer', 'Manage Imports', 'English', 'admin', 'en'),
(NULL, 'convert_database_complete', 'Convert database successfully complete.', 'English', 'admin', 'en'),
(NULL, 'no_importers', 'There is no any importers.', 'English', 'admin', 'en'),
(NULL, 'import_report', 'Import Report', 'English', 'admin', 'en'),
(NULL, 'assign_account', 'Assign to account', 'English', 'admin', 'en'),
(NULL, 'existing_account', 'Existing account', 'English', 'admin', 'en'),
(NULL, 'dont_assign', 'Don not assign', 'English', 'admin', 'en'),
(NULL, 'xml_parse_error', 'Error occurs while parse XML file', 'English', 'admin', 'en'),
(NULL, 'xml_file_empty', 'XML file empty.', 'English', 'admin', 'en'),
(NULL, 'esyndicat_new_plugins', 'eSyndiCat New Plugins', 'English', 'admin', 'en'),
(NULL, 'quick_search_account_qtip', 'Please input account ID, username or email', 'English', 'admin', 'en'),
(NULL, 'id', 'ID', 'English', 'admin', 'en'),
(NULL, 'items_per_page', 'Items per page', 'English', 'admin', 'en'),
(NULL, 'do', 'Do!', 'English', 'admin', 'en'),
(NULL, 'error_saving_changes', 'Error saving changes...', 'English', 'admin', 'en'),
(NULL, 'filter', 'Filter', 'English', 'admin', 'en'),
(NULL, 'action', 'Action', 'English', 'admin', 'en'),
(NULL, 'action_confirm', 'Do you really want to {action} [ {listings} ] to {category} category?', 'English', 'admin', 'en'),
(NULL, 'view_logo', 'View Logo', 'English', 'admin', 'en'),
(NULL, 'site_logo_image_error', 'Error occurs while uploading site logo image.', 'English', 'admin', 'en'),
(NULL, 'wrong_image_type', 'Only following image types are allowed (<i>{types}</i>).', 'English', 'admin', 'en'),
(NULL, 'params_wrong', 'Params are wrong.', 'English', 'admin', 'en'),
(NULL, 'uploading_site_logo', 'Uploading Site Logo...', 'English', 'admin', 'en'),
(NULL, 'image_uploaded', '"Image {name} is successfully uploaded.', 'English', 'admin', 'en'),
(NULL, 'upload_site_logo', 'Upload Site Logo', 'English', 'admin', 'en'),
(NULL, 'upload', 'Upload', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_icons', 'Do you really want to remove selected icons?', 'English', 'admin', 'en'),
(NULL, 'select_icon', 'Select a icon', 'English', 'admin', 'en'),
(NULL, 'uploading_icon', 'Uploading Icon', 'English', 'admin', 'en'),
(NULL, 'upload_new_category_icon', 'Upload New Category Icon', 'English', 'admin', 'en'),
(NULL, 'htaccess_file', '.htaccess file', 'English', 'admin', 'en'),
(NULL, 'copy_to_clipboard', 'Copy to clipboard', 'English', 'admin', 'en'),
(NULL, 'select_logo', 'Select Site Logo', 'English', 'admin', 'en'),
(NULL, 'logo', 'Logo', 'English', 'admin', 'en'),
(NULL, 'add_new_phrase', 'Add new phrase?', 'English', 'admin', 'en'),
(NULL, 'add_one_more_phrase', 'Would you like to add one more phrase?', 'English', 'admin', 'en'),
(NULL, 'searching', 'Searching...', 'English', 'admin', 'en'),
(NULL, 'type_username_email', '-- type your username or email --', 'English', 'admin', 'en'),
(NULL, 'last_updated', 'Last Updated', 'English', 'admin', 'en'),
(NULL, 'error_while_doc_tabs', 'Error while getting doc tabs.', 'English', 'admin', 'en'),
(NULL, 'type_account_username', 'Type account username', 'English', 'admin', 'en'),
(NULL, 'or', 'OR', 'English', 'common', 'en'),
(NULL, 'and', 'AND', 'English', 'common', 'en'),
(NULL, 'type_listing_title', 'Type the listing title...', 'English', 'admin', 'en'),
(NULL, 'order_number', 'Order Number', 'English', 'admin', 'en'),
(NULL, 'condition', 'Condition', 'English', 'admin', 'en'),
(NULL, 'add_transaction', 'Add transaction', 'English', 'admin', 'en'),
(NULL, 'add_new_transaction', 'Do you want to add new transaction?', 'English', 'admin', 'en'),
(NULL, 'and_then', 'and then', 'English', 'admin', 'en'),
(NULL, 'go_to_list', 'Go to list', 'English', 'admin', 'en'),
(NULL, 'add_another_one', 'Add another one', 'English', 'admin', 'en'),
(NULL, 'go_to_browse', 'Go to browse', 'English', 'admin', 'en'),
(NULL, 'go_to_browse_new_category', 'Go to browse new category', 'English', 'admin', 'en'),
(NULL, 'page_content_about', 'About Us page content', 'English', 'page', 'en'),
(NULL, 'page_content_policy', 'Privacy Policy page content', 'English', 'page', 'en'),
(NULL, 'page_content_terms', 'Terms Of Use page content', 'English', 'page', 'en'),
(NULL, 'page_content_help', 'Help page content', 'English', 'page', 'en'),
(NULL, 'page_content_advertise', 'Advertise Us page content', 'English', 'page', 'en'),
(NULL, 'file_format', 'File Format', 'English', 'admin', 'en'),
(NULL, 'csv_format', 'CSV format', 'English', 'admin', 'en'),
(NULL, 'sql_format', 'SQL format', 'English', 'admin', 'en'),
(NULL, 'newly_added_listings', 'Newly added listings', 'English', 'frontend', 'en'),
(NULL, 'most_popular_listings', 'Most popular listings', 'English', 'frontend', 'en'),
(NULL, 'rss_feed', 'RSS feed', 'English', 'frontend', 'en'),
(NULL, 'quick_search_listing_qtip', 'Please input listing URL, title, description, ID or account username', 'English', 'admin', 'en'),
(NULL, 'quick_search_category_qtip', 'Please input category title', 'English', 'admin', 'en'),
(NULL, 'installer_not_removed', 'Installer has not been removed. Please delete install/index.php file immediately!', 'English', 'admin', 'en'),
(NULL, 'config_writable', 'The includes/config.inc.php still has writable privileges. Please change config.inc.php permissions to non-writable.', 'English', 'admin', 'en'),
(NULL, 'esyndicat_action_add_favorite', 'Add Favorite', 'English', 'frontend', 'en'),
(NULL, 'esyndicat_action_remove_favorite', 'Remove Favorite', 'English', 'frontend', 'en'),
(NULL, 'esyndicat_action_report_listing', 'Report Listing', 'English', 'frontend', 'en'),
(NULL, 'esyndicat_action_visit_website', 'Visit Website', 'English', 'frontend', 'en'),
(NULL, 'doc_plugin_not_available', 'Documentation of plugin is not available.', 'English', 'admin', 'en'),
(NULL, 'plain_text_templates', 'Plain Text Templates', 'English', 'admin', 'en'),
(NULL, 'html_templates', 'HTML templates', 'English', 'admin', 'en'),
(NULL, 'nothing', 'Nothing', 'English', 'admin', 'en'),
(NULL, 'no_captcha_preview', 'No captcha preview', 'English', 'admin', 'en'),
(NULL, 'quick_jump_to', 'Quick Jump To', 'English', 'admin', 'en'),
(NULL, 'howdy', 'Howdy', 'English', 'admin', 'en'),
(NULL, 'iso_code', 'ISO - code', 'English', 'admin', 'en'),
(NULL, 'digit_only', 'digit only(1-255) default is 100', 'English', 'admin', 'en'),
(NULL, 'proportional', 'PROPORTIONAL', 'English', 'admin', 'en'),
(NULL, 'stretch', 'STRETCH', 'English', 'admin', 'en'),
(NULL, 'fit', 'FIT', 'English', 'admin', 'en'),
(NULL, 'proportional_tip', 'The mod will attempt to fit the image inside the "frame" create by the width and height arguments.', 'English', 'admin', 'en'),
(NULL, 'stretch_tip', 'The mod will stretch the image if necessary to fit into that "frame".', 'English', 'admin', 'en'),
(NULL, 'fit_tip', 'The will attempt to resize the image proportionally only if it does not fit inside the "frame" set by the provided width and height: if it does fit, the image will not be resized at all.', 'English', 'admin', 'en'),
(NULL, 'show_in_search_as', 'Show in search page as', 'English', 'admin', 'en'),
(NULL, 'checkboxes', 'Checkboxes Set', 'English', 'admin', 'en'),
(NULL, 'radios', 'Radios Set', 'English', 'admin', 'en'),
(NULL, 'dropdown', 'Dropdown List', 'English', 'admin', 'en'),
(NULL, 'title_for_any', 'Title for "any" meta option', 'English', 'admin', 'en'),
(NULL, 'mark_after_submit', 'Mark listing after submit as', 'English', 'admin', 'en'),
(NULL, 'send_expiration_email', 'Send email in [...] day(s) before expiration', 'English', 'admin', 'en'),
(NULL, 'assign_fields', 'Assign fields', 'English', 'admin', 'en'),
(NULL, 'xml_syndication', 'XML syndication', 'English', 'frontend', 'en'),
(NULL, 'enter_confirmation', 'Please enter confirmation code below', 'English', 'frontend', 'en'),
(NULL, 'unknown', 'Unknown', 'English', 'frontend', 'en'),
(NULL, 'upload_writable_permission', 'Please set writable permissions for uploads/ directory. chmod 777 uploads/', 'English', 'admin', 'en'),
(NULL, 'confirm_not_valid', 'Confirmations data is not valid. Please recheck the confirm link.', 'English', 'frontend', 'en'),
(NULL, 'keywords', 'Keywords', 'English', 'admin', 'en'),
(NULL, 'check_listing_fields', 'Please recheck your information.', 'English', 'frontend', 'en'),
(NULL, 'are_you_sure_to_delete_this_deep_link', 'Are you sure you want to delete this deep link?', 'English', 'admin', 'en'),
(NULL, 'collapsible', 'Collapsible', 'English', 'admin', 'en'),
(NULL, 'block_options', 'Block Options', 'English', 'admin', 'en'),
(NULL, 'block_contents', 'Block Contents', 'English', 'admin', 'en'),
(NULL, 'error_contents', 'Contents field is a required.', 'English', 'common', 'en'),
(NULL, 'error_title', 'Title field is required.', 'English', 'admin', 'en'),
(NULL, 'block_languages_empty', 'You need to choose language.', 'English', 'admin', 'en'),
(NULL, 'error_lang_title', 'Title {lang} field is a required.', 'English', 'admin', 'en'),
(NULL, 'error_lang_contents', 'Contents {lang} field is a required.', 'English', 'admin', 'en'),
(NULL, 'new', 'New', 'English', 'common', 'en'),
(NULL, 'hide_category', 'Hide category', 'English', 'admin', 'en'),
(NULL, 'go_to_config', 'Go to configuration page of {plugin}', 'English', 'admin', 'en'),
(NULL, 'go_to_manage', 'Go to manage page of {plugin}', 'English', 'admin', 'en'),
(NULL, 'upgrade_plugin', 'Run upgrade of the {plugin}', 'English', 'admin', 'en'),
(NULL, 'manage_templates', 'Manage Templates', 'English', 'admin', 'en'),
(NULL, 'screenshot', 'Screenshot', 'English', 'admin', 'en'),
(NULL, 'operation', 'Operation', 'English', 'admin', 'en'),
(NULL, 'details', 'Details', 'English', 'admin', 'en'),
(NULL, 'contributor', 'Contributor', 'English', 'admin', 'en'),
(NULL, 'release_date', 'Release Date', 'English', 'admin', 'en'),
(NULL, 'esyndicat_version', 'eSyndiCat version', 'English', 'admin', 'en'),
(NULL, 'template_empty', 'Template doesn''t exists.', 'English', 'admin', 'en'),
(NULL, 'template_folder_error', 'Template folder doesn''t exist.', 'English', 'admin', 'en'),
(NULL, 'template_xmlfile_error', 'The XML file of {template} doesn''t exist.', 'English', 'admin', 'en'),
(NULL, 'template_installed', 'The {template} template successfully installed.', 'English', 'admin', 'en'),
(NULL, 'date_registration ', 'Date Registration', 'English', 'frontend', 'en'),
(NULL, 'view_account_details', 'View account details', 'English', 'frontend', 'en'),
(NULL, 'no_accounts', 'There is no any accounts.', 'English', 'frontend', 'en'),
(NULL, 'no_account_listings', 'Account does not have any listings yet.', 'English', 'frontend', 'en'),
(NULL, 'page_title_accounts', 'Accounts', 'English', 'page', 'en'),
(NULL, 'rebuild_htaccess', 'Rebuild htaccess', 'English', 'admin', 'en'),
(NULL, 'notif_htaccess_permission', 'Please set the writable permission to rebuild the .htaccess file.', 'English', 'admin', 'en'),
(NULL, 'notification', 'Notification', 'English', 'admin', 'en'),
(NULL, 'notif_htaccess_rebuilt', 'The .htaccess file has been rebuilt.', 'English', 'admin', 'en'),
(NULL, 'submitted', 'Submitted', 'English', 'admin', 'en'),
(NULL, 'preview', 'Preview', 'English', 'admin', 'en'),
(NULL, 'page_title_account_login', 'Account Login', 'English', 'page', 'en'),
(NULL, 'page_title_account_register', 'Account Register', 'English', 'page', 'en'),
(NULL, 'page_title_edit_listing', 'Edit Listing', 'English', 'page', 'en'),
(NULL, 'page_title_account_logout', 'Account Logout', 'English', 'page', 'en'),
(NULL, 'page_title_thank', 'Thank', 'English', 'page', 'en'),
(NULL, 'page_title_account_password_forgot', 'Account Password Forgot', 'English', 'page', 'en'),
(NULL, 'page_title_error', 'Error', 'English', 'page', 'en'),
(NULL, 'page_title_accounts', 'Accounts', 'English', 'page', 'en'),
(NULL, 'page_title_view_listing', 'View Listing', 'English', 'page', 'en'),
(NULL, 'page_title_report_broken_listing', 'Report Broken Listing', 'English', 'page', 'en'),
(NULL, 'miscellaneous', 'Miscellaneous', 'English', 'admin', 'en'),
(NULL, 'category_url_will_be', 'Category URL will be', 'English', 'admin', 'en'),
(NULL, 'page_url_will_be', 'Page URL will be', 'English', 'admin', 'en'),
(NULL, 'max_num_images', 'Max number of images', 'English', 'admin', 'en'),
(NULL, 'no_more_files', 'You can not upload more files. Limit exceeded.', 'English', 'common', 'en'),
(NULL, 'category_locked_subcategories_alert', 'This category will be locked. Do you want to have subcategories locked also?', 'English', 'admin', 'en'),
(NULL, 'category_unlocked_subcategories_alert', 'This category will be unlocked. Do you want to have subcategories unlocked also?', 'English', 'admin', 'en'),
(NULL, 'hide', 'Hide', 'English', 'admin', 'en'),
(NULL, 'logo_image_not_found', 'Logo image cannot be found. Please reupload logo image.', 'English', 'admin', 'en'),
(NULL, 'page_title_index_browse', 'Browse Categories', 'English', 'page', 'en'),
(NULL, 'youre_in_preview_mode', 'You are in template preview mode.', 'English', 'frontend', 'en'),
(NULL, 'add_another_one_to_same', 'Add another in the same category', 'English', 'admin', 'en'),
(NULL, 'listing_expired', 'Expired', 'English', 'admin', 'en'),
(NULL, 'block_type_tip_plain', 'Plain type is used when you wish to display simple information. It will be displayed as is plus escaping HTML tags.', 'English', 'admin', 'en'),
(NULL, 'block_type_tip_html', 'HTML type is used for formatted HTML display. You can use WYSIWYG editor for your block content. This block can be also used for JavaScript code, but you <span style="color: red">need to paste it in SOURCE mode</span>.', 'English', 'admin', 'en'),
(NULL, 'block_type_tip_smarty', 'Smarty type block is used for smarty code. You can get more information about Smarty template engine here: <a href="http://www.smarty.net" target="_blank">http://www.smarty.net</a>', 'English', 'admin', 'en'),
(NULL, 'block_type_tip_php', 'PHP is used to have php code in your block content.', 'English', 'admin', 'en'),
(NULL, 'accounts', 'Enables accounts for your eSyndiCat Directory', 'English', 'tooltip', 'en'),
(NULL, 'accounts_autoapproval', 'Sends out confirmation emails and automatically approves accounts.', 'English', 'tooltip', 'en'),
(NULL, 'accounts_registered', 'Disabling this, reduces spam posts.', 'English', 'tooltip', 'en'),
(NULL, 'display_new_plugins', 'Notifies when a new plugin is available.', 'English', 'tooltip', 'en'),
(NULL, 'captcha', 'Activates Captcha', 'English', 'tooltip', 'en'),
(NULL, 'captcha_name', 'kcaptcha is default', 'English', 'tooltip', 'en'),
(NULL, 'captcha_preview', 'Displays what the image will look like.', 'English', 'tooltip', 'en'),
(NULL, 'captcha_case_sensitive', 'Default is enable; Exact entry is needed.', 'English', 'tooltip', 'en'),
(NULL, 'captcha_num_chars', 'Recommended to use 4 or 5 letters.', 'English', 'tooltip', 'en'),
(NULL, 'suggest_category', 'This displays the Submit Category link', 'English', 'tooltip', 'en'),
(NULL, 'use_html_path', 'This places all of the categories as /"yourcategory".html', 'English', 'tooltip', 'en'),
(NULL, 'related', 'Displays the Related Categories links at the bottom of the category used', 'English', 'tooltip', 'en'),
(NULL, 'neighbour', 'Displays Neighbor categories within the category chosen', 'English', 'tooltip', 'en'),
(NULL, 'show_children_listings', 'Shows listings in the categories within the main category', 'English', 'tooltip', 'en'),
(NULL, 'categories_order', 'Preferred sorting can be defined by Title or Order', 'English', 'tooltip', 'en'),
(NULL, 'categories_tree_type', 'Define as a Directory Tree like in 2.2 or Dropdown selection', 'English', 'tooltip', 'en'),
(NULL, 'num_categories_cols', 'Displays the number of columns for your categories', 'English', 'tooltip', 'en'),
(NULL, 'num_listings_display', 'Shows a listing display showing category and listing numbers', 'English', 'tooltip', 'en'),
(NULL, 'subcats_display', 'Displays the subcategories listings under the main category', 'English', 'tooltip', 'en'),
(NULL, 'cron_recip', 'Checks reciprocal status and disables the listing.', 'English', 'tooltip', 'en'),
(NULL, 'cron_broken', 'This updates listing status.', 'English', 'tooltip', 'en'),
(NULL, 'cron_pagerank', 'This will update the pagerank of sites.', 'English', 'tooltip', 'en'),
(NULL, 'cron_num_listings', 'Default is 10; Perfect for shared hosting accounts. VPS 25-35, Dedicated 100.', 'English', 'tooltip', 'en'),
(NULL, 'cron_check_interval', '1 is default; Recommended for large directories.', 'English', 'tooltip', 'en'),
(NULL, 'cron_report_job', 'Sends an email after cronjob is complete.', 'English', 'tooltip', 'en'),
(NULL, 'cron_report_job_extra', 'Includes the what listings were updated in the email.', 'English', 'tooltip', 'en'),
(NULL, 'cron_report_cycle', 'After all listings are checked, An email will notify you.', 'English', 'tooltip', 'en'),
(NULL, 'cron_report_cycle_extra', 'Listing will include all listings that were completed.', 'English', 'tooltip', 'en'),
(NULL, 'cron_backup', 'Enables a backup of your database.', 'English', 'tooltip', 'en'),
(NULL, 'cron_backup_archive', 'Enabled will backup the database into a zip file to conserve space.', 'English', 'tooltip', 'en'),
(NULL, 'cron_backup_interval', 'Default is 30 days, If your site is active, it is recommended to reduce the time.', 'English', 'tooltip', 'en'),
(NULL, 'currency_symbol', 'Default is $.', 'English', 'tooltip', 'en'),
(NULL, 'site', 'This will be your site''s name.', 'English', 'tooltip', 'en'),
(NULL, 'site_logo', 'Upload your logo here, keep the image size.', 'English', 'tooltip', 'en'),
(NULL, 'backup', 'Default is backup/  recommended that you do not alter.', 'English', 'tooltip', 'en'),
(NULL, 'admin', 'Default is admin/ recommended that you do not alter.', 'English', 'tooltip', 'en'),
(NULL, 'site_email', 'Email address you wish to get account changes and alerts sent to.', 'English', 'tooltip', 'en'),
(NULL, 'bugs_email', 'Email address you wish to be alerted if there is a problem.', 'English', 'tooltip', 'en'),
(NULL, 'lang', 'Select your preferred language of your site.', 'English', 'tooltip', 'en'),
(NULL, 'charset', 'Default is UTF-8.', 'English', 'tooltip', 'en'),
(NULL, 'date_format', 'Select your preferred date format %e is timezone,  %Y is 4-digit year.', 'English', 'tooltip', 'en'),
(NULL, 'suffix', 'This is the 2nd description for your Title bar.', 'English', 'tooltip', 'en'),
(NULL, 'title_breadcrumb', 'Produces breadcrumbs in Title.', 'English', 'tooltip', 'en'),
(NULL, 'language_switch', 'Allows users on the front of your site changed language.', 'English', 'tooltip', 'en'),
(NULL, 'mod_rewrite', 'Produces SEO friendly URLs.', 'English', 'tooltip', 'en'),
(NULL, 'caching', 'If you are using slow shared hosting, this will cache your pages for faster loading.', 'English', 'tooltip', 'en'),
(NULL, 'display_frontend', 'Enabling the Frontend displays your site as intended.', 'English', 'tooltip', 'en'),
(NULL, 'underconstruction', 'If Display Frontend is disabled.  The below message will be shown.', 'English', 'tooltip', 'en'),
(NULL, 'listing_check', 'Enabling this will check from broken listings.', 'English', 'tooltip', 'en'),
(NULL, 'reciprocal_check', 'Enable this for link checking; Cron configuration is required.', 'English', 'tooltip', 'en'),
(NULL, 'reciprocal_required_only_for_free', 'Enable this for gaining a link exchange function.', 'English', 'tooltip', 'en'),
(NULL, 'reciprocal_domain', 'Makes reciprocal domain name sensitive.', 'English', 'tooltip', 'en'),
(NULL, 'reciprocal_text', 'This is your preferred domain you want to promote.', 'English', 'tooltip', 'en'),
(NULL, 'recip_featured', 'Allows reciprocal listings to be featured.', 'English', 'tooltip', 'en'),
(NULL, 'reciprocal_label', 'This text can be edited to fit your needs.', 'English', 'tooltip', 'en'),
(NULL, 'reciprocal_code', 'This code is for the client to paste within his site for Reciprocal listing checks.', 'English', 'tooltip', 'en'),
(NULL, 'duplicate_checking', 'Enables Duplicate listing Check; Frequency is determined in Cron Configuration.', 'English', 'tooltip', 'en'),
(NULL, 'duplicate_type', 'Checks links based on the dropdown choice.', 'English', 'tooltip', 'en'),
(NULL, 'duplicate_visitors', 'Disables Link Checking', 'English', 'tooltip', 'en'),
(NULL, 'allow_listings_submission', 'Enables the Submit Listings button.', 'English', 'tooltip', 'en'),
(NULL, 'auto_approval', 'Automatic Submission approval; Note: Do not enable if you want to manually approve listings.', 'English', 'tooltip', 'en'),
(NULL, 'new_window', 'Opens a new window when directed to the listing.', 'English', 'tooltip', 'en'),
(NULL, 'forward_to_listing_details', 'Opens the on-site listing instead of being forwards to the actual site.', 'English', 'tooltip', 'en'),
(NULL, 'pagerank', 'Shows the pagerank on both the site details and truncated listings.', 'English', 'tooltip', 'en'),
(NULL, 'thumbshot', 'Displays a small screen capture of the listings website.', 'English', 'tooltip', 'en'),
(NULL, 'broken_listings_report', 'Enabling this will check the broken listings and send an email report.\r\n', 'English', 'tooltip', 'en'),
(NULL, 'description_num_chars', 'Limits description on Browse Categories, Popular Listings, and few other listings pages.', 'English', 'tooltip', 'en'),
(NULL, 'description_min_max_length', 'Min & max length values for the listing description field.', 'English', 'tooltip', 'en'),
(NULL, 'num_index_listings', 'Selecting how many listings you want displayed per page. Default is 10.', 'English', 'tooltip', 'en'),
(NULL, 'num_get_listings', 'Select the number of listings you want displayed on the Top, New and Popular listings pages.', 'English', 'tooltip', 'en'),
(NULL, 'num_featured_display', 'Displays the selected number of listings you want in the Featured box.', 'English', 'tooltip', 'en'),
(NULL, 'num_partner_display', 'Displays the selected number of listings you want in the Partners box.', 'English', 'tooltip', 'en'),
(NULL, 'visitor_sorting', 'Enabling this will allow users to view listings by alpha, rank, clicks or date.', 'English', 'tooltip', 'en'),
(NULL, 'listings_sorting', 'This will be the default setting for users to start viewing the listings.', 'English', 'tooltip', 'en'),
(NULL, 'listings_sorting_type', 'Ascending or Descending settings will determine by preference.', 'English', 'tooltip', 'en'),
(NULL, 'expiration_period', 'If a listing is not paid or subscription expires, the number of days before action below is taken.', 'English', 'tooltip', 'en'),
(NULL, 'expiration_action', 'When the days allowed above expire, this setting will determine what action is to be taken. Default is Nothing.', 'English', 'tooltip', 'en'),
(NULL, 'mail_function', 'The Mail Method to send emails.', 'English', 'tooltip', 'en'),
(NULL, 'mimetype', 'Determines whether you want to send text or html emails (templates located in the Email Template tab to the left).', 'English', 'tooltip', 'en'),
(NULL, 'sendmail_path', 'Default is /usr/bin/sendmail', 'English', 'tooltip', 'en'),
(NULL, 'smtp_server', 'That would be Ex. (smtp.yourdomain.com)', 'English', 'tooltip', 'en'),
(NULL, 'smtp_user', 'The username is specified with your email/hosting provider.', 'English', 'tooltip', 'en'),
(NULL, 'smtp_password', 'Password for the username above.', 'English', 'tooltip', 'en'),
(NULL, 'resend_confirmation_email', 'Resend confirmation email', 'English', 'admin', 'en'),
(NULL, 'confirmation_resent', 'Confirmation email resent.', 'English', 'admin', 'en'),
(NULL, 'categories_display_type', 'Defines categories display type.<br />\r\nExample:<br />\r\n<pre>Horizontal:\r\na b c d\r\ne f g h\r\nVertical:\r\na c e g \r\nb d f h</pre>', 'English', 'tooltip', 'en'),
(NULL, 'item', 'Item', 'English', 'admin', 'en'),
(NULL, 'categories_icon_notif', 'Create and upload images to "uploads/category-icons" folder to be able choose your own category icons.', 'English', 'admin', 'en'),
(NULL, 'remove_reason', 'Remove reason', 'English', 'admin', 'en'),
(NULL, 'view_image', 'View Image', 'English', 'admin', 'en'),
(NULL, 'image_not_found', 'Image not found', 'English', 'admin', 'en'),
(NULL, 'uploading_image', 'Uploading Image', 'English', 'admin', 'en'),
(NULL, 'select_image', 'Select Image', 'English', 'admin', 'en'),
(NULL, 'image', 'Image', 'English', 'admin', 'en'),
(NULL, 'upload_image_error', 'Upload Image Error', 'English', 'admin', 'en'),
(NULL, 'collapsed', 'Collapsed', 'English', 'admin', 'en'),
(NULL, 'cannot_create_folder', 'Can\'t create folders for sitemap files.', 'English', 'admin', 'en'),
(NULL, 'not_writable_folder', 'Sitemap file\'s folder non writable.', 'English', 'admin', 'en'),
(NULL, 'create_gy_sitemap', 'Create Google Yahoo sitemap.', 'English', 'admin', 'en'),
(NULL, 'total_items', 'total items', 'English', 'admin', 'en'),
(NULL, 'start_from', 'start from', 'English', 'admin', 'en'),
(NULL, 'processing', 'Processing.', 'English', 'admin', 'en'),
(NULL, 'finished', 'Finished.', 'English', 'admin', 'en'),
(NULL, 'progress', 'Progress.', 'English', 'admin', 'en'),
(NULL, 'start', 'Start.', 'English', 'admin', 'en'),
(NULL, 'instead_thumbnail', 'Instead of thumbnail', 'English', 'admin', 'en'),
(NULL, 'twitter_news', 'Twitter News', 'English', 'admin', 'en'),
(NULL, 'unbroken', 'Unbroken', 'English', 'admin', 'en'),
(NULL, 'more', 'more...', 'English', 'frontend', 'en'),
(NULL, 'categories_found', 'Categories found: ', 'English', 'frontend', 'en'),
(NULL, 'username_banned', 'Your account has been banned by administrator.', 'English', 'frontend', 'en'),
(NULL, 'last_visited', 'Last Visited', 'English', 'common', 'en'),
(NULL, 'item_selected', 'item selected', 'English', 'admin', 'en'),
(NULL, 'items_selected', 'items selected', 'English', 'admin', 'en'),
(NULL, 'set_as_default', 'Set As Default', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_set_as_default_selected_icons', 'Are you sure to set selected image as default icon for all categories?', 'English', 'admin', 'en'),
(NULL, 'image_set_as_default_icon_categories', 'image set as default icon for categories.', 'English', 'admin', 'en'),
(NULL, 'instructions_restore_password_sent', 'Email with instructions to restore password has been sent.', 'English', 'frontend', 'en'),
(NULL, 'instructions_change_email_sent', 'Email with instructions to change email has been sent.', 'English', 'frontend', 'en'),
(NULL, 'change_email', 'Change Email', 'English', 'frontend', 'en'),
(NULL, 'confirm_email', 'Confirm Email', 'English', 'frontend', 'en'),
(NULL, 'account_successful_change_email', 'You have successfully change your account email.', 'English', 'frontend', 'en'),
(NULL, 'hook_editor', 'Hook Editor', 'English', 'admin', 'en'),
(NULL, 'field_meta_description', 'Meta Description', 'English', 'common', 'en'),
(NULL, 'field_meta_keywords', 'Meta Keywords', 'English', 'common', 'en'),
(NULL, 'hook_editor_alert', 'Please be very careful when editing hooks. It can be easily broken plugins functionality.', 'English', 'admin', 'en'),
(NULL, 'never', 'never', 'English', 'admin', 'en'),
(NULL, 'error_deep_link_not_similar', 'The domain of deep link ( {url} ) is not similar as listing URL.', 'English', 'frontend', 'en'),
(NULL, 'image_removed', 'Image has been removed.', 'English', 'admin', 'en'),
(NULL, 'hide_category_option', 'This option allows to hide category in the list though it will be still accessible via direct link.', 'English', 'admin', 'en'),
(NULL, 'submit_feedback', 'Submit Feedback to eSyndiCat Team', 'English', 'admin', 'en'),
(NULL, 'feedback_terms', 'If you have any ideas how to improve our software, found a bug or want to request custom modification you are welcome to use this feedback form. We will log all your requests in our database. We will prepare terms of contacting and violators will be banned.', 'English', 'admin', 'en'),
(NULL, 'bug_report', 'Bug Report', 'English', 'admin', 'en'),
(NULL, 'feature_request', 'New Feature Request', 'English', 'admin', 'en'),
(NULL, 'custom_quote', 'Custom Modification', 'English', 'admin', 'en'),
(NULL, 'message_body', 'Message Body', 'English', 'admin', 'en'),
(NULL, 'send_confirm', 'Are you sure you wish to send this feedback to eSyndiCat Team?', 'English', 'admin', 'en'),
(NULL, 'request_submitted', 'Thanks. Your request has been submitted.', 'English', 'admin', 'en'),
(NULL, 'check_listing', 'check listing...', 'English', 'common', 'en'),
(NULL, 'comments', 'Comments', 'English', 'common', 'en'),
(NULL, 'comment_author', 'Comment Author', 'English', 'common', 'en'),
(NULL, 'author_email', 'Author Email', 'English', 'common', 'en'),
(NULL, 'author_url', 'Author URL', 'English', 'common', 'en'),
(NULL, 'leave_comment', 'Leave Comment', 'English', 'common', 'en'),
(NULL, 'all_comments', 'All Comments', 'English', 'admin', 'en'),
(NULL, 'comment', 'Comment', 'English', 'common', 'en'),
(NULL, 'no_comments', 'No Comments.', 'English', 'common', 'en'),
(NULL, 'comment_added', 'Comment added.', 'English', 'common', 'en'),
(NULL, 'comment_waits_approve', 'Your comment should be approved by administrator.', 'English', 'common', 'en'),
(NULL, 'manage_comments', 'Manage Comments', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_selected_comments', 'Are you sure you want to delete selected comments?', 'English', 'admin', 'en'),
(NULL, 'are_you_sure_to_delete_this_comment', 'Are you sure you want to delete this comment?', 'English', 'admin', 'en'),
(NULL, 'edit_comment', 'Edit comment', 'English', 'admin', 'en'),
(NULL, 'error_comment', 'Make sure you entered valid comment.', 'English', 'frontend', 'en'),
(NULL, 'error_comment_author', 'Make sure you entered valid comment author.', 'English', 'frontend', 'en'),
(NULL, 'error_comment_email', 'Make sure you entered valid author email.', 'English', 'frontend', 'en'),
(NULL, 'error_max_comment', 'Your comment length should be less than {maxLength} symbols.', 'English', 'frontend', 'en'),
(NULL, 'error_min_comment', 'Your comment length should be more than {minLength} symbols.', 'English', 'frontend', 'en'),
(NULL, 'error_comment_logged', 'You should be logged in to comment listings.', 'English', 'frontend', 'en'),
(NULL, 'listing_comments_submission_disabled', 'Listing comments submission is disabled by adminstrator.', 'English', 'frontend', 'en'),
(NULL, 'comment_rate_this', 'Rate this', 'English', 'frontend', 'en'),
(NULL, 'rating', 'Rating', 'English', 'frontend', 'en'),
(NULL, 'not_set', 'not set', 'English', 'frontend', 'en'),
(NULL, 'vote_cast', 'Vote cast', 'English', 'frontend', 'en'),
(NULL, 'votes_cast', 'Votes cast', 'English', 'frontend', 'en'),
(NULL, 'thanks_for_voting', 'Thanks for voting', 'English', 'frontend', 'en'),
(NULL, 'visual_mode', 'Visual Mode', 'English', 'admin', 'en'),
(NULL, 'calendar', 'Calendar', 'English', 'frontend', 'en');

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}listing_categories`;
CREATE TABLE `{install:prefix}listing_categories` (
  `listing_id` int(8) NOT NULL default '0',
  `category_id` int(8) NOT NULL default '0',
  KEY `listing_id` (`listing_id`,`category_id`)
) {install:mysql_version};

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}listing_clicks`;
CREATE TABLE `{install:prefix}listing_clicks` (
  `id` int(8) NOT NULL auto_increment,
  `listing_id` int(8) NOT NULL default '0',
  `ip` varchar(16) NOT NULL default '',
  `date` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`id`),
  KEY `listing_id` (`listing_id`),
  KEY `ip` (`ip`,`date`)
) {install:mysql_version};

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}listing_fields`;
CREATE TABLE `{install:prefix}listing_fields` (
  `id` int(4) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `type` enum('text','textarea','combo','radio','checkbox','storage','image','number','pictures') NOT NULL default 'text',
  `length` varchar(255) NOT NULL default '',
  `values` text,
  `default` varchar(255) NOT NULL default '',
  `order` double NOT NULL default '0',
  `tooltip` text NOT NULL default '',
  `editor` enum('0','1') NOT NULL default '0',
  `required` enum('1','0') NOT NULL default '0',
  `adminonly` enum('0','1') NOT NULL default '0',
  `pages` set('suggest','edit','view') NOT NULL default '',
  `image_height` int(4) NOT NULL default '0',
  `image_width` int(4) NOT NULL default '0',
  `thumb_width` int(4) NOT NULL default '0',
  `thumb_height` int(4) NOT NULL default '0',
  `resize_mode` int(4) NOT NULL default '1001',
  `file_prefix` varchar(50) NOT NULL default '',
  `searchable` tinyint(1) NOT NULL default '0',
  `file_types` text,
  `section_key` varchar(30) NOT NULL default '',
  `show_as` enum('checkbox','radio','combo') NOT NULL default 'checkbox',
  `any_meta` varchar(50) NOT NULL default '',
  `recursive` tinyint(1) NOT NULL default '0',
  `instead_thumbnail` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) {install:mysql_version};

INSERT INTO `{install:prefix}listing_fields` (`id`, `name`, `type`, `length`, `values`, `default`, `order`, `required`, `adminonly`, `pages`, `thumb_width`,  `thumb_height`, `image_height`, `image_width`, `file_prefix`, `searchable`, `file_types`, `section_key`, `show_as`, `any_meta`, `recursive`) VALUES
(1, 'url', 'text', '150', '', 'http://', 2, '1', '0', 'suggest,edit,view', 0, 0, 0, 0, '', 0, '', '', 'checkbox', '', 1),
(2, 'title', 'text', '200', '', '', 1, '0', '0', 'suggest,edit,view', 0, 0, 0, 0, '', 1, '', '', 'checkbox', '', 1),
(3, 'description', 'textarea', '50,500', '', '', 3, '0', '0', 'suggest,edit,view', 0, 0, 0, 0, '', 1, '', '', 'checkbox', '', 1),
(4, 'email', 'text', '100', '', '', 5, '1', '0', 'suggest,edit', 0, 0, 0, 0, '', 0, '', '', 'checkbox', '', 1),
(5, 'reciprocal', 'text', '100', '', 'http://', 4, '0', '0', 'suggest,edit', 0, 0, 0, 0, '', 0, '', '', 'checkbox', '', 1),
(6, 'meta_description', 'textarea', '0,150', '', '', 6, '0', '1', '', 0, 0, 0, 0, '', 0, '', '', 'checkbox', '', 1),
(7, 'meta_keywords', 'textarea', '0,256', '', '', 7, '0', '1', '', 0, 0, 0, 0, '', 0, '', '', 'checkbox', '', 1);

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}listings`;
CREATE TABLE `{install:prefix}listings` (
  `id` int(8) unsigned NOT NULL auto_increment,
  `account_id` int(8) NOT NULL default '0',
  `category_id` int(11) NOT NULL default '0',
  `transaction_id` int(11) NOT NULL default '0',
  `moved_from` int(8) NOT NULL default '-1',
  `domain` varchar(150) NOT NULL default '',
  `url` varchar(100) NOT NULL default '',
  `description` text NOT NULL,
  `email` varchar(100) NOT NULL default '',
  `reciprocal` varchar(100) NOT NULL default '',
  `recip_valid` enum('0','1') NOT NULL default '0',
  `ip_address` varchar(15) NOT NULL default '',
  `listing_header` int(4) NOT NULL default '0',
  `status` enum('approval','banned','active') NOT NULL default 'approval',
  `pagerank` tinyint(2) NOT NULL default '-1',
  `rank` tinyint(3) NOT NULL DEFAULT '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `clicks` int(10) unsigned NOT NULL default '0',
  `partner` enum('0','1') NOT NULL default '0',
  `partner_start` datetime NOT NULL default '0000-00-00 00:00:00',
  `featured` enum('0','1') NOT NULL default '0',
  `featured_start` datetime NOT NULL default '0000-00-00 00:00:00',
  `title` varchar(200) NOT NULL default '',
  `expire` int(4) NOT NULL default '0',
  `action_expire` varchar(20) NOT NULL default '',
  `last_check_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `cron_cycle` enum('0','1') NOT NULL default '0',
  `fav_accounts_set` text NOT NULL,
  `meta_description` text NOT NULL,
  `meta_keywords` text NOT NULL,
  `num_votes` int(11) NOT NULL default '0',
  `rating` float NOT NULL default '0',
  `min_rating` int(11) NOT NULL default '0',
  `max_rating` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `category_id` (`category_id`),
  KEY `date` (`date`),
  KEY `recip_valid` (`recip_valid`),
  KEY `listing_header` (`listing_header`),
  KEY `status` (`status`),
  KEY `featured` (`featured`),
  KEY `partner` (`partner`),
  FULLTEXT KEY `url` (`url`,`description`)
) {install:mysql_version};


INSERT INTO `{install:prefix}listings` (`account_id`, `category_id`, `moved_from`, `domain`, `url`, `description`, `email`, `listing_header`, `status`, `pagerank`, `date`, `title`, `featured`, `featured_start`) VALUES
(0, 0, -1, 'www.esyndicat.com', 'http://www.esyndicat.com', 'eSyndiCat is a full featured software that can be used as an addition to your existing site or as a stand-alone platform. Using eSyndiCat Directory Software your website can achieve top rank and take the leading positions in the most popular search engines! You can choose both free and paid versions.', 'no-reply@esyndicat.com', 200, 'active', 5, NOW(), 'eSyndicat Directory Script', '1', NOW());

INSERT INTO `{install:prefix}listings` (`account_id`, `category_id`, `moved_from`, `domain`, `url`, `description`, `email`, `listing_header`, `status`, `pagerank`, `date`, `title`, `featured`, `featured_start`) VALUES
(0, 14, -1, 'www.subrion.com', 'http://www.subrion.com', 'Subrion CMS unites the functionality of articles script, auto classifieds script, realty classifieds script, and web directory script all in one package. Subrion''s highly scalable set of key features makes it a powerful platform for web sites.', 'no-reply@subrion.com', 200, 'active', 5, NOW(), 'Subrion CMS', '1', NOW());

INSERT INTO `{install:prefix}listings` (`account_id`, `category_id`, `moved_from`, `domain`, `url`, `description`, `email`, `listing_header`, `status`, `pagerank`, `date`, `title`, `partner`, `partner_start`) VALUES
(0, 14, -1, 'www.subrion.com', 'http://www.subrion.com/product/autos.html', 'Subrion Auto Classifieds Script is the best choice for your online auto sales business. Number of advanced features, easy customization, and powerful administration panel makes this classifieds software perfectly suitable for auto classifieds portal or for auto auction website. SEO friendly, written in PHP with MySQL it doesn\'t need any specific knowledge to operate.', 'no-reply@subrion.com', 200, 'active', 5, NOW(), 'Subrion Auto Classified', '1', NOW());

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}pages`;
CREATE TABLE `{install:prefix}pages` (
  `id` int(8) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `menus` set('main','bottom','account','inventory') NOT NULL DEFAULT 'main',
  `status` enum('inactive','active','draft') NOT NULL default 'inactive',
  `last_updated` datetime NOT NULL default '0000-00-00 00:00:00',
  `plugin` varchar(50) NOT NULL DEFAULT '',
  `order` float NOT NULL default '0',
  `unique_url` varchar(150) NOT NULL,
  `non_modrewrite_url` VARCHAR( 150 ) NOT NULL,
  `custom_url` varchar(255) NOT NULL default '',
  `meta_description` tinytext,
  `meta_keywords` tinytext,
  `nofollow` enum('1','0') NOT NULL default '0',
  `readonly` enum('0','1') NOT NULL default '0',
  `group` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) {install:mysql_version};

INSERT INTO `{install:prefix}pages` VALUES 
(NULL, 'index', 'main,inventory', 'active', NOW(), '', 1, 'index.php', 'index.php', '', '', '', '0', '0', 'miscellaneous'),
(NULL, 'index_browse', '', 'active', NOW(), '', '0', '', '', '', '', '', '0', '0', 'miscellaneous'),
(NULL, 'search', 'main,inventory', 'active', NOW(), '', 2, 'search.php', 'search.php', '', '', '', '0', '0', 'listings'),
(NULL, 'new_listings', 'main', 'active', NOW(), '', 3, 'new-listings.html', 'listings.php?view=new', '', '', '', '0', '0', 'listings'),
(NULL, 'top_listings', 'main', 'active', NOW(), '', 4, 'top-listings.html', 'listings.php?view=top', '', '', '', '0', '0', 'listings'),
(NULL, 'popular_listings', 'main', 'active', NOW(), '', 5, 'popular-listings.html', 'listings.php?view=popular', '', '', '', '0', '0', 'listings'),
(NULL, 'random_listings', 'main', 'active', NOW(), '', 6, 'random-listings.html', 'listings.php?view=random', '', '', '', '0', '0', 'listings'),
(NULL, 'suggest_listing', 'main,inventory', 'active', NOW(), '', 7, 'suggest-listing.php?id={idcat}', 'suggest-listing.php?id={idcat}', '', '', '', '1', '0', 'listings'),
(NULL, 'suggest_category', 'main', 'active', NOW(), '', 8, 'suggest-category.php?id={idcat}', 'suggest-category.php?id={idcat}', '', '', '', '1', '0', 'miscellaneous'),
(NULL, 'account_listings', 'account', 'active', NOW(), '', 9, 'account-listings.html', 'listings.php?view=account', '', '', '', '0', '0', 'listings'),
(NULL, 'favorites_listings', 'account', 'active', NOW(), '', 10, 'favorites-listings.html', 'listings.php?view=favorites', '', '', '', '0', '0', 'listings'),
(NULL, 'edit_account', 'account', 'active', NOW(), '', 11, 'edit-account.php', 'edit-account.php', '', '', '', '1', '0', 'accounts'),
(NULL, 'accounts', 'main', 'active', NOW(), '', 1.1, 'accounts/', 'accounts.php', '', '', '', '0', '0', 'accounts'),
(NULL, 'account_login', '', 'active', NOW(), '', 0, '', '', '', '', '', '0', '1', 'accounts'),
(NULL, 'account_logout', '', 'active', NOW(), '', 0, '', '', '', '', '', '0', '1', 'accounts'),
(NULL, 'account_register', '', 'active', NOW(), '', 0, '', '', '', '', '', '0', '0', 'accounts'),
(NULL, 'thank', '', 'active', NOW(), '', 0, '', '', '', '', '', '0', '1', 'listings'),
(NULL, 'view_listing', '', 'active', NOW(), '', 0, '', '', '', '', '', '0', '1', 'listings'),
(NULL, 'edit_listing', '', 'active', NOW(), '', 0, '', '', '', '', '', '0', '1', 'listings'),
(NULL, 'account_password_forgot', '', 'active', NOW(), '', 0, '', '', '', '', '', '0', '1', 'accounts'),
(NULL, 'error', '', 'active', NOW(), '', 0, '', '', '', '', '', '0', '1', 'pages'),
(NULL, 'confirm', '', 'active', NOW(), '', 0, '', '', '', '', '', '0', '1', 'pages');

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}plugins`;
CREATE TABLE `{install:prefix}plugins` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `author` varchar(75) NOT NULL default '',
  `contributor` varchar(75) NOT NULL default '',
  `title` varchar(150) NOT NULL default '',
  `status` enum('inactive','active','incomplete') NOT NULL default 'active',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `version` varchar(15) NOT NULL default '',
  `summary` text NOT NULL,
  `htaccess` text,
  `uninstall_code` text,
  `uninstall_sql` text,
  PRIMARY KEY  (`id`)
) {install:mysql_version};

INSERT INTO `{install:prefix}plugins` (`id`, `name`, `author`, `contributor`, `title`, `status`, `version`, `summary`, `htaccess`, `uninstall_code`, `uninstall_sql`) VALUES
(NULL, 'kcaptcha', 'Sergey Ten', 'Intelliants LLC', 'KCaptcha', 'active', '1.0', 'Plugin will add the CAPTCHA to all pages where it needs.', '', 'global $esynConfig;\n\n				$current_value = $esynConfig->getConfig(''captcha_name'');\n\n				$esynConfig->setTable(''config'');\n				$current_values = $esynConfig->one("`multiple_values`", "`name` = ''captcha_name''");\n				$esynConfig->resetTable();\n\n				$values = explode('','', $current_values);\n\n				if(!empty($values))\n				{\n					foreach($values as $key => $value)\n					{\n						if(''kcaptcha'' == $value)\n						{\n							unset($values[$key]);\n						}\n					}\n				}\n\n				$updated_values = join('','', $values);\n\n				$esynConfig->setTable(''config'');\n				$esynConfig->update(array(''multiple_values'' => $updated_values), "`name` = ''captcha_name''");\n				$esynConfig->resetTable();', ''),
(NULL, 'comments', 'Sergey Ten', 'Intelliants LLC', 'Comments', 'active', '2.0', 'The plugin allows visitors adding comments to listings.', NULL, NULL, 'a:3:{i:0;a:2:{s:5:"query";s:30:"DROP TABLE `{prefix}comments`;";s:8:"external";b:0;}i:1;a:2:{s:5:"query";s:27:"DROP TABLE `{prefix}votes`;";s:8:"external";b:0;}i:2;a:2:{s:5:"query";s:101:"ALTER TABLE `{prefix}listings` DROP `num_votes`, DROP `rating`, DROP `min_rating`, DROP `max_rating`;";s:8:"external";b:0;}}');
{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}related`;
CREATE TABLE `{install:prefix}related` (
  `id` int(8) NOT NULL auto_increment,
  `category_id` int(8) NOT NULL default '0',
  `related_id` int(8) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `category_id` (`category_id`),
  KEY `related_id` (`related_id`)
) {install:mysql_version};

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}tab_pages`;
CREATE TABLE IF NOT EXISTS `{install:prefix}tab_pages` (
  `id` int(11) NOT NULL auto_increment,
  `tab_name` varchar(255) NOT NULL default '',
  `page_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) {install:mysql_version};

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}tabs`;
CREATE TABLE IF NOT EXISTS `{install:prefix}tabs` (
  `name` varchar(255) NOT NULL default '',
  `sticky` enum('1','0') NOT NULL default '1',
  `order` float NOT NULL default '0',
  PRIMARY KEY  (`name`)
) {install:mysql_version};

INSERT INTO `{install:prefix}tabs` VALUES
('help', '1', 1),
('search', '1', 2);

{install:drop_tables}DROP TABLE IF EXISTS `{install:prefix}votes`;
CREATE TABLE `{install:prefix}votes` (
	`listing_id` int(8) NOT NULL default '0',
	`vote_value` tinyint(4) NOT NULL default '0',
	`ip_address` varchar(15) NOT NULL,
	`date` datetime NOT NULL default '0000-00-00 00:00:00',
	KEY `ip_address` (`ip_address`),
	KEY `listing_id` (`listing_id`)
) {install:mysql_version};
